type token =
  | TUnknown of (Ast_c.info)
  | TCommentSpace of (Ast_c.info)
  | TCommentNewline of (Ast_c.info)
  | TComment of (Ast_c.info)
  | TInt of ((string * (Ast_c.sign * Ast_c.base)) * Ast_c.info)
  | TFloat of ((string * Ast_c.floatType) * Ast_c.info)
  | TChar of ((string * Ast_c.isWchar) * Ast_c.info)
  | TString of ((string * Ast_c.isWchar) * Ast_c.info)
  | TQuote of ((string * Ast_c.isWchar) * Ast_c.info)
  | TPct of (Ast_c.info)
  | TFormat of (string * Ast_c.info)
  | TSubString of (string * Ast_c.info)
  | TDecimal of ((string * string (*n*) * string (*p*)) * Ast_c.info)
  | TIdent of (string * Ast_c.info)
  | TKRParam of (string * Ast_c.info)
  | Tconstructorname of (string * Ast_c.info)
  | TypedefIdent of (string * Ast_c.info)
  | TOPar of (Ast_c.info)
  | TCPar of (Ast_c.info)
  | TOBrace of (Ast_c.info)
  | TCBrace of (Ast_c.info)
  | TOCro of (Ast_c.info)
  | TCCro of (Ast_c.info)
  | TDot of (Ast_c.info)
  | TComma of (Ast_c.info)
  | TPtrOp of (Ast_c.info)
  | TInc of (Ast_c.info)
  | TDec of (Ast_c.info)
  | TAssign of (Ast_c.assignOp)
  | TEq of (Ast_c.info)
  | TWhy of (Ast_c.info)
  | TTilde of (Ast_c.info)
  | TBang of (Ast_c.info)
  | TEllipsis of (Ast_c.info)
  | TDotDot of (Ast_c.info)
  | TPtVirg of (Ast_c.info)
  | TOrLog of (Ast_c.info)
  | TAndLog of (Ast_c.info)
  | TOr of (Ast_c.info)
  | TXor of (Ast_c.info)
  | TAnd of (Ast_c.info)
  | TEqEq of (Ast_c.info)
  | TNotEq of (Ast_c.info)
  | TInf of (Ast_c.info)
  | TSup of (Ast_c.info)
  | TInfEq of (Ast_c.info)
  | TSupEq of (Ast_c.info)
  | TShl of (Ast_c.info)
  | TShr of (Ast_c.info)
  | TPlus of (Ast_c.info)
  | TMinus of (Ast_c.info)
  | TMul of (Ast_c.info)
  | TDiv of (Ast_c.info)
  | TMod of (Ast_c.info)
  | TMax of (Ast_c.info)
  | TMin of (Ast_c.info)
  | Tchar of (Ast_c.info)
  | Tshort of (Ast_c.info)
  | Tint of (Ast_c.info)
  | Tdouble of (Ast_c.info)
  | Tfloat of (Ast_c.info)
  | Tcomplex of (Ast_c.info)
  | Tlong of (Ast_c.info)
  | Tunsigned of (Ast_c.info)
  | Tsigned of (Ast_c.info)
  | Tvoid of (Ast_c.info)
  | Tsize_t of (Ast_c.info)
  | Tssize_t of (Ast_c.info)
  | Tptrdiff_t of (Ast_c.info)
  | TautoType of (Ast_c.info)
  | Tauto of (Ast_c.info)
  | Tregister of (Ast_c.info)
  | Textern of (Ast_c.info)
  | Tstatic of (Ast_c.info)
  | Ttypedef of (Ast_c.info)
  | Tconst of (Ast_c.info)
  | Tvolatile of (Ast_c.info)
  | Tstruct of (Ast_c.info)
  | Tunion of (Ast_c.info)
  | Tenum of (Ast_c.info)
  | Tdecimal of (Ast_c.info)
  | Texec of (Ast_c.info)
  | Tbreak of (Ast_c.info)
  | Telse of (Ast_c.info)
  | Tswitch of (Ast_c.info)
  | Tcase of (Ast_c.info)
  | Tcontinue of (Ast_c.info)
  | Tfor of (Ast_c.info)
  | Tdo of (Ast_c.info)
  | Tif of (Ast_c.info)
  | Twhile of (Ast_c.info)
  | Treturn of (Ast_c.info)
  | Tgoto of (Ast_c.info)
  | Tdefault of (Ast_c.info)
  | Tsizeof of (Ast_c.info)
  | Tnew of (Ast_c.info)
  | Tdelete of (Ast_c.info)
  | Tdefined of (Ast_c.info)
  | TOParCplusplusInit of (Ast_c.info)
  | Tnamespace of (Ast_c.info)
  | Trestrict of (Ast_c.info)
  | Tasm of (Ast_c.info)
  | Tattribute of (Ast_c.info)
  | TattributeNoarg of (Ast_c.info)
  | Tinline of (Ast_c.info)
  | Ttypeof of (Ast_c.info)
  | TDefine of (Ast_c.info)
  | TDefParamVariadic of ((string * Ast_c.info))
  | TCppEscapedNewline of (Ast_c.info)
  | TCppConcatOp of (Ast_c.info)
  | TOParDefine of (Ast_c.info)
  | TOBraceDefineInit of (Ast_c.info)
  | TIdentDefine of ((string * Ast_c.info))
  | TDefEOL of (Ast_c.info)
  | TInclude of ((string * string * bool ref * Ast_c.info))
  | TIncludeStart of ((Ast_c.info * bool ref))
  | TIncludeFilename of ((string * Ast_c.info))
  | TIfdef of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelif of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelse of (((int * int) option ref * Ast_c.info))
  | TEndif of (((int * int) option ref * Ast_c.info))
  | TIfdefBool of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefMisc of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefVersion of ((bool * (int * int) option ref * Ast_c.info))
  | TUifdef of (Ast_c.info)
  | TUelseif of (Ast_c.info)
  | TUendif of (Ast_c.info)
  | TUndef of (Ast_c.info)
  | TPrePragma of (Ast_c.info*Ast_c.info*string*Ast_c.info*Ast_c.info*(string*Ast_c.info)list)
  | TPragma of (Ast_c.info)
  | TPragmaString of (string * Ast_c.info)
  | TCppDirectiveOther of (Ast_c.info)
  | TMacroAttr of ((string * Ast_c.info))
  | TMacroEndAttr of ((string * Ast_c.info))
  | TMacroStmt of ((string * Ast_c.info))
  | TMacroIdStmt of ((string * Ast_c.info))
  | TMacroIdentBuilder of ((string * Ast_c.info))
  | TMacroString of ((string * Ast_c.info))
  | TMacroDecl of ((string * Ast_c.info))
  | TMacroDeclConst of (Ast_c.info)
  | TMacroIterator of ((string * Ast_c.info))
  | TCommentSkipTagStart of (Ast_c.info)
  | TCommentSkipTagEnd of (Ast_c.info)
  | TCParEOL of (Ast_c.info)
  | TAction of (Ast_c.info)
  | TCommentMisc of (Ast_c.info)
  | TCommentCpp of ((Token_c.cppcommentkind * Ast_c.info))
  | EOF of (Ast_c.info)
  | TTODO of (Ast_c.info)

open Parsing;;
let _ = parse_error;;
# 2 "parsing_c/parser_c.mly"
(* Yoann Padioleau
 *
 * Copyright (C) 2002, 2006, 2007, 2008, 2009 Yoann Padioleau
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License (GPL)
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * file license.txt for more details.
 *)

(**
 * This grammar has been inspired by:
 * http://www.lysator.liu.se/c/ANSI-C-grammar-y.html
 *)

open Common

open Ast_c

module LP = Lexer_parser
open Lexer_parser (* for the fields *)

open Semantic_c (* Semantic exn *)
module T = Token_c

(*****************************************************************************)
(* Wrappers *)
(*****************************************************************************)
let warning s v =
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ s) v
  else v

let computed_warning s v = (*do not construct string unless it will be shown*)
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ (s())) v
  else v

let pr2, pr2_once = Common.mk_pr2_wrappers Flag_parsing_c.verbose_parsing

(*****************************************************************************)
(* Parse helpers functions *)
(*****************************************************************************)

(*-------------------------------------------------------------------------- *)
(* Type related *)
(*-------------------------------------------------------------------------- *)

type shortLong      = Short  | Long | LongLong

type decl = {
  storageD: storagebis wrap;
  typeD: ((sign option) * (shortLong option) * (typeCbis option)) wrap;
  qualifD: typeQualifierbis wrap;
  inlineD: bool             wrap;
  (* note: have a full_info: parse_info list; to remember ordering
   * between storage, qualifier, type ? well this info is already in
   * the Ast_c.info, just have to sort them to get good order *)
}

let nullDecl = {
  storageD = NoSto, [];
  typeD = (None, None, None), [];
  qualifD = nullQualif;
  inlineD = false, [];
}
let fake_pi = Common.fake_parse_info

let addStorageD  = function
  | ((x,ii), ({storageD = (NoSto,[])} as v)) -> { v with storageD = (x, [ii]) }
  | ((x,ii), ({storageD = (y, ii2)} as v)) ->
      if x = y then warning "duplicate storage classes" v
      else warning "multiple storage classes, keeping the second" v

let addInlineD  = function
  | ((true,ii), ({inlineD = (false,[])} as v)) -> { v with inlineD=(true,[ii])}
  | ((true,ii), ({inlineD = (true, ii2)} as v)) -> warning "duplicate inline" v
  | _ -> raise (Impossible 86)


let addTypeD     = function
  | ((Left3 Signed,ii)   ,({typeD = ((Some Signed,  b,c),ii2)} as v)) ->
      warning "duplicate 'signed'"   v
  | ((Left3 UnSigned,ii) ,({typeD = ((Some UnSigned,b,c),ii2)} as v)) ->
      warning "duplicate 'unsigned'" v
  | ((Left3 _,ii),        ({typeD = ((Some _,b,c),ii2)} as _v)) ->
      raise (Semantic ("both signed and unsigned specified", fake_pi))
  | ((Left3 x,ii),        ({typeD = ((None,b,c),ii2)} as v))   ->
      {v with typeD = (Some x,b,c),ii @ ii2}

  | ((Middle3 Short,ii),  ({typeD = ((a,Some Short,c),ii2)} as v)) ->
      warning "duplicate 'short'" v


  (* gccext: long long allowed *)
  | ((Middle3 Long,ii),   ({typeD = ((a,Some Long ,c),ii2)} as v)) ->
      { v with typeD = (a, Some LongLong, c),ii @ ii2 }
  | ((Middle3 Long,ii),   ({typeD = ((a,Some LongLong ,c),ii2)} as v)) ->
      warning "triplicate 'long'" v


  | ((Middle3 _,ii),      ({typeD = ((a,Some _,c),ii2)} as _v)) ->
      raise (Semantic ("both long and short specified", fake_pi))
  | ((Middle3 x,ii),      ({typeD = ((a,None,c),ii2)} as v))  ->
      {v with typeD = (a, Some x,c),ii @ ii2}

  | ((Right3 t,ii),       ({typeD = ((a,b,Some x),ii2)} as v)) ->
      let mktype t ii = (({const=false;volatile=false;},[]),(t,ii)) in
      computed_warning
	(fun _ ->
	  Printf.sprintf
	    "two or more data types: dropping %s, keeping typeD %s\n"
	    (Pretty_print_c.string_of_fullType (mktype t ii))
	    (Pretty_print_c.string_of_fullType (mktype x ii2)))
	v
  | ((Right3 t,ii),       ({typeD = ((a,b,None),ii2)} as v))   ->
      {v with typeD = (a,b, Some t),ii @ ii2}


let addQualif = function
  | ({const=true},   ({const=true} as x)) ->   warning "duplicate 'const'" x
  | ({volatile=true},({volatile=true} as x))-> warning "duplicate 'volatile'" x
  | ({const=true},    v) -> {v with const=true}
  | ({volatile=true}, v) -> {v with volatile=true}
  | _ ->
      internal_error "there is no noconst or novolatile keyword"

let addQualifD ((qu,ii), ({qualifD = (v,ii2)} as x)) =
  { x with qualifD = (addQualif (qu, v),ii::ii2) }


(*-------------------------------------------------------------------------- *)
(* Declaration/Function related *)
(*-------------------------------------------------------------------------- *)


(* stdC: type section, basic integer types (and ritchie)
 * To understand the code, just look at the result (right part of the PM)
 * and go back.
 *)
let (fixDeclSpecForDecl: decl -> (fullType * (storage wrap)))  = function
 {storageD = (st,iist);
  qualifD = (qu,iiq);
  typeD = (ty,iit);
  inlineD = (inline,iinl);
  } ->
   let ty',iit' =
   (match ty with
 | (None,None,None)       ->
     (* generate fake_info, otherwise type_annotater can crash in
      * offset.
      *)
     warning "type defaults to 'int'" (defaultInt, [fakeInfo fake_pi])
 | (None, None, Some t)   -> (t, iit)

 | (Some sign,   None, (None| Some (BaseType (IntType (Si (_,CInt))))))  ->
     BaseType(IntType (Si (sign, CInt))), iit
 | ((None|Some Signed),Some x,(None|Some(BaseType(IntType (Si (_,CInt)))))) ->
     BaseType(IntType (Si (Signed, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some UnSigned, Some x, (None| Some (BaseType (IntType (Si (_,CInt))))))->
     BaseType(IntType (Si (UnSigned, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some sign,   None, (Some (BaseType (IntType CChar))))   ->
     BaseType(IntType (Si (sign, CChar2))), iit
 | (None, Some Long,(Some(BaseType(FloatType CDouble))))    ->
     BaseType (FloatType (CLongDouble)), iit
 | (None, Some Long,(Some(BaseType(FloatType CDoubleComplex))))    ->
     BaseType (FloatType (CLongDoubleComplex)), iit

 | (Some _,_, Some _) ->
     (*mine*)
     raise (Semantic ("signed, unsigned valid only for char and int", fake_pi))
 | (_,Some _,(Some(BaseType(FloatType (CFloat))))) ->
     raise (Semantic ("long or short specified with floating type", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDouble)))) ->
     raise (Semantic ("the only valid combination is long double", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDoubleComplex)))) ->
     raise (Semantic ("the only valid combination is long double complex", fake_pi))

 | (_, Some _, Some _) ->
     (* mine *)
     raise (Semantic ("long, short valid only for int or float", fake_pi))

     (* if do short uint i, then gcc say parse error, strange ? it is
      * not a parse error, it is just that we don't allow with typedef
      * either short/long or signed/unsigned. In fact, with
      * parse_typedef_fix2 (with et() and dt()) now I say too parse
      * error so this code is executed only when do short struct
      * {....} and never with a typedef cos now we parse short uint i
      * as short ident ident => parse error (cos after first short i
      * pass in dt() mode) *)

   )
   in
   ((qu, iiq),
   (ty', iit'))
     ,((st, inline),iist @ iinl)


let fixDeclSpecForParam = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | (Sto Register) -> (v, true), iist
  | NoSto -> (v, false), iist
  | _ ->
      raise
        (Semantic ("storage class specified for parameter of function",
                  fake_pi))

let fixDeclSpecForMacro = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | NoSto -> v
  | _ ->
      raise
        (Semantic ("storage class specified for macro type decl",
                  fake_pi))


let fixDeclSpecForFuncDef x =
  let (returnType,storage) = fixDeclSpecForDecl x in
  (match fst (unwrap storage) with
  | StoTypedef ->
      raise (Semantic ("function definition declared 'typedef'", fake_pi))
  | _ -> (returnType, storage)
  )


(* parameter: (this is the context where we give parameter only when
 * in func DEFINITION not in funct DECLARATION) We must have a name.
 * This function ensure that we give only parameterTypeDecl with well
 * formed Classic constructor todo?: do we accept other declaration
 * in ? so I must add them to the compound of the deffunc. I don't
 * have to handle typedef pb here cos C forbid to do VF f { ... }
 * with VF a typedef of func cos here we don't see the name of the
 * argument (in the typedef)
 *)
let (fixOldCDecl: fullType -> fullType) = fun ty ->
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, (b, iib))) ->

      (* stdC: If the prototype declaration declares a parameter for a
       * function that you are defining (it is part of a function
       * definition), then you must write a name within the declarator.
       * Otherwise, you can omit the name. *)
      (match params with
      | [{p_namei = None; p_type = ty2},_] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->
              ty
          | _ ->
              pr2_once ("SEMANTIC:parameter name omitted, but I continue");
              ty
          )

      | params ->
          (params +> List.iter (fun (param,_) ->
            match param with
            | {p_namei = None} ->
              (* if majuscule, then certainly macro-parameter *)
                pr2_once ("SEMANTIC:parameter name omitted, but I continue");
	    | _ -> ()
          ));
          ty
      )

        (* todo? can we declare prototype in the decl or structdef,
           ... => length <> but good kan meme *)
  | _ ->
      (* gcc say parse error but don't see why *)
      raise (Semantic ("seems this is not a function", fake_pi))


let fixFunc (typ, compound, old_style_opt) =
  let (cp,iicp) = compound in

  let (name, ty,   (st,iist),  attrs) = typ in

  let (qu, tybis) = ty in

  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params,abool)) ->
      let iifunc = Ast_c.get_ii_typeC_take_care tybis in

      let iistart = Ast_c.fakeInfo () in
      assert (qu = nullQualif);

      (match params with
      | [{p_namei= None; p_type = ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->  ()
          | _ ->
                (* failwith "internal error: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei = Some s}, _) -> ()
	  | _ -> ()
                (* failwith "internal error: fixOldCDecl not good" *)
          )
      );
      (* bugfix: cf tests_c/function_pointer4.c.
       * Apparemment en C on peut syntaxiquement ecrire ca:
       *
       *   void a(int)(int x);
       * mais apres gcc gueule au niveau semantique avec:
       *   xxx.c:1: error: 'a' declared as function returning a function
       * Je ne faisais pas cette verif. Sur du code comme
       *   void METH(foo)(int x) { ...} , le parser croit (a tort) que foo
       * est un typedef, et donc c'est parsé comme l'exemple precedent,
       * ce qui ensuite confuse l'unparser qui n'est pas habitué
       * a avoir dans le returnType un FunctionType et qui donc
       * pr_elem les ii dans le mauvais sens ce qui genere au final
       * une exception. Hence this fix to at least detect the error
       * at parsing time (not unparsing time).
       *)
      (match Ast_c.unwrap_typeC fullt with
      | FunctionType _ ->
          let s = Ast_c.str_of_name name in
          let iis = Ast_c.info_of_name name in
          pr2 (spf "WEIRD: %s declared as function returning a function." s);
          pr2 (spf "This is probably because of a macro. Extend standard.h");
          raise (Semantic (spf "error: %s " s, Ast_c.parse_info_of_info iis))
      | _ -> ()
      );

      (* it must be nullQualif,cos parser construct only this*)
      {f_name = name;
       f_type = (fullt, (params, abool));
       f_storage = st;
       f_body =
	if !Flag_parsing_c.parsing_header_for_types
	then []
	else cp;
       f_attr = attrs;
       f_old_c_style = old_style_opt;
      },
      (iifunc @ iicp @ [iistart] @ iist)
  | _ ->
      raise
        (Semantic
            ("you are trying to do a function definition but you don't give " ^
             "any parameter", fake_pi))


(*-------------------------------------------------------------------------- *)
(* parse_typedef_fix2 *)
(*-------------------------------------------------------------------------- *)

let dt s () =
  if !Flag_parsing_c.debug_etdt then pr2 ("<" ^ s);
  LP.disable_typedef ()

let et s () =
  if !Flag_parsing_c.debug_etdt then pr2 (">" ^ s);
  LP.enable_typedef ()


let fix_add_params_ident x =
  let (s, ty, st, _attrs) = x in
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, bool)) ->

      (match params with
      | [{p_namei=None; p_type=ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void -> ()
          | _ ->
              (* failwith "internal error: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei= Some name}, _) ->
              LP.add_ident (Ast_c.str_of_name s)
	  | _ ->
              ()
                (* failwith "internal error: fixOldCDecl not good" *)
          )
      )
  | _ -> ()

(*-------------------------------------------------------------------------- *)
(* shortcuts *)
(*-------------------------------------------------------------------------- *)

let mk_e e ii = Ast_c.mk_e e ii

let mk_string_wrap (s,info) = (s, [info])

(*-------------------------------------------------------------------------- *)
(* support for functions with no return type *)
(*-------------------------------------------------------------------------- *)

let args_are_params l =
  match l with
    [Right (ArgAction(ActMisc [x])), ii] when Ast_c.is_fake x -> true
  | _ -> List.for_all (function Right (ArgType x), ii -> true | _ -> false) l
let args_to_params l pb =
  let pi =
    match pb with Some pb -> Ast_c.parse_info_of_info pb | None -> fake_pi in
  match l with
    [(Right (ArgAction(ActMisc [x])), ii)] when Ast_c.is_fake x -> []
  | l ->
      List.map
	(function
	    Right (ArgType x), ii -> x, ii
	  | x ->
	      raise
		(Semantic
		   ("function with no return type must have types in param list",
		    pi)))
	l

(* For fake info added at the end of a conditional or iteration, to have the
correct position information *)
let postfakeInfo pii  =
  let (max,min) =  Lib_parsing_c.max_min_ii_by_pos pii in
  let max_pi = Ast_c.get_info (fun x -> x) max in
  let vp = ({str="";charpos=max_pi.Common.charpos;line=max_pi.Common.line;
	      column=max_pi.Common.column;file=max_pi.Common.file},
	    String.length max_pi.Common.str) in
  { pinfo = FakeTok ("",vp);
    cocci_tag = ref Ast_c.emptyAnnot;
    annots_tag = Token_annot.empty;
    comments_tag = ref Ast_c.emptyComments;
    danger = ref Ast_c.NoDanger;
  }

# 589 "parsing_c/parser_c.ml"
let yytransl_const = [|
    0|]

let yytransl_block = [|
  257 (* TUnknown *);
  258 (* TCommentSpace *);
  259 (* TCommentNewline *);
  260 (* TComment *);
  261 (* TInt *);
  262 (* TFloat *);
  263 (* TChar *);
  264 (* TString *);
  265 (* TQuote *);
  266 (* TPct *);
  267 (* TFormat *);
  268 (* TSubString *);
  269 (* TDecimal *);
  270 (* TIdent *);
  271 (* TKRParam *);
  272 (* Tconstructorname *);
  273 (* TypedefIdent *);
  274 (* TOPar *);
  275 (* TCPar *);
  276 (* TOBrace *);
  277 (* TCBrace *);
  278 (* TOCro *);
  279 (* TCCro *);
  280 (* TDot *);
  281 (* TComma *);
  282 (* TPtrOp *);
  283 (* TInc *);
  284 (* TDec *);
  285 (* TAssign *);
  286 (* TEq *);
  287 (* TWhy *);
  288 (* TTilde *);
  289 (* TBang *);
  290 (* TEllipsis *);
  291 (* TDotDot *);
  292 (* TPtVirg *);
  293 (* TOrLog *);
  294 (* TAndLog *);
  295 (* TOr *);
  296 (* TXor *);
  297 (* TAnd *);
  298 (* TEqEq *);
  299 (* TNotEq *);
  300 (* TInf *);
  301 (* TSup *);
  302 (* TInfEq *);
  303 (* TSupEq *);
  304 (* TShl *);
  305 (* TShr *);
  306 (* TPlus *);
  307 (* TMinus *);
  308 (* TMul *);
  309 (* TDiv *);
  310 (* TMod *);
  311 (* TMax *);
  312 (* TMin *);
  313 (* Tchar *);
  314 (* Tshort *);
  315 (* Tint *);
  316 (* Tdouble *);
  317 (* Tfloat *);
  318 (* Tcomplex *);
  319 (* Tlong *);
  320 (* Tunsigned *);
  321 (* Tsigned *);
  322 (* Tvoid *);
  323 (* Tsize_t *);
  324 (* Tssize_t *);
  325 (* Tptrdiff_t *);
  326 (* TautoType *);
  327 (* Tauto *);
  328 (* Tregister *);
  329 (* Textern *);
  330 (* Tstatic *);
  331 (* Ttypedef *);
  332 (* Tconst *);
  333 (* Tvolatile *);
  334 (* Tstruct *);
  335 (* Tunion *);
  336 (* Tenum *);
  337 (* Tdecimal *);
  338 (* Texec *);
  339 (* Tbreak *);
  340 (* Telse *);
  341 (* Tswitch *);
  342 (* Tcase *);
  343 (* Tcontinue *);
  344 (* Tfor *);
  345 (* Tdo *);
  346 (* Tif *);
  347 (* Twhile *);
  348 (* Treturn *);
  349 (* Tgoto *);
  350 (* Tdefault *);
  351 (* Tsizeof *);
  352 (* Tnew *);
  353 (* Tdelete *);
  354 (* Tdefined *);
  355 (* TOParCplusplusInit *);
  356 (* Tnamespace *);
  357 (* Trestrict *);
  358 (* Tasm *);
  359 (* Tattribute *);
  360 (* TattributeNoarg *);
  361 (* Tinline *);
  362 (* Ttypeof *);
  363 (* TDefine *);
  364 (* TDefParamVariadic *);
  365 (* TCppEscapedNewline *);
  366 (* TCppConcatOp *);
  367 (* TOParDefine *);
  368 (* TOBraceDefineInit *);
  369 (* TIdentDefine *);
  370 (* TDefEOL *);
  371 (* TInclude *);
  372 (* TIncludeStart *);
  373 (* TIncludeFilename *);
  374 (* TIfdef *);
  375 (* TIfdefelif *);
  376 (* TIfdefelse *);
  377 (* TEndif *);
  378 (* TIfdefBool *);
  379 (* TIfdefMisc *);
  380 (* TIfdefVersion *);
  381 (* TUifdef *);
  382 (* TUelseif *);
  383 (* TUendif *);
  384 (* TUndef *);
  385 (* TPrePragma *);
  386 (* TPragma *);
  387 (* TPragmaString *);
  388 (* TCppDirectiveOther *);
  389 (* TMacroAttr *);
  390 (* TMacroEndAttr *);
  391 (* TMacroStmt *);
  392 (* TMacroIdStmt *);
  393 (* TMacroIdentBuilder *);
  394 (* TMacroString *);
  395 (* TMacroDecl *);
  396 (* TMacroDeclConst *);
  397 (* TMacroIterator *);
  398 (* TCommentSkipTagStart *);
  399 (* TCommentSkipTagEnd *);
  400 (* TCParEOL *);
  401 (* TAction *);
  402 (* TCommentMisc *);
  403 (* TCommentCpp *);
    0 (* EOF *);
  404 (* TTODO *);
    0|]

let yylhs = "\255\255\
\001\000\006\000\006\000\006\000\008\000\008\000\008\000\009\000\
\009\000\010\000\010\000\012\000\012\000\012\000\012\000\011\000\
\011\000\011\000\013\000\013\000\004\000\004\000\015\000\015\000\
\015\000\016\000\016\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\017\000\017\000\020\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\025\000\025\000\
\025\000\025\000\025\000\025\000\024\000\024\000\024\000\024\000\
\024\000\024\000\024\000\023\000\023\000\023\000\023\000\023\000\
\023\000\023\000\023\000\023\000\023\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\031\000\031\000\035\000\035\000\036\000\037\000\037\000\037\000\
\040\000\040\000\040\000\039\000\041\000\044\000\021\000\022\000\
\003\000\045\000\045\000\045\000\045\000\045\000\045\000\045\000\
\045\000\045\000\045\000\045\000\046\000\046\000\046\000\046\000\
\053\000\053\000\055\000\055\000\055\000\034\000\057\000\057\000\
\059\000\059\000\059\000\060\000\060\000\060\000\060\000\060\000\
\047\000\047\000\047\000\048\000\048\000\048\000\048\000\048\000\
\049\000\049\000\049\000\049\000\049\000\049\000\049\000\049\000\
\050\000\050\000\050\000\050\000\050\000\050\000\032\000\032\000\
\051\000\051\000\067\000\069\000\069\000\069\000\069\000\069\000\
\052\000\052\000\052\000\052\000\071\000\071\000\071\000\071\000\
\072\000\072\000\070\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
\074\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
\074\000\074\000\074\000\074\000\074\000\074\000\074\000\027\000\
\077\000\077\000\077\000\078\000\078\000\079\000\079\000\080\000\
\080\000\080\000\080\000\082\000\082\000\081\000\081\000\081\000\
\081\000\081\000\081\000\084\000\085\000\089\000\089\000\089\000\
\090\000\090\000\090\000\090\000\090\000\090\000\090\000\090\000\
\090\000\088\000\088\000\092\000\092\000\092\000\092\000\038\000\
\094\000\094\000\095\000\097\000\097\000\097\000\097\000\097\000\
\097\000\098\000\083\000\083\000\083\000\083\000\005\000\005\000\
\099\000\100\000\100\000\100\000\100\000\103\000\103\000\103\000\
\108\000\108\000\108\000\108\000\108\000\108\000\108\000\108\000\
\108\000\108\000\107\000\107\000\107\000\107\000\109\000\109\000\
\054\000\093\000\110\000\110\000\110\000\112\000\112\000\112\000\
\112\000\112\000\112\000\105\000\113\000\114\000\111\000\111\000\
\111\000\115\000\115\000\106\000\106\000\106\000\029\000\029\000\
\118\000\118\000\118\000\118\000\118\000\120\000\120\000\120\000\
\030\000\030\000\121\000\121\000\121\000\126\000\126\000\126\000\
\126\000\127\000\127\000\127\000\127\000\127\000\127\000\128\000\
\128\000\130\000\130\000\130\000\131\000\131\000\075\000\122\000\
\134\000\132\000\133\000\124\000\124\000\076\000\076\000\076\000\
\139\000\139\000\140\000\061\000\142\000\142\000\143\000\143\000\
\141\000\141\000\141\000\144\000\145\000\145\000\147\000\147\000\
\146\000\146\000\062\000\062\000\062\000\062\000\062\000\062\000\
\149\000\149\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\151\000\151\000\
\151\000\151\000\151\000\065\000\065\000\153\000\153\000\152\000\
\154\000\156\000\155\000\063\000\063\000\063\000\063\000\063\000\
\063\000\063\000\157\000\157\000\157\000\157\000\007\000\007\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\056\000\058\000\136\000\138\000\116\000\117\000\123\000\125\000\
\086\000\087\000\033\000\033\000\066\000\066\000\068\000\068\000\
\026\000\026\000\104\000\104\000\135\000\135\000\129\000\129\000\
\129\000\137\000\137\000\137\000\102\000\102\000\102\000\091\000\
\091\000\042\000\042\000\043\000\043\000\014\000\014\000\014\000\
\119\000\119\000\158\000\158\000\096\000\159\000\159\000\064\000\
\101\000\101\000\150\000\150\000\019\000\019\000\000\000\000\000\
\000\000\000\000\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\006\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\003\000\
\002\000\004\000\001\000\003\000\001\000\003\000\001\000\003\000\
\003\000\001\000\005\000\001\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\001\000\004\000\001\000\002\000\002\000\002\000\002\000\004\000\
\002\000\005\000\002\000\004\000\002\000\004\000\004\000\003\000\
\004\000\003\000\001\000\004\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\004\000\004\000\003\000\003\000\
\003\000\002\000\002\000\005\000\007\000\001\000\001\000\001\000\
\001\000\003\000\001\000\001\000\003\000\001\000\002\000\003\000\
\000\000\002\000\002\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\002\000\005\000\
\006\000\004\000\001\000\004\000\003\000\004\000\006\000\003\000\
\001\000\001\000\002\000\003\000\002\000\003\000\000\000\001\000\
\001\000\001\000\002\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000\002\000\005\000\007\000\005\000\009\000\011\000\
\005\000\007\000\006\000\007\000\006\000\007\000\005\000\004\000\
\002\000\001\000\001\000\001\000\002\000\003\000\001\000\001\000\
\002\000\001\000\002\000\001\000\004\000\007\000\001\000\000\000\
\000\000\004\000\003\000\002\000\000\000\003\000\003\000\004\000\
\000\000\003\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\002\000\002\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\006\000\004\000\001\000\001\000\004\000\004\000\001\000\
\001\000\001\000\001\000\003\000\001\000\002\000\001\000\001\000\
\002\000\002\000\003\000\001\000\001\000\001\000\003\000\003\000\
\004\000\003\000\004\000\001\000\001\000\001\000\001\000\002\000\
\003\000\002\000\003\000\003\000\004\000\002\000\003\000\003\000\
\004\000\001\000\003\000\001\000\002\000\002\000\001\000\001\000\
\001\000\002\000\001\000\001\000\001\000\001\000\002\000\002\000\
\002\000\001\000\001\000\001\000\002\000\002\000\001\000\002\000\
\001\000\003\000\003\000\007\000\008\000\002\000\001\000\000\000\
\001\000\001\000\001\000\001\000\001\000\002\000\002\000\002\000\
\002\000\002\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\003\000\004\000\001\000\002\000\003\000\
\004\000\004\000\005\000\001\000\001\000\001\000\001\000\002\000\
\002\000\004\000\005\000\001\000\004\000\002\000\001\000\003\000\
\001\000\004\000\002\000\003\000\003\000\002\000\003\000\005\000\
\001\000\000\000\005\000\004\000\002\000\001\000\001\000\002\000\
\002\000\001\000\001\000\005\000\005\000\001\000\001\000\004\000\
\003\000\001\000\002\000\003\000\001\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\000\000\005\000\006\000\002\000\
\001\000\003\000\001\000\001\000\001\000\002\000\001\000\002\000\
\002\000\003\000\003\000\001\000\002\000\001\000\003\000\004\000\
\001\000\002\000\002\000\004\000\007\000\003\000\004\000\001\000\
\001\000\002\000\001\000\001\000\001\000\001\000\002\000\002\000\
\001\000\005\000\006\000\004\000\005\000\000\000\001\000\001\000\
\001\000\001\000\001\000\003\000\001\000\003\000\003\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\006\000\005\000\004\000\002\000\001\000\001\000\
\005\000\001\000\001\000\001\000\001\000\005\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\002\000\001\000\002\000\001\000\003\000\
\001\000\003\000\001\000\003\000\001\000\002\000\001\000\004\000\
\003\000\001\000\004\000\003\000\001\000\004\000\003\000\001\000\
\003\000\001\000\002\000\000\000\002\000\000\000\001\000\003\000\
\001\000\002\000\001\000\002\000\001\000\001\000\002\000\001\000\
\001\000\000\000\001\000\000\000\001\000\000\000\002\000\002\000\
\002\000\002\000\002\000"

let yydefred = "\000\000\
\002\000\000\000\000\000\000\000\000\000\000\000\007\002\000\000\
\008\000\000\000\245\000\207\001\227\000\236\000\228\000\000\000\
\000\000\009\000\237\000\239\000\238\000\226\000\233\000\234\000\
\235\000\244\000\069\001\070\001\068\001\067\001\072\001\249\000\
\250\000\000\000\000\000\000\000\000\000\000\000\251\000\000\000\
\000\000\000\000\000\000\000\000\000\000\184\001\186\001\185\001\
\187\001\192\001\193\001\194\001\000\000\000\000\160\001\253\000\
\208\001\008\002\202\001\000\000\000\000\200\001\199\001\203\001\
\205\001\248\000\240\000\241\000\000\000\000\000\000\000\073\001\
\000\000\000\000\074\001\000\000\127\001\000\000\128\001\140\001\
\000\000\148\001\150\001\188\001\189\001\191\001\190\001\204\001\
\087\000\088\000\091\000\000\000\000\000\092\000\000\000\013\000\
\000\000\209\001\000\000\000\000\073\000\074\000\145\000\075\000\
\069\000\071\000\072\000\070\000\015\000\000\000\163\000\000\000\
\000\000\162\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\254\001\000\000\123\000\000\000\000\000\000\000\009\002\000\000\
\086\000\000\000\000\000\021\000\023\000\000\000\000\000\049\000\
\000\000\000\000\000\000\076\000\000\000\115\000\113\000\114\000\
\116\000\117\000\118\000\000\000\000\000\000\000\000\000\000\000\
\000\000\011\000\011\002\000\000\000\000\000\000\042\001\000\000\
\000\000\001\000\003\000\217\001\000\000\232\000\231\000\251\001\
\112\001\000\000\113\001\005\000\006\000\211\001\007\000\000\000\
\000\000\000\000\000\000\000\000\000\000\071\001\065\001\000\000\
\000\000\155\001\000\000\000\000\000\000\198\001\063\001\064\001\
\066\001\000\000\005\001\004\001\006\001\001\002\000\000\000\000\
\000\000\000\000\000\000\000\000\085\001\000\000\237\001\149\001\
\000\000\054\001\062\001\215\001\000\000\000\000\145\001\141\001\
\143\001\000\000\000\000\000\000\000\000\100\000\000\000\000\000\
\000\000\000\000\000\000\052\000\000\000\053\000\000\000\000\000\
\110\000\028\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\014\000\161\000\000\000\055\000\000\000\000\000\
\000\000\000\000\000\000\067\000\000\000\059\000\000\000\061\000\
\000\000\000\000\017\000\000\000\000\000\000\000\000\000\000\000\
\147\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\082\000\083\000\
\054\000\167\000\168\000\219\001\000\000\119\000\000\000\000\000\
\000\000\141\000\000\000\140\000\138\000\000\000\136\000\000\000\
\142\000\143\000\144\000\146\000\255\001\039\001\040\001\041\001\
\000\000\000\000\000\000\000\000\049\001\000\000\048\001\000\000\
\028\001\218\001\240\001\151\001\000\000\000\000\032\001\000\000\
\252\001\000\000\139\001\000\000\234\001\000\000\000\000\002\000\
\000\000\000\000\252\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\158\001\000\000\000\000\000\000\105\000\106\000\227\001\107\000\
\109\000\000\000\000\000\000\000\000\000\088\001\000\000\012\001\
\000\000\000\000\043\001\044\001\001\001\000\000\050\001\000\000\
\051\001\084\001\000\000\000\000\000\000\000\000\115\001\000\000\
\000\000\118\001\119\001\000\000\000\000\129\001\114\001\229\001\
\000\000\000\000\147\001\142\001\146\001\144\001\101\000\099\000\
\090\000\098\000\019\000\000\000\093\000\096\000\000\000\222\000\
\223\000\225\000\224\000\000\000\219\000\214\000\215\000\212\000\
\213\000\218\000\195\000\196\000\198\000\197\000\216\000\217\000\
\000\000\206\000\205\000\210\000\211\000\209\000\199\000\200\000\
\204\000\203\000\202\000\201\000\208\000\207\000\188\000\189\000\
\190\000\191\000\192\000\194\000\193\000\221\000\220\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\130\000\128\000\129\000\000\000\000\000\000\000\
\000\000\102\000\000\000\225\001\103\000\104\000\108\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\175\001\176\001\
\178\001\179\001\177\001\000\000\247\001\000\000\000\000\022\000\
\125\000\024\000\025\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\029\000\030\000\033\000\032\000\
\031\000\112\000\000\000\079\000\000\000\000\000\080\000\081\000\
\220\001\000\000\000\000\000\000\210\001\134\000\139\000\022\001\
\000\000\018\001\000\000\000\000\000\000\000\000\000\000\002\000\
\152\001\000\000\000\000\000\000\000\000\035\001\029\001\030\001\
\000\000\000\000\000\000\000\000\243\000\000\000\000\000\000\000\
\000\000\221\001\000\000\247\000\246\000\000\000\000\000\000\000\
\000\000\000\000\213\001\000\000\000\000\000\000\097\001\000\000\
\000\000\095\001\000\000\249\001\168\001\167\001\156\001\162\001\
\159\001\245\001\000\000\000\000\197\001\007\001\000\000\000\000\
\013\001\000\000\008\001\010\001\000\000\045\001\046\001\003\001\
\000\000\000\000\086\001\239\001\000\000\000\000\092\001\076\001\
\000\000\000\000\000\000\000\000\000\000\130\001\000\000\000\000\
\000\000\231\001\000\000\000\000\216\001\108\001\230\001\089\001\
\000\000\000\000\000\000\000\000\000\000\124\000\180\000\000\000\
\000\000\126\000\000\000\000\000\000\000\000\000\000\000\000\000\
\064\000\000\000\066\000\000\000\243\001\000\000\000\000\000\000\
\060\000\062\000\000\000\000\000\000\000\122\000\018\000\000\000\
\181\001\160\000\000\000\000\000\000\000\000\000\050\000\078\000\
\077\000\000\000\017\001\019\001\023\001\020\001\000\000\024\001\
\000\000\000\000\027\001\241\001\034\001\000\000\236\001\000\000\
\212\001\134\001\138\001\000\000\201\001\000\000\000\000\175\000\
\000\000\223\001\222\001\206\001\000\000\000\000\000\000\000\000\
\000\000\102\001\000\000\000\000\000\000\214\001\000\000\099\001\
\000\000\250\001\196\001\000\000\228\001\000\000\000\000\009\001\
\011\001\000\000\000\000\000\000\238\001\077\001\000\000\094\001\
\000\000\107\001\000\000\000\000\126\001\121\001\000\000\000\000\
\000\000\131\001\123\001\020\000\000\000\179\000\000\000\000\000\
\000\000\000\000\150\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\153\000\063\000\065\000\000\000\226\001\068\000\
\120\000\000\000\000\000\248\001\000\000\159\000\027\000\084\000\
\000\000\021\001\025\001\004\000\135\001\235\001\242\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\103\001\000\000\
\101\001\096\001\000\000\000\000\100\001\195\001\090\001\000\000\
\000\000\000\000\000\000\080\001\000\000\000\000\000\000\000\000\
\000\000\233\001\000\000\120\001\124\001\186\000\000\000\000\000\
\000\000\178\000\127\000\155\000\000\000\157\000\000\000\000\000\
\000\000\121\000\000\000\180\001\000\000\000\000\000\000\187\000\
\000\000\000\000\224\001\000\000\000\000\157\001\000\000\003\002\
\170\001\098\001\091\001\000\000\081\001\082\001\093\001\052\001\
\000\000\117\001\116\001\232\001\000\000\182\000\183\000\156\000\
\158\000\154\000\149\000\000\000\000\000\000\000\085\000\173\000\
\000\000\000\000\104\001\083\001\053\001\184\000\000\000\000\000\
\182\001\183\001\000\000\000\000\151\000\000\000\000\000\174\000\
\152\000"

let yydgoto = "\006\000\
\007\000\058\000\153\002\136\000\163\000\008\000\171\000\070\002\
\145\001\137\000\162\000\139\000\164\001\244\001\140\000\141\000\
\142\000\143\000\253\001\144\000\145\000\019\002\146\000\147\000\
\003\001\227\001\061\000\148\000\072\002\051\002\231\000\149\000\
\097\001\150\000\232\000\160\001\228\001\118\001\230\001\119\001\
\120\001\231\001\121\001\226\002\151\000\152\000\153\000\154\000\
\155\000\156\000\098\001\208\001\220\001\221\001\061\001\157\000\
\062\001\030\002\063\001\064\001\063\000\066\001\067\001\158\000\
\154\002\057\002\058\002\185\002\186\002\057\003\234\002\124\002\
\209\001\066\000\067\000\068\000\069\000\070\000\154\001\208\000\
\209\000\210\000\134\001\129\001\091\002\076\001\084\001\085\001\
\033\002\078\001\086\001\087\001\088\001\047\002\048\002\097\002\
\167\000\168\000\079\001\072\000\211\000\212\000\073\000\122\001\
\140\001\104\002\190\000\075\000\076\000\213\000\214\000\099\002\
\215\000\100\002\126\001\073\002\200\002\074\002\075\002\076\002\
\077\000\078\000\222\000\149\001\118\002\079\000\150\001\151\001\
\113\002\114\002\115\002\116\002\227\002\152\001\153\001\185\000\
\092\001\178\002\093\001\094\001\080\000\227\000\228\000\081\000\
\082\000\216\000\083\000\112\001\115\001\065\003\245\001\155\002\
\052\003\085\000\086\000\087\000\088\000\178\000\159\000"

let yysindex = "\102\003\
\000\000\245\011\098\019\133\023\213\029\000\000\000\000\066\012\
\000\000\089\255\000\000\000\000\000\000\000\000\000\000\016\255\
\038\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\243\254\243\254\131\000\096\255\201\255\000\000\132\255\
\207\255\142\029\244\255\157\255\217\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\229\255\083\000\000\000\000\000\
\000\000\000\000\000\000\093\255\142\029\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\142\029\142\029\035\001\000\000\
\227\255\242\255\000\000\142\029\000\000\084\001\000\000\000\000\
\250\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\027\000\000\000\028\000\000\000\
\204\021\000\000\133\023\133\023\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\059\255\000\000\128\000\
\133\023\000\000\134\000\098\019\137\000\154\000\133\023\208\000\
\166\000\133\023\061\008\253\021\059\000\066\255\205\000\155\000\
\000\000\010\001\000\000\019\001\000\000\037\001\000\000\247\255\
\000\000\000\000\045\001\000\000\000\000\229\000\248\020\000\000\
\213\029\011\002\133\023\000\000\033\255\000\000\000\000\000\000\
\000\000\000\000\000\000\047\001\199\017\054\001\222\000\028\000\
\078\001\000\000\000\000\213\029\213\029\213\029\000\000\209\000\
\094\001\000\000\000\000\000\000\074\027\000\000\000\000\000\000\
\000\000\243\254\000\000\000\000\000\000\000\000\000\000\096\001\
\141\001\133\023\099\001\033\255\107\001\000\000\000\000\065\020\
\026\015\000\000\015\001\018\001\066\014\000\000\000\000\000\000\
\000\000\203\001\000\000\000\000\000\000\000\000\255\254\110\000\
\031\000\015\255\118\001\251\255\000\000\127\255\000\000\000\000\
\148\001\000\000\000\000\000\000\163\001\121\025\000\000\000\000\
\000\000\035\001\071\029\246\000\176\001\000\000\186\001\027\000\
\188\001\071\000\192\001\000\000\213\029\000\000\065\031\133\023\
\000\000\000\000\146\000\213\019\116\001\133\023\133\023\078\001\
\028\000\133\023\000\000\000\000\080\018\000\000\213\029\197\001\
\238\001\174\014\208\001\000\000\249\001\000\000\022\255\000\000\
\033\255\003\002\000\000\014\002\174\014\098\000\146\012\133\023\
\000\000\080\018\133\023\133\023\133\023\133\023\133\023\133\023\
\133\023\133\023\133\023\133\023\133\023\133\023\133\023\133\023\
\133\023\133\023\133\023\133\023\133\023\133\023\133\023\133\023\
\133\023\239\001\254\012\133\023\141\001\141\001\000\000\000\000\
\000\000\000\000\000\000\000\000\033\255\000\000\000\000\133\023\
\005\002\000\000\017\002\000\000\000\000\032\002\000\000\199\017\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\006\002\046\022\254\000\222\027\000\000\032\001\000\000\035\002\
\000\000\000\000\000\000\000\000\071\002\066\002\000\000\129\001\
\000\000\141\001\000\000\073\002\000\000\079\002\213\000\000\000\
\036\255\077\002\000\000\093\002\095\002\098\019\067\255\098\000\
\060\021\000\000\247\255\000\000\199\017\000\000\185\000\002\002\
\000\000\018\001\007\002\230\001\000\000\000\000\000\000\000\000\
\000\000\047\255\101\002\078\255\000\000\000\000\031\000\000\000\
\095\022\074\027\000\000\000\000\000\000\015\255\000\000\133\003\
\000\000\000\000\066\014\144\022\066\014\121\025\000\000\106\002\
\107\002\000\000\000\000\058\003\115\002\000\000\000\000\000\000\
\121\025\255\254\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\027\002\000\000\000\000\239\001\000\000\
\000\000\000\000\000\000\114\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\022\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\105\002\
\065\031\059\001\133\023\080\018\110\021\110\021\124\002\060\001\
\069\001\078\001\000\000\000\000\000\000\239\001\106\013\214\013\
\255\001\000\000\105\001\000\000\000\000\000\000\000\000\133\023\
\133\023\152\002\154\002\033\255\133\023\125\001\000\000\000\000\
\000\000\000\000\000\000\137\001\000\000\217\018\169\001\000\000\
\000\000\000\000\000\000\078\001\108\002\247\005\115\006\146\002\
\119\005\232\006\208\006\208\006\223\003\223\003\223\003\223\003\
\010\002\010\002\094\002\094\002\000\000\000\000\000\000\000\000\
\000\000\000\000\193\022\000\000\171\001\043\000\000\000\000\000\
\000\000\102\001\080\018\080\018\000\000\000\000\000\000\000\000\
\158\002\000\000\155\002\032\001\071\002\242\022\074\027\000\000\
\000\000\151\027\055\001\243\254\061\000\000\000\000\000\000\000\
\073\002\176\003\161\002\133\023\000\000\133\023\108\028\194\000\
\144\002\000\000\147\002\000\000\000\000\113\002\033\255\166\002\
\207\001\028\000\000\000\133\023\151\000\170\002\000\000\182\002\
\172\020\000\000\247\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\041\255\066\014\000\000\000\000\033\255\190\002\
\000\000\186\002\000\000\000\000\071\002\000\000\000\000\000\000\
\203\001\181\255\000\000\000\000\133\003\212\001\000\000\000\000\
\172\020\221\001\115\002\066\014\066\014\000\000\243\254\174\002\
\074\255\000\000\176\002\133\023\000\000\000\000\000\000\000\000\
\201\002\197\002\205\002\065\031\075\002\000\000\000\000\098\019\
\185\002\000\000\035\023\084\023\133\023\217\018\217\018\197\002\
\000\000\235\001\000\000\240\001\000\000\167\011\066\014\250\000\
\000\000\000\000\187\002\202\002\244\001\000\000\000\000\098\000\
\000\000\000\000\217\018\217\018\133\023\222\020\000\000\000\000\
\000\000\080\018\000\000\000\000\000\000\000\000\199\002\000\000\
\071\002\179\028\000\000\000\000\000\000\161\002\000\000\176\003\
\000\000\000\000\000\000\206\002\000\000\217\002\059\255\000\000\
\212\002\000\000\000\000\000\000\222\002\219\002\033\255\062\017\
\024\000\000\000\060\021\060\021\221\002\000\000\182\002\000\000\
\060\021\000\000\000\000\208\002\000\000\227\002\033\255\000\000\
\000\000\032\000\066\014\144\022\000\000\000\000\182\002\000\000\
\049\255\000\000\254\001\024\002\000\000\000\000\225\011\211\002\
\133\023\000\000\000\000\000\000\114\002\000\000\133\023\234\002\
\235\002\065\031\000\000\080\018\217\018\029\002\217\018\048\002\
\052\002\173\002\000\000\000\000\000\000\208\001\000\000\000\000\
\000\000\224\002\098\019\000\000\167\001\000\000\000\000\000\000\
\182\002\000\000\000\000\000\000\000\000\000\000\000\000\133\023\
\238\002\194\000\133\023\187\002\002\003\216\002\000\000\133\023\
\000\000\000\000\050\003\056\003\000\000\000\000\000\000\061\003\
\066\014\144\022\053\002\000\000\056\003\046\003\144\022\049\003\
\051\003\000\000\225\011\000\000\000\000\000\000\224\001\075\002\
\075\002\000\000\000\000\000\000\217\018\000\000\217\018\053\003\
\217\018\000\000\013\003\000\000\217\018\217\018\065\003\000\000\
\081\003\093\003\000\000\055\002\224\002\000\000\079\003\000\000\
\000\000\000\000\000\000\060\002\000\000\000\000\000\000\000\000\
\068\003\000\000\000\000\000\000\075\002\000\000\000\000\000\000\
\000\000\000\000\000\000\053\001\242\002\167\001\000\000\000\000\
\091\003\053\003\000\000\000\000\000\000\000\000\098\019\098\019\
\000\000\000\000\133\023\240\002\000\000\094\003\098\019\000\000\
\000\000"

let yyrindex = "\000\000\
\000\000\229\002\000\000\000\000\000\000\000\000\000\000\229\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\207\004\
\075\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\154\001\250\001\000\000\000\000\000\000\000\000\000\000\
\000\000\182\004\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\184\023\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\223\023\232\023\078\003\000\000\
\000\000\038\025\000\000\244\023\000\000\000\000\000\000\000\000\
\229\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\195\006\106\003\000\000\114\030\000\000\
\015\030\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\080\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\063\007\000\000\000\000\000\000\
\000\000\153\030\000\000\000\000\000\000\067\009\220\002\000\000\
\000\000\175\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\039\255\000\000\067\026\245\002\
\118\004\000\000\000\000\155\011\157\011\164\011\000\000\019\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\172\023\000\000\000\000\000\000\000\000\000\000\203\005\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\024\255\000\000\000\000\000\000\051\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\160\026\000\000\
\098\024\164\000\000\000\000\000\000\000\152\000\000\000\000\000\
\000\000\000\000\000\000\000\000\071\006\099\003\000\000\000\000\
\000\000\078\003\229\002\000\000\000\000\000\000\000\000\106\003\
\000\000\000\000\000\000\000\000\000\000\000\000\088\003\000\000\
\000\000\000\000\000\000\229\002\000\000\000\000\000\000\089\003\
\103\007\000\000\000\000\000\000\229\002\000\000\000\000\000\000\
\009\008\000\000\135\008\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\062\002\000\000\000\000\
\000\000\229\002\000\000\000\000\092\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\227\007\000\000\241\025\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\082\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\037\028\000\000\033\000\000\000\000\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\107\003\000\000\062\255\
\000\000\000\000\000\000\108\003\000\000\074\001\000\000\000\000\
\111\003\000\000\000\000\000\000\000\000\000\000\000\000\062\002\
\000\000\163\015\017\003\044\016\229\002\181\016\070\255\000\000\
\000\000\018\003\000\000\051\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\253\026\000\000\199\024\000\000\
\000\000\000\000\000\000\000\000\000\000\187\001\000\000\000\000\
\000\000\000\000\063\002\000\000\063\002\099\003\000\000\000\000\
\000\000\000\000\000\000\078\003\000\000\000\000\000\000\000\000\
\113\003\085\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\083\004\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\205\030\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\088\003\000\000\000\000\229\002\000\000\000\000\000\000\000\000\
\000\000\100\003\000\000\000\000\000\000\000\000\000\000\000\000\
\064\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\103\003\000\000\206\009\039\006\043\005\
\193\002\137\010\092\002\159\006\118\003\036\010\091\010\175\010\
\230\009\005\010\110\009\149\009\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\102\255\106\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\046\000\000\000\000\000\000\000\000\000\
\000\000\000\000\037\028\069\255\032\255\000\000\000\000\000\000\
\108\003\114\003\000\000\000\000\000\000\000\000\229\002\199\000\
\121\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\119\031\000\000\000\000\000\000\000\000\000\000\108\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\078\003\051\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\159\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\063\002\063\002\000\000\073\255\000\000\
\078\003\000\000\094\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\088\003\007\031\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\173\008\
\000\000\000\000\000\000\000\000\000\000\000\000\063\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\206\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\229\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\232\000\000\000\000\000\
\076\000\000\000\000\000\000\000\000\000\000\000\000\000\024\255\
\000\000\000\000\000\000\114\003\000\000\000\000\108\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\179\000\063\002\000\000\000\000\000\000\108\003\000\000\
\078\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\205\030\000\000\000\000\000\000\
\000\000\088\003\000\000\229\002\000\000\000\000\000\000\000\000\
\000\000\029\011\000\000\000\000\000\000\029\009\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\108\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\199\000\000\000\028\003\000\000\000\000\000\000\000\000\
\000\000\000\000\030\003\000\000\000\000\000\000\000\000\000\000\
\063\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\031\
\007\031\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\031\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\007\031\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\032\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000"

let yygindex = "\000\000\
\000\000\000\000\255\255\007\000\159\255\215\254\148\004\221\255\
\002\000\190\255\253\255\173\255\000\000\062\003\114\000\018\000\
\129\002\149\021\000\000\092\001\013\002\169\254\000\000\000\000\
\028\002\136\255\022\000\000\000\242\254\251\254\193\003\113\255\
\022\004\209\255\000\000\000\000\000\000\215\009\000\000\149\254\
\000\000\203\002\057\003\211\255\000\000\000\000\061\255\000\000\
\000\000\000\000\055\255\078\254\012\255\012\000\000\000\000\000\
\000\000\000\000\025\255\072\255\125\255\001\000\020\000\202\255\
\127\000\000\000\118\002\000\000\166\001\079\001\084\253\204\001\
\000\000\000\000\000\000\000\000\076\001\231\000\193\255\025\000\
\060\255\000\000\000\000\000\000\089\002\029\000\209\254\201\254\
\111\255\206\254\000\000\000\000\005\000\000\000\000\000\250\255\
\000\000\144\255\000\000\000\000\148\254\000\000\000\000\180\254\
\216\253\121\253\016\000\072\002\000\000\000\000\167\254\000\000\
\000\000\081\002\000\000\132\254\183\253\101\255\000\000\109\002\
\000\000\000\000\215\003\044\003\080\002\000\000\000\000\000\000\
\000\000\102\253\000\000\074\002\219\001\038\003\000\000\015\004\
\143\003\034\002\248\253\000\000\000\000\000\000\135\254\000\000\
\000\000\000\000\000\000\009\002\123\003\000\000\051\002\008\000\
\149\001\108\253\156\001\131\253\000\000\000\000\000\000"

let yytablesize = 8367
let yytable = "\138\000\
\184\000\135\000\064\000\060\000\205\000\052\001\071\000\207\000\
\109\001\084\000\161\000\127\001\071\000\062\000\101\002\105\002\
\206\000\074\000\047\001\062\000\037\002\065\000\077\001\074\000\
\036\002\065\001\164\000\177\000\179\000\249\001\127\002\216\002\
\014\001\223\000\015\001\160\000\252\000\041\002\173\000\112\002\
\050\001\175\002\221\000\050\001\052\001\016\001\098\002\042\001\
\213\001\235\000\014\001\070\001\071\001\072\001\055\002\203\000\
\014\001\212\002\008\001\135\000\098\000\110\001\102\002\235\001\
\106\002\083\002\204\000\243\000\034\003\244\001\056\002\084\002\
\009\000\059\001\093\002\244\001\028\003\174\000\138\001\122\002\
\031\001\225\000\092\002\009\001\063\002\226\000\031\001\033\001\
\031\002\041\000\032\000\033\000\224\000\033\001\100\001\087\002\
\074\000\125\001\223\002\175\000\124\001\091\001\137\000\234\000\
\053\003\002\002\172\000\125\001\125\001\148\001\197\000\239\000\
\138\000\186\000\245\000\039\000\251\000\041\000\122\001\056\000\
\018\000\052\001\133\000\078\003\079\003\248\000\131\000\054\003\
\198\000\122\001\241\000\127\000\129\000\077\002\136\002\205\000\
\076\003\174\001\123\001\167\001\095\001\205\000\010\001\064\002\
\004\001\014\001\069\003\056\000\238\001\188\000\247\001\073\003\
\125\001\138\000\088\002\058\001\138\001\222\001\132\000\205\000\
\094\003\071\000\056\001\000\001\084\000\025\002\164\000\006\003\
\060\001\026\003\051\001\206\000\074\000\051\001\129\000\014\001\
\031\003\056\001\021\002\155\001\157\001\251\000\129\000\166\001\
\176\002\164\000\164\000\164\000\065\001\138\000\085\002\106\001\
\075\001\053\003\244\001\137\000\234\001\111\001\046\002\107\001\
\084\000\230\002\066\003\241\000\108\001\031\001\125\001\129\000\
\074\000\025\002\138\001\071\003\033\001\164\000\187\000\133\000\
\054\003\023\002\024\002\131\000\056\001\078\002\146\001\130\002\
\189\000\139\001\132\000\122\001\158\001\084\000\204\002\226\000\
\205\002\065\001\133\001\166\000\059\001\130\001\156\001\169\002\
\056\001\147\001\074\000\164\000\056\001\165\002\210\001\168\002\
\226\000\138\000\036\002\219\001\216\001\217\001\170\002\214\001\
\218\001\226\000\164\000\074\000\224\002\192\000\091\001\210\002\
\176\000\176\000\026\002\098\002\074\000\193\000\138\000\016\001\
\219\001\131\002\132\002\136\001\164\000\205\000\226\000\211\002\
\044\002\059\001\017\001\252\001\035\002\148\001\137\001\219\002\
\220\002\074\000\148\002\247\002\229\000\047\001\230\000\249\001\
\148\001\251\000\251\000\174\002\205\000\209\002\015\003\207\000\
\172\000\101\001\022\002\014\001\128\001\015\001\117\001\042\003\
\206\000\016\003\199\002\015\001\138\000\138\001\058\001\132\000\
\016\001\161\002\197\002\016\001\071\000\205\000\016\001\084\000\
\160\000\241\000\160\000\060\001\007\001\194\000\043\002\074\000\
\165\000\205\000\074\001\090\002\111\002\195\000\251\000\105\002\
\056\001\165\001\215\002\241\000\052\001\206\000\171\000\016\001\
\196\000\075\001\138\000\120\002\062\002\035\003\138\002\140\002\
\127\001\138\000\039\002\058\001\030\003\217\000\171\000\239\001\
\045\002\071\000\240\001\226\001\084\000\190\002\125\002\166\000\
\060\001\003\003\071\002\160\000\074\000\218\000\226\001\202\000\
\226\001\248\001\025\003\241\001\250\001\251\001\027\003\045\002\
\225\000\233\000\166\000\166\000\166\000\206\002\146\001\001\003\
\180\000\240\000\241\000\181\000\015\001\084\000\182\000\244\000\
\089\001\146\001\246\000\130\001\226\001\105\002\096\002\016\001\
\084\000\147\001\105\002\164\000\180\000\129\002\166\000\181\000\
\127\000\242\001\127\000\247\000\147\001\130\002\164\000\052\001\
\075\001\000\001\015\001\211\001\212\001\000\001\000\001\078\001\
\132\001\000\001\002\001\075\001\000\001\016\001\236\000\238\000\
\183\000\020\003\078\001\132\000\166\000\132\000\160\000\052\001\
\253\000\182\002\043\002\079\001\068\003\243\001\074\001\009\000\
\138\000\029\003\219\001\166\000\183\000\254\000\079\001\183\002\
\226\000\176\000\011\001\127\000\165\000\249\000\091\001\176\000\
\096\000\203\000\073\001\074\000\241\000\166\000\074\001\053\002\
\205\000\176\000\205\000\123\001\204\000\054\002\144\002\165\000\
\165\000\165\000\138\000\149\002\012\001\013\003\132\000\043\003\
\167\002\203\000\172\000\055\003\117\001\103\002\117\001\018\000\
\172\000\019\001\020\001\250\000\204\000\024\003\179\002\109\001\
\180\002\098\000\172\000\165\000\068\002\109\000\069\002\073\001\
\248\002\000\001\016\001\074\001\201\002\000\001\193\002\138\000\
\138\000\219\001\219\001\013\001\206\000\131\001\205\000\226\000\
\226\000\194\002\205\000\203\002\014\001\173\002\127\000\017\003\
\018\003\165\000\074\000\074\000\000\001\021\003\251\000\052\001\
\160\000\172\000\225\000\000\001\202\000\038\002\015\001\241\000\
\165\000\184\002\206\000\071\000\110\001\127\000\129\000\052\001\
\039\002\132\000\062\000\045\002\160\000\241\000\074\000\241\000\
\043\002\032\002\165\000\203\000\074\001\128\002\134\002\018\001\
\226\001\226\001\054\001\016\001\016\001\241\000\204\000\135\002\
\132\000\068\001\071\002\042\000\091\001\016\001\137\001\203\000\
\044\000\180\000\137\001\069\001\181\000\158\001\016\001\220\000\
\221\002\045\000\204\000\080\001\095\002\087\001\176\000\237\000\
\237\000\191\000\087\001\182\000\166\000\053\000\096\001\054\000\
\087\001\055\000\071\002\142\002\138\000\099\001\235\002\166\000\
\113\001\143\002\138\000\138\000\199\000\241\000\255\000\211\001\
\162\002\238\002\240\002\241\002\200\000\201\000\160\000\150\002\
\127\000\183\000\043\002\219\000\114\001\143\002\074\001\138\000\
\138\000\135\001\249\000\151\002\205\000\096\000\138\000\111\002\
\219\001\152\002\206\000\004\001\127\000\141\001\226\000\110\001\
\129\000\203\000\110\001\132\000\251\000\110\001\071\000\071\002\
\158\001\074\000\095\003\096\003\204\000\062\000\220\000\087\001\
\009\003\074\000\159\001\156\002\138\000\160\002\106\001\132\000\
\046\000\143\002\161\001\143\002\111\001\117\001\107\001\084\000\
\002\001\163\001\109\000\108\001\002\001\002\001\215\001\074\000\
\002\001\094\002\166\001\002\001\071\002\071\002\223\001\110\001\
\160\000\165\000\071\002\026\000\202\000\117\001\117\001\225\000\
\205\000\192\002\063\003\111\002\165\000\232\001\214\002\152\002\
\138\000\138\000\219\001\138\000\084\002\039\003\127\000\217\002\
\226\000\242\000\241\000\203\000\010\000\084\002\077\003\138\000\
\016\001\051\003\127\000\074\000\006\001\244\002\204\000\224\001\
\117\001\018\002\245\002\143\002\242\002\243\002\251\002\111\001\
\143\002\132\000\111\001\184\002\016\001\111\001\255\002\233\001\
\032\003\060\003\176\000\049\001\236\001\132\000\084\002\073\001\
\032\002\253\002\254\002\074\001\043\001\047\000\048\000\237\001\
\044\001\241\000\045\001\158\001\046\001\047\001\048\001\027\002\
\002\001\138\000\033\003\138\000\002\001\138\000\203\000\045\003\
\084\002\138\000\138\000\028\002\029\002\016\001\040\002\111\001\
\127\000\204\000\242\000\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\047\003\002\001\117\001\103\002\048\003\070\003\
\016\001\090\003\002\001\176\000\016\001\084\002\092\003\016\001\
\246\001\244\001\242\001\132\000\084\002\176\000\246\001\244\001\
\242\001\082\001\042\002\138\000\138\000\100\003\101\003\059\002\
\231\002\050\002\232\002\138\000\233\002\105\003\001\000\002\000\
\003\000\004\000\005\000\044\003\052\002\046\003\042\000\060\002\
\042\000\061\002\042\000\079\002\042\000\038\000\116\001\086\002\
\081\002\056\003\042\000\108\002\109\002\042\000\042\000\042\000\
\042\000\042\000\042\000\042\000\042\000\042\000\042\000\117\002\
\121\002\123\002\117\001\103\002\126\002\133\002\157\002\225\001\
\103\002\037\001\038\001\039\001\040\001\041\001\242\000\242\000\
\242\000\242\000\242\000\242\000\242\000\242\000\242\000\242\000\
\242\000\242\000\242\000\242\000\242\000\242\000\242\000\242\000\
\242\000\242\000\146\002\080\003\147\002\081\003\051\000\083\003\
\163\002\164\002\056\002\085\003\086\003\177\002\188\002\191\002\
\242\000\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\242\000\189\002\195\002\042\000\196\002\207\002\
\089\002\222\002\110\002\046\000\056\003\046\000\228\002\046\000\
\158\002\046\000\229\002\236\002\250\002\002\003\249\002\046\000\
\007\003\042\000\046\000\046\000\046\000\046\000\046\000\046\000\
\046\000\242\000\008\003\042\000\010\003\012\003\026\000\011\003\
\026\000\019\003\026\000\022\003\026\000\023\003\036\003\040\003\
\041\003\010\000\010\000\010\000\010\000\026\000\026\000\026\000\
\049\003\242\000\010\000\050\003\058\003\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\061\003\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\046\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\046\000\160\000\
\010\000\062\003\064\003\202\000\198\002\026\000\010\000\067\003\
\046\000\072\003\016\000\242\000\074\003\087\003\075\003\010\000\
\082\003\010\000\010\000\010\000\110\002\010\000\010\000\010\000\
\084\003\026\000\203\000\088\003\089\003\091\003\010\000\093\003\
\010\000\145\002\049\000\026\000\099\003\204\000\103\003\056\001\
\104\003\002\002\097\000\164\000\010\000\010\002\010\000\133\001\
\010\000\010\000\010\000\177\000\165\000\026\001\006\002\010\000\
\106\001\170\000\163\001\161\001\010\000\132\001\105\001\166\000\
\038\000\005\002\038\000\169\000\038\000\172\001\038\000\004\002\
\173\001\171\001\160\000\159\002\038\000\059\000\202\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\065\002\242\000\127\000\
\162\001\246\002\053\001\141\002\082\002\203\000\187\002\059\003\
\038\003\102\003\208\002\142\001\242\000\213\002\242\000\202\002\
\204\000\107\002\218\002\037\003\225\002\249\000\119\002\129\000\
\096\000\051\000\132\000\051\000\242\000\051\000\090\001\051\000\
\014\003\242\000\252\002\051\000\051\000\051\000\230\000\005\003\
\051\000\051\000\051\000\051\000\051\000\051\000\051\000\051\000\
\051\000\051\000\051\000\051\000\051\000\051\000\051\000\051\000\
\051\000\051\000\051\000\051\000\051\000\051\000\051\000\038\000\
\049\002\242\000\098\003\041\000\080\002\109\000\000\000\044\000\
\097\003\000\000\127\000\000\000\242\000\000\000\000\000\000\000\
\045\000\000\000\000\000\038\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\053\000\038\000\054\000\000\000\
\055\000\056\000\000\000\000\000\000\000\132\000\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\000\000\
\000\000\000\000\044\000\000\000\000\000\127\000\242\000\000\000\
\051\000\000\000\000\000\045\000\000\000\000\000\000\000\000\000\
\000\000\000\000\045\000\000\000\000\000\000\000\000\000\053\000\
\000\000\054\000\000\000\055\000\051\000\000\000\000\000\000\000\
\132\000\000\000\000\000\000\000\000\000\000\000\051\000\000\000\
\000\000\000\000\000\000\242\000\242\000\000\000\000\000\000\000\
\000\000\242\000\229\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\
\016\000\016\000\016\000\000\000\000\000\000\000\000\000\000\000\
\016\000\242\000\000\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\000\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\242\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\000\000\000\000\016\000\000\000\
\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\016\000\000\000\016\000\
\016\000\016\000\000\000\016\000\016\000\016\000\000\000\000\000\
\000\000\000\000\000\000\060\001\016\000\000\000\016\000\060\001\
\060\001\000\000\136\001\060\001\000\000\000\000\060\001\000\000\
\000\000\000\000\016\000\000\000\016\000\000\000\016\000\016\000\
\016\000\060\001\000\000\000\000\230\000\016\000\060\001\230\000\
\230\000\230\000\016\000\230\000\230\000\230\000\000\000\230\000\
\000\000\060\001\000\000\230\000\230\000\230\000\000\000\000\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\000\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\000\000\000\000\000\000\060\001\000\000\000\000\047\000\060\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\230\000\000\000\230\000\000\000\230\000\
\230\000\000\000\000\000\060\001\230\000\045\000\060\001\045\000\
\230\000\045\000\000\000\045\000\000\000\060\001\109\001\000\000\
\000\000\045\000\000\000\000\000\045\000\045\000\045\000\045\000\
\045\000\045\000\000\000\230\000\230\000\000\000\000\000\230\000\
\229\000\000\000\000\000\229\000\229\000\229\000\230\000\229\000\
\229\000\229\000\000\000\229\000\000\000\000\000\000\000\229\000\
\229\000\229\000\000\000\000\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\000\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\045\000\000\000\043\000\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\229\000\
\045\000\229\000\000\000\229\000\229\000\000\000\000\000\000\000\
\229\000\000\000\045\000\000\000\229\000\000\000\000\000\000\000\
\000\000\000\000\089\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\229\000\
\229\000\000\000\000\000\229\000\000\000\000\000\000\000\000\000\
\136\001\000\000\229\000\136\001\136\001\136\001\000\000\136\001\
\136\001\136\001\000\000\136\001\000\000\000\000\000\000\136\001\
\136\001\136\001\000\000\000\000\136\001\136\001\136\001\136\001\
\136\001\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\136\001\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\136\001\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\000\000\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\136\001\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\136\001\136\001\136\001\136\001\023\001\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\136\001\
\000\000\136\001\000\000\136\001\136\001\000\000\000\000\000\000\
\136\001\047\000\000\000\047\000\136\001\047\000\094\000\047\000\
\000\000\000\000\000\000\000\000\000\000\047\000\000\000\000\000\
\047\000\047\000\047\000\047\000\047\000\000\000\000\000\136\001\
\136\001\000\000\000\000\136\001\109\001\000\000\000\000\109\001\
\109\001\109\001\136\001\109\001\109\001\109\001\000\000\109\001\
\000\000\000\000\000\000\109\001\109\001\109\001\012\000\000\000\
\109\001\109\001\109\001\109\001\109\001\109\001\109\001\109\001\
\109\001\109\001\109\001\109\001\109\001\109\001\109\001\109\001\
\109\001\109\001\109\001\109\001\109\001\109\001\109\001\109\001\
\109\001\109\001\109\001\109\001\000\000\109\001\109\001\109\001\
\109\001\109\001\109\001\109\001\109\001\109\001\109\001\109\001\
\109\001\109\001\109\001\109\001\109\001\109\001\109\001\109\001\
\047\000\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\109\001\047\000\109\001\000\000\109\001\
\109\001\043\000\000\000\043\000\109\001\043\000\047\000\043\000\
\109\001\000\000\000\000\000\000\000\000\043\000\000\000\000\000\
\043\000\043\000\043\000\043\000\043\000\043\000\043\000\043\000\
\043\000\043\000\167\000\109\001\109\001\000\000\000\000\109\001\
\000\000\000\000\000\000\000\000\089\000\089\000\109\001\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\095\000\000\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\245\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\043\000\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\000\000\000\000\000\000\000\000\043\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\043\000\000\000\
\000\000\000\000\000\000\000\000\089\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\168\000\000\000\
\089\000\000\000\000\000\000\000\167\000\000\000\000\000\000\000\
\094\000\094\000\089\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\000\000\000\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\000\000\
\012\000\012\000\000\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\057\000\000\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\056\000\000\000\000\000\000\000\
\094\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\094\000\000\000\000\000\000\000\
\168\000\000\000\000\000\000\000\000\000\000\000\094\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\012\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\012\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\095\000\095\000\012\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\000\000\000\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\245\000\058\000\245\000\245\000\245\000\
\000\000\245\000\000\000\000\000\000\000\245\000\245\000\245\000\
\000\000\000\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\000\000\028\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\001\000\000\000\000\001\001\002\001\000\000\
\000\000\000\000\000\000\000\000\095\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\095\000\000\000\000\000\000\000\000\000\034\000\000\000\000\000\
\000\000\000\000\095\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\245\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\034\000\035\000\036\000\037\000\245\000\000\000\
\000\000\000\000\000\000\000\000\035\000\000\000\000\000\000\000\
\245\000\057\000\000\000\057\000\000\000\057\000\000\000\057\000\
\000\000\000\000\000\000\057\000\057\000\057\000\043\000\000\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\057\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\057\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\056\000\
\000\000\056\000\000\000\056\000\000\000\056\000\000\000\000\000\
\000\000\056\000\056\000\056\000\000\000\048\000\056\000\056\000\
\056\000\056\000\056\000\056\000\056\000\056\000\056\000\056\000\
\056\000\056\000\056\000\056\000\056\000\056\000\056\000\056\000\
\056\000\056\000\056\000\056\000\056\000\036\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\057\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\037\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\057\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\057\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\056\000\000\000\
\000\000\000\000\000\000\039\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\058\000\
\000\000\058\000\056\000\058\000\000\000\058\000\000\000\000\000\
\000\000\058\000\058\000\058\000\056\000\000\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\058\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\058\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\028\000\000\000\028\000\
\000\000\028\000\040\000\028\000\000\000\000\000\000\000\000\000\
\000\000\028\000\000\000\000\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\000\000\000\000\000\000\000\000\000\000\
\034\000\000\000\034\000\083\001\034\000\000\000\034\000\000\000\
\044\000\000\000\000\000\000\000\034\000\000\000\058\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\000\000\058\000\000\000\000\000\000\000\000\000\035\000\
\000\000\035\000\000\000\035\000\058\000\035\000\041\000\000\000\
\000\000\000\000\000\000\035\000\028\000\000\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\028\000\000\000\000\000\000\000\000\000\000\000\
\229\001\000\000\000\000\000\000\000\000\000\000\000\000\034\000\
\048\000\000\000\048\000\229\001\048\000\229\001\048\000\000\000\
\000\000\000\000\000\000\000\000\048\000\000\000\000\000\048\000\
\048\000\048\000\048\000\034\000\000\000\000\000\000\000\000\000\
\036\000\000\000\036\000\000\000\036\000\034\000\036\000\000\000\
\000\000\229\001\000\000\000\000\036\000\000\000\035\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\037\000\
\000\000\037\000\035\000\037\000\148\000\037\000\000\000\000\000\
\000\000\000\000\083\001\037\000\035\000\000\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\039\000\000\000\
\039\000\000\000\039\000\000\000\039\000\000\000\000\000\048\000\
\000\000\000\000\039\000\000\000\000\000\039\000\039\000\039\000\
\039\000\039\000\039\000\039\000\039\000\039\000\039\000\039\000\
\039\000\039\000\039\000\048\000\000\000\000\000\000\000\036\000\
\083\001\000\000\000\000\000\000\000\000\048\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\036\000\000\000\040\000\000\000\040\000\
\000\000\040\000\000\000\040\000\000\000\036\000\037\000\000\000\
\000\000\040\000\000\000\000\000\040\000\040\000\040\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\040\000\
\040\000\040\000\037\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\037\000\039\000\000\000\000\000\
\000\000\000\000\036\001\044\000\037\001\044\000\000\000\044\000\
\000\000\044\000\000\000\038\001\000\000\000\000\000\000\044\000\
\000\000\039\000\044\000\044\000\044\000\044\000\044\000\044\000\
\044\000\044\000\000\000\039\000\000\000\229\001\229\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\041\000\000\000\041\000\000\000\041\000\000\000\041\000\
\000\000\000\000\000\000\000\000\040\000\041\000\000\000\000\000\
\041\000\041\000\041\000\041\000\041\000\041\000\041\000\041\000\
\041\000\041\000\041\000\041\000\041\000\041\000\000\000\000\000\
\040\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\040\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\057\000\000\000\000\000\000\000\
\000\000\000\000\044\000\000\000\000\000\083\001\000\000\000\000\
\172\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\044\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\044\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\041\000\148\000\148\000\148\000\148\000\148\000\000\000\000\000\
\000\000\148\000\148\000\000\000\148\000\148\000\148\000\000\000\
\148\000\148\000\000\000\000\000\041\000\000\000\000\000\148\000\
\148\000\000\000\000\000\000\000\148\000\148\000\041\000\000\000\
\148\000\170\000\148\000\000\000\000\000\148\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\148\000\148\000\
\148\000\000\000\000\000\000\000\000\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\000\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\000\000\
\000\000\148\000\148\000\148\000\000\000\148\000\148\000\148\000\
\000\000\000\000\148\000\000\000\000\000\000\000\148\000\000\000\
\148\000\000\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\000\000\148\000\148\000\000\000\148\000\000\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\036\001\148\000\037\001\000\000\036\001\036\001\037\001\037\001\
\036\001\038\001\037\001\000\000\000\001\038\001\038\001\001\001\
\000\000\038\001\000\000\000\000\000\000\036\001\036\001\037\001\
\037\001\000\000\000\000\036\001\000\000\037\001\038\001\038\001\
\000\000\000\000\000\000\000\000\038\001\000\000\036\001\000\000\
\037\001\000\000\000\000\000\000\000\000\000\000\000\000\038\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\000\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\000\000\160\000\000\000\
\000\000\000\000\202\000\000\000\034\000\035\000\036\000\037\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\009\000\110\002\010\000\011\000\000\000\000\000\
\036\001\203\000\037\001\000\000\000\000\000\000\000\000\000\000\
\043\000\038\001\000\000\000\000\204\000\000\000\000\000\000\000\
\012\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\036\001\000\000\037\001\036\001\000\000\037\001\000\000\000\000\
\000\000\038\001\000\000\000\000\038\001\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\000\000\000\000\
\000\000\000\000\000\000\044\000\000\000\000\000\127\000\000\000\
\000\000\010\000\011\000\000\000\045\000\000\000\000\000\000\000\
\038\000\039\000\040\000\041\000\000\000\042\000\043\000\044\000\
\053\000\000\000\054\000\000\000\055\000\000\000\000\000\000\000\
\045\000\132\000\046\000\047\000\048\000\049\000\050\000\051\000\
\052\000\000\000\000\000\000\000\053\000\000\000\054\000\000\000\
\055\000\056\000\013\000\014\000\015\000\016\000\017\000\000\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\000\000\000\000\000\000\089\000\090\000\
\091\000\092\000\093\000\000\000\000\000\000\000\094\000\160\000\
\081\001\000\000\011\000\097\000\246\001\169\000\039\000\000\000\
\041\000\000\000\042\000\043\000\099\000\100\000\000\000\000\000\
\000\000\101\000\102\000\000\000\000\000\000\000\000\000\104\000\
\000\000\000\000\105\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\106\000\107\000\108\000\056\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\000\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\122\000\123\000\124\000\125\000\000\000\000\000\039\000\000\000\
\041\000\000\000\042\000\043\000\000\000\000\000\000\000\127\000\
\000\000\000\000\089\000\090\000\091\000\092\000\093\000\000\000\
\000\000\000\000\094\000\160\000\081\001\000\000\011\000\097\000\
\020\002\000\000\000\000\000\000\000\000\000\000\056\000\000\000\
\099\000\100\000\132\000\133\000\000\000\101\000\102\000\000\000\
\000\000\000\000\225\001\104\000\000\000\000\000\105\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\106\000\
\107\000\108\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\000\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\122\000\123\000\124\000\125\000\
\000\000\000\000\039\000\000\000\041\000\000\000\042\000\043\000\
\000\000\000\000\000\000\127\000\000\000\000\000\089\000\090\000\
\091\000\092\000\093\000\000\000\000\000\000\000\094\000\160\000\
\081\001\000\000\011\000\097\000\137\002\000\000\000\000\000\000\
\000\000\000\000\056\000\000\000\099\000\100\000\132\000\133\000\
\000\000\101\000\102\000\000\000\000\000\000\000\225\001\104\000\
\000\000\000\000\105\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\106\000\107\000\108\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\000\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\122\000\123\000\124\000\125\000\000\000\000\000\039\000\000\000\
\041\000\000\000\042\000\043\000\000\000\000\000\000\000\127\000\
\000\000\000\000\089\000\090\000\091\000\092\000\093\000\000\000\
\000\000\000\000\094\000\160\000\081\001\000\000\011\000\097\000\
\139\002\000\000\000\000\000\000\000\000\000\000\056\000\000\000\
\099\000\100\000\132\000\133\000\000\000\101\000\102\000\000\000\
\000\000\000\000\225\001\104\000\000\000\000\000\105\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\106\000\
\107\000\108\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\000\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\122\000\123\000\124\000\125\000\
\000\000\000\000\039\000\000\000\041\000\000\000\042\000\043\000\
\000\000\000\000\000\000\127\000\000\000\000\000\089\000\090\000\
\091\000\092\000\093\000\000\000\000\000\000\000\094\000\160\000\
\081\001\000\000\011\000\097\000\000\000\000\000\000\000\000\000\
\000\000\000\000\056\000\000\000\099\000\100\000\132\000\133\000\
\000\000\101\000\102\000\000\000\000\000\000\000\225\001\104\000\
\000\000\000\000\105\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\106\000\107\000\108\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\000\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\122\000\123\000\124\000\125\000\000\000\000\000\039\000\000\000\
\041\000\000\000\042\000\043\000\000\000\000\000\000\000\127\000\
\000\000\000\000\089\000\090\000\091\000\092\000\093\000\000\000\
\000\000\000\000\094\000\160\000\081\001\000\000\011\000\097\000\
\000\000\000\000\000\000\000\000\000\000\000\000\056\000\000\000\
\099\000\100\000\132\000\133\000\000\000\101\000\102\000\000\000\
\000\000\000\000\116\001\104\000\000\000\000\000\105\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\106\000\
\107\000\108\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\000\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\122\000\123\000\124\000\125\000\
\000\000\000\000\039\000\000\000\041\000\000\000\042\000\043\000\
\000\000\000\000\000\000\127\000\000\000\000\000\089\000\090\000\
\091\000\092\000\093\000\000\000\000\000\000\000\094\000\095\000\
\000\000\010\000\055\001\097\000\000\000\098\000\000\000\000\000\
\000\000\000\000\056\000\000\000\099\000\100\000\132\000\133\000\
\000\000\101\000\102\000\000\000\000\000\103\000\225\001\104\000\
\000\000\000\000\105\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\106\000\107\000\108\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\109\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\110\000\111\000\000\000\112\000\113\000\
\114\000\115\000\102\001\117\000\118\000\119\000\120\000\121\000\
\122\000\123\000\124\000\125\000\000\000\000\000\039\000\103\001\
\041\000\000\000\042\000\043\000\044\000\000\000\000\000\127\000\
\104\001\105\001\000\000\000\000\000\000\045\000\000\000\046\000\
\047\000\048\000\049\000\050\000\051\000\052\000\128\000\000\000\
\000\000\053\000\000\000\054\000\000\000\055\000\056\000\129\000\
\130\000\131\000\132\000\133\000\000\000\000\000\134\000\141\000\
\141\000\141\000\141\000\141\000\000\000\000\000\000\000\141\000\
\141\000\000\000\141\000\141\000\141\000\000\000\141\000\000\000\
\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\
\000\000\000\000\141\000\141\000\000\000\000\000\141\000\000\000\
\141\000\000\000\000\000\141\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\141\000\141\000\141\000\000\000\
\000\000\000\000\000\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\000\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\000\000\000\000\141\000\
\141\000\141\000\000\000\141\000\141\000\141\000\000\000\000\000\
\141\000\000\000\000\000\000\000\164\001\000\000\141\000\000\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\000\000\000\000\141\000\000\000\141\000\000\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\000\000\141\000\
\140\000\140\000\140\000\140\000\140\000\000\000\000\000\000\000\
\140\000\140\000\000\000\140\000\140\000\140\000\000\000\140\000\
\000\000\000\000\000\000\000\000\000\000\000\000\140\000\140\000\
\000\000\000\000\000\000\140\000\140\000\000\000\000\000\140\000\
\000\000\140\000\000\000\000\000\140\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\140\000\140\000\140\000\
\000\000\000\000\000\000\000\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\000\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\000\000\000\000\
\140\000\140\000\140\000\000\000\140\000\140\000\140\000\000\000\
\000\000\140\000\000\000\000\000\000\000\165\001\000\000\140\000\
\000\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\000\000\000\000\140\000\000\000\140\000\000\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\000\000\
\140\000\142\000\142\000\142\000\142\000\142\000\000\000\000\000\
\000\000\142\000\142\000\000\000\142\000\142\000\142\000\000\000\
\142\000\000\000\000\000\000\000\000\000\000\000\000\000\142\000\
\142\000\000\000\000\000\000\000\142\000\142\000\000\000\000\000\
\142\000\000\000\142\000\000\000\000\000\142\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\142\000\142\000\
\142\000\000\000\000\000\000\000\000\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\000\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\000\000\
\000\000\142\000\142\000\142\000\000\000\142\000\142\000\142\000\
\000\000\000\000\142\000\000\000\000\000\000\000\169\001\000\000\
\142\000\000\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\000\000\000\000\142\000\000\000\142\000\000\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\000\000\142\000\089\000\090\000\091\000\092\000\093\000\000\000\
\000\000\000\000\094\000\095\000\000\000\010\000\055\001\097\000\
\000\000\098\000\000\000\000\000\000\000\000\000\000\000\000\000\
\099\000\100\000\000\000\000\000\000\000\101\000\102\000\000\000\
\000\000\103\000\000\000\104\000\000\000\000\000\105\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\106\000\
\107\000\108\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\109\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\110\000\
\111\000\000\000\112\000\113\000\114\000\115\000\102\001\117\000\
\118\000\119\000\120\000\121\000\122\000\123\000\124\000\125\000\
\000\000\000\000\039\000\103\001\041\000\000\000\042\000\043\000\
\044\000\000\000\000\000\127\000\000\000\105\001\000\000\000\000\
\000\000\045\000\000\000\046\000\047\000\048\000\049\000\050\000\
\051\000\052\000\128\000\000\000\000\000\053\000\000\000\054\000\
\000\000\055\000\056\000\129\000\130\000\131\000\132\000\133\000\
\000\000\000\000\134\000\089\000\090\000\091\000\092\000\093\000\
\000\000\000\000\000\000\094\000\095\000\000\000\010\000\055\001\
\097\000\000\000\098\000\000\000\000\000\000\000\000\000\000\000\
\000\000\099\000\100\000\000\000\000\000\000\000\101\000\102\000\
\000\000\000\000\103\000\000\000\104\000\000\000\000\000\105\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\106\000\107\000\108\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\109\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\110\000\111\000\000\000\112\000\056\001\114\000\115\000\116\000\
\117\000\118\000\119\000\120\000\057\001\122\000\123\000\124\000\
\125\000\000\000\000\000\039\000\126\000\041\000\000\000\042\000\
\043\000\044\000\000\000\000\000\127\000\000\000\000\000\000\000\
\000\000\000\000\045\000\000\000\046\000\047\000\048\000\049\000\
\050\000\051\000\052\000\128\000\000\000\000\000\053\000\000\000\
\054\000\000\000\055\000\056\000\129\000\130\000\131\000\132\000\
\133\000\000\000\000\000\134\000\089\000\090\000\091\000\092\000\
\093\000\000\000\000\000\000\000\094\000\095\000\000\000\000\000\
\055\001\097\000\000\000\098\000\000\000\000\000\000\000\000\000\
\000\000\000\000\099\000\100\000\000\000\000\000\000\000\101\000\
\102\000\000\000\000\000\103\000\000\000\104\000\000\000\000\000\
\105\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\106\000\107\000\108\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\109\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\037\000\110\000\111\000\000\000\112\000\113\000\114\000\115\000\
\116\000\117\000\118\000\119\000\120\000\121\000\122\000\123\000\
\124\000\125\000\000\000\000\000\039\000\126\000\041\000\000\000\
\042\000\043\000\000\000\000\000\000\000\127\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\056\000\129\000\130\000\131\000\
\132\000\133\000\000\000\000\000\134\000\089\000\090\000\091\000\
\092\000\093\000\000\000\000\000\000\000\094\000\095\000\000\000\
\000\000\096\000\097\000\000\000\098\000\000\000\000\000\000\000\
\000\000\000\000\000\000\099\000\100\000\000\000\000\000\000\000\
\101\000\102\000\000\000\000\000\103\000\000\000\104\000\000\000\
\000\000\105\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\106\000\107\000\108\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\109\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\110\000\111\000\000\000\112\000\113\000\114\000\
\115\000\116\000\117\000\118\000\119\000\120\000\121\000\122\000\
\123\000\124\000\125\000\000\000\000\000\000\000\126\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\127\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\046\000\000\000\
\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\129\000\130\000\
\131\000\132\000\133\000\000\000\000\000\134\000\089\000\090\000\
\091\000\092\000\093\000\000\000\000\000\000\000\094\000\095\000\
\000\000\000\000\096\000\097\000\000\000\098\000\000\000\000\000\
\000\000\000\000\000\000\000\000\099\000\100\000\000\000\000\000\
\000\000\101\000\102\000\000\000\000\000\103\000\000\000\104\000\
\000\000\000\000\105\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\106\000\107\000\108\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\109\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\110\000\111\000\000\000\112\000\113\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000\121\000\
\122\000\123\000\124\000\125\000\000\000\000\000\000\000\126\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\127\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\089\000\090\000\091\000\092\000\093\000\128\000\000\000\
\000\000\094\000\160\000\000\000\000\000\011\000\097\000\129\000\
\130\000\131\000\132\000\133\000\000\000\000\000\134\000\099\000\
\100\000\000\000\000\000\000\000\101\000\102\000\000\000\000\000\
\103\000\000\000\104\000\000\000\000\000\105\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\106\000\107\000\
\108\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\000\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\122\000\123\000\124\000\125\000\000\000\
\000\000\039\000\000\000\041\000\000\000\042\000\043\000\000\000\
\000\000\000\000\127\000\000\000\000\000\089\000\090\000\091\000\
\092\000\093\000\000\000\000\000\000\000\094\000\160\000\000\000\
\000\000\011\000\097\000\000\000\000\000\000\000\000\000\000\000\
\000\000\056\000\129\000\099\000\100\000\132\000\133\000\000\000\
\101\000\102\000\000\000\000\000\000\000\000\000\104\000\000\000\
\000\000\105\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\106\000\107\000\108\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\000\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\000\000\
\000\000\000\000\000\000\000\000\032\000\033\000\034\000\035\000\
\036\000\037\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\122\000\
\123\000\124\000\125\000\000\000\000\000\039\000\000\000\041\000\
\000\000\000\000\043\000\000\000\000\000\000\000\127\000\000\000\
\089\000\090\000\091\000\092\000\093\000\000\000\000\000\000\000\
\094\000\066\002\000\000\000\000\181\000\097\000\000\000\067\002\
\198\002\068\002\000\000\069\002\000\000\056\000\099\000\100\000\
\000\000\132\000\133\000\101\000\102\000\000\000\000\000\000\000\
\000\000\104\000\000\000\000\000\105\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\106\000\107\000\108\000\
\000\000\000\000\089\000\090\000\091\000\092\000\093\000\000\000\
\000\000\183\000\094\000\066\002\000\000\000\000\181\000\097\000\
\000\000\067\002\000\003\068\002\000\000\069\002\000\000\000\000\
\099\000\100\000\000\000\000\000\000\000\101\000\102\000\000\000\
\000\000\000\000\000\000\104\000\000\000\000\000\105\000\000\000\
\000\000\000\000\122\000\123\000\124\000\125\000\000\000\106\000\
\107\000\108\000\000\000\000\000\000\000\000\000\021\001\000\000\
\000\000\127\000\000\000\183\000\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\000\000\000\000\000\000\000\000\132\000\133\000\000\000\000\000\
\000\000\000\000\000\000\000\000\122\000\123\000\124\000\125\000\
\089\000\090\000\091\000\092\000\093\000\000\000\000\000\000\000\
\094\000\066\002\000\000\127\000\181\000\097\000\000\000\067\002\
\000\000\068\002\000\000\069\002\000\000\000\000\099\000\100\000\
\000\000\000\000\000\000\101\000\102\000\000\000\000\000\000\000\
\000\000\104\000\000\000\000\000\105\000\000\000\132\000\133\000\
\000\000\000\000\000\000\000\000\000\000\106\000\107\000\108\000\
\000\000\000\000\089\000\090\000\091\000\092\000\093\000\000\000\
\000\000\183\000\094\000\160\000\000\000\000\000\000\000\097\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\099\000\100\000\000\000\000\000\000\000\101\000\102\000\000\000\
\000\000\103\000\000\000\104\000\000\000\000\000\105\000\000\000\
\000\000\000\000\122\000\123\000\124\000\125\000\000\000\106\000\
\107\000\108\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\127\000\254\001\255\001\000\002\001\002\002\002\003\002\
\004\002\005\002\006\002\007\002\008\002\009\002\010\002\011\002\
\012\002\013\002\014\002\015\002\016\002\017\002\000\000\000\000\
\000\000\000\000\000\000\000\000\132\000\133\000\000\000\000\000\
\000\000\000\000\000\000\000\000\122\000\123\000\124\000\125\000\
\089\000\090\000\091\000\092\000\093\000\000\000\000\000\000\000\
\094\000\160\000\000\000\127\000\000\000\097\000\000\000\098\000\
\000\000\000\000\000\000\000\000\000\000\000\000\099\000\100\000\
\000\000\000\000\000\000\101\000\102\000\000\000\000\000\000\000\
\000\000\104\000\000\000\129\000\105\000\000\000\132\000\133\000\
\000\000\000\000\000\000\000\000\000\000\106\000\107\000\108\000\
\000\000\089\000\090\000\091\000\092\000\093\000\000\000\000\000\
\000\000\094\000\160\000\000\000\000\000\000\000\097\000\000\000\
\000\000\000\000\005\001\000\000\000\000\000\000\000\000\099\000\
\100\000\000\000\000\000\000\000\101\000\102\000\000\000\000\000\
\000\000\000\000\104\000\000\000\000\000\105\000\000\000\000\000\
\000\000\000\000\122\000\123\000\124\000\125\000\106\000\107\000\
\108\000\000\000\089\000\090\000\091\000\092\000\093\000\000\000\
\000\000\127\000\094\000\160\000\000\000\000\000\000\000\097\000\
\000\000\000\000\000\000\000\000\034\002\000\000\000\000\000\000\
\099\000\100\000\000\000\000\000\000\000\101\000\102\000\000\000\
\000\000\000\000\000\000\104\000\132\000\133\000\105\000\000\000\
\000\000\000\000\000\000\122\000\123\000\124\000\125\000\106\000\
\107\000\108\000\000\000\089\000\090\000\091\000\092\000\093\000\
\000\000\000\000\127\000\094\000\160\000\000\000\000\000\000\000\
\097\000\000\000\000\000\000\000\000\000\089\002\000\000\000\000\
\000\000\099\000\100\000\000\000\000\000\000\000\101\000\102\000\
\000\000\000\000\000\000\000\000\104\000\132\000\133\000\105\000\
\000\000\000\000\000\000\000\000\122\000\123\000\124\000\125\000\
\106\000\107\000\108\000\000\000\089\000\090\000\091\000\092\000\
\093\000\000\000\000\000\127\000\094\000\160\000\000\000\000\000\
\000\000\097\000\000\000\067\002\000\000\000\000\000\000\000\000\
\000\000\000\000\099\000\100\000\000\000\000\000\000\000\101\000\
\102\000\000\000\000\000\000\000\000\000\104\000\132\000\133\000\
\105\000\000\000\000\000\000\000\000\000\122\000\123\000\124\000\
\125\000\106\000\107\000\108\000\000\000\089\000\090\000\091\000\
\092\000\093\000\000\000\000\000\127\000\094\000\160\000\000\000\
\000\000\000\000\097\000\000\000\158\002\000\000\000\000\000\000\
\000\000\000\000\000\000\099\000\100\000\000\000\000\000\000\000\
\101\000\102\000\000\000\000\000\000\000\000\000\104\000\132\000\
\133\000\105\000\000\000\000\000\000\000\000\000\122\000\123\000\
\124\000\125\000\106\000\107\000\108\000\000\000\089\000\090\000\
\091\000\092\000\093\000\000\000\000\000\127\000\094\000\160\000\
\000\000\000\000\000\000\097\000\000\000\000\000\000\000\000\000\
\166\002\000\000\000\000\000\000\099\000\100\000\000\000\000\000\
\000\000\101\000\102\000\000\000\000\000\000\000\000\000\104\000\
\132\000\133\000\105\000\000\000\000\000\000\000\000\000\122\000\
\123\000\124\000\125\000\106\000\107\000\108\000\000\000\089\000\
\090\000\091\000\092\000\093\000\000\000\000\000\127\000\094\000\
\160\000\000\000\000\000\000\000\097\000\237\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\099\000\100\000\000\000\
\000\000\000\000\101\000\102\000\000\000\000\000\000\000\000\000\
\104\000\132\000\133\000\105\000\000\000\000\000\000\000\000\000\
\122\000\123\000\124\000\125\000\106\000\107\000\108\000\000\000\
\089\000\090\000\091\000\092\000\093\000\000\000\000\000\127\000\
\094\000\160\000\000\000\000\000\000\000\097\000\239\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\099\000\100\000\
\000\000\000\000\000\000\101\000\102\000\000\000\000\000\000\000\
\000\000\104\000\132\000\133\000\105\000\000\000\000\000\000\000\
\000\000\122\000\123\000\124\000\125\000\106\000\107\000\108\000\
\000\000\089\000\090\000\091\000\092\000\093\000\000\000\000\000\
\127\000\094\000\160\000\000\000\000\000\000\000\097\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\099\000\
\100\000\000\000\000\000\000\000\101\000\102\000\000\000\000\000\
\000\000\000\000\104\000\132\000\133\000\105\000\000\000\000\000\
\000\000\000\000\122\000\123\000\124\000\125\000\106\000\107\000\
\108\000\253\001\000\000\000\000\253\001\253\001\253\001\253\001\
\000\000\127\000\000\000\000\000\253\001\058\001\000\000\000\000\
\000\000\058\001\058\001\000\000\000\000\058\001\253\001\253\001\
\058\001\000\000\000\000\000\000\253\001\000\000\000\000\000\000\
\000\000\000\000\000\000\058\001\132\000\133\000\000\000\253\001\
\058\001\000\000\000\000\122\000\123\000\124\000\125\000\000\000\
\000\000\253\001\000\000\058\001\059\001\000\000\000\000\000\000\
\059\001\059\001\127\000\000\000\059\001\061\001\000\000\059\001\
\000\000\061\001\061\001\000\000\000\000\061\001\000\000\000\000\
\061\001\057\001\059\001\000\000\000\000\057\001\057\001\059\001\
\000\000\057\001\000\000\061\001\057\001\132\000\133\000\000\000\
\061\001\000\000\059\001\000\000\000\000\000\000\000\000\057\001\
\000\000\253\001\000\000\061\001\057\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\058\001\000\000\057\001\
\000\000\058\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\253\001\000\000\000\000\253\001\000\000\000\000\000\000\
\000\000\000\000\000\000\253\001\000\000\058\001\000\000\000\000\
\058\001\000\000\000\000\000\000\000\000\000\000\000\000\058\001\
\000\000\000\000\000\000\000\000\059\001\000\000\000\000\000\000\
\059\001\000\000\000\000\000\000\000\000\061\001\000\000\000\000\
\000\000\061\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\057\001\000\000\000\000\059\001\057\001\000\000\059\001\
\000\000\000\000\000\000\000\000\000\000\061\001\059\001\000\000\
\061\001\000\000\255\000\000\000\255\000\255\000\000\000\061\001\
\000\000\057\001\255\000\000\000\057\001\000\000\000\000\255\000\
\000\000\000\000\000\000\057\001\255\000\255\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\255\000\255\000\255\000\255\000\255\000\000\000\
\255\000\255\000\255\000\255\000\255\000\255\000\255\000\255\000\
\255\000\255\000\255\000\255\000\255\000\255\000\255\000\255\000\
\255\000\255\000\255\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\255\000\000\000\255\000\255\000\
\255\000\000\000\255\000\255\000\255\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\255\000\000\000\254\000\
\000\000\254\000\254\000\000\000\000\000\000\000\000\000\254\000\
\000\000\255\000\000\000\255\000\254\000\255\000\255\000\255\000\
\000\000\254\000\254\000\000\000\255\000\000\000\000\000\000\000\
\000\000\255\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\254\000\
\254\000\254\000\254\000\254\000\000\000\254\000\254\000\254\000\
\254\000\254\000\254\000\254\000\254\000\254\000\254\000\254\000\
\254\000\254\000\254\000\254\000\254\000\254\000\254\000\254\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\254\000\000\000\254\000\254\000\254\000\000\000\254\000\
\254\000\254\000\000\000\071\001\000\000\000\000\071\001\071\001\
\000\000\000\000\254\000\071\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\254\000\000\000\
\254\000\071\001\254\000\254\000\254\000\000\000\071\001\000\000\
\000\000\254\000\000\000\000\000\000\000\000\000\254\000\000\000\
\000\000\071\001\000\000\000\000\000\000\000\000\071\001\071\001\
\071\001\071\001\071\001\000\000\071\001\071\001\071\001\071\001\
\071\001\071\001\071\001\071\001\071\001\071\001\071\001\071\001\
\071\001\071\001\071\001\071\001\071\001\071\001\071\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\009\000\000\000\
\000\000\011\000\071\001\000\000\071\001\000\000\071\001\071\001\
\000\000\000\000\000\000\071\001\000\000\000\000\000\000\071\001\
\000\000\000\000\000\000\000\000\143\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\071\001\071\001\000\000\000\000\071\001\000\000\
\055\001\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\000\000\
\000\000\000\000\000\000\000\000\032\000\033\000\034\000\035\000\
\036\000\037\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\039\000\000\000\041\000\
\000\000\000\000\043\000\044\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\045\000\000\000\046\000\047\000\
\048\000\049\000\050\000\051\000\052\000\000\000\000\000\000\000\
\053\000\000\000\054\000\000\000\055\000\056\000\245\000\000\000\
\000\000\245\000\245\000\144\001\000\000\000\000\245\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\013\000\245\000\000\000\000\000\000\000\
\000\000\245\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\245\000\000\000\000\000\000\000\
\000\000\245\000\245\000\245\000\245\000\245\000\000\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\002\000\000\245\000\000\002\245\000\
\000\000\245\000\245\000\000\002\000\000\000\000\245\000\000\000\
\000\002\000\000\245\000\000\000\000\000\000\000\000\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\245\000\245\000\000\000\
\000\000\245\000\000\000\000\002\000\002\000\002\000\002\000\002\
\000\000\000\002\000\002\000\002\000\002\000\002\000\002\000\002\
\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\
\000\002\000\002\000\002\000\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\002\
\000\000\000\002\000\000\000\002\000\002\000\002\000\000\000\000\
\153\001\000\000\000\000\153\001\000\000\000\000\000\002\000\000\
\087\001\000\000\000\000\000\000\000\000\087\001\000\000\000\000\
\000\000\000\000\000\002\087\001\000\002\000\000\000\002\000\002\
\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\153\001\153\001\153\001\153\001\153\001\000\000\153\001\153\001\
\153\001\153\001\153\001\153\001\153\001\153\001\153\001\153\001\
\153\001\153\001\153\001\153\001\153\001\153\001\153\001\153\001\
\153\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\087\001\000\000\153\001\000\000\153\001\000\000\
\153\001\153\001\153\001\000\000\000\000\154\001\000\000\000\000\
\154\001\000\000\000\000\153\001\000\000\089\001\000\000\000\000\
\000\000\000\000\089\001\000\000\000\000\000\000\000\000\153\001\
\089\001\153\001\000\000\153\001\153\001\000\000\000\000\000\000\
\000\000\000\000\153\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\154\001\154\001\154\001\
\154\001\154\001\000\000\154\001\154\001\154\001\154\001\154\001\
\154\001\154\001\154\001\154\001\154\001\154\001\154\001\154\001\
\154\001\154\001\154\001\154\001\154\001\154\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\081\001\000\000\011\000\000\000\082\001\000\000\000\000\089\001\
\000\000\154\001\000\000\154\001\000\000\154\001\154\001\154\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\154\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\154\001\000\000\154\001\000\000\
\154\001\154\001\013\000\014\000\015\000\016\000\017\000\154\001\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\081\001\000\000\011\000\
\000\000\000\000\000\000\000\000\000\000\000\000\039\000\000\000\
\041\000\000\000\042\000\043\000\000\000\000\000\000\000\000\000\
\171\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\056\000\013\000\
\014\000\015\000\016\000\017\000\000\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\000\000\000\000\000\000\000\000\081\001\000\000\011\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\039\000\000\000\041\000\000\000\042\000\
\043\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\056\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\000\000\
\000\000\000\000\000\000\217\001\000\000\217\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\039\000\000\000\041\000\000\000\042\000\043\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\217\001\217\001\217\001\
\217\001\217\001\056\000\217\001\217\001\217\001\217\001\217\001\
\217\001\217\001\217\001\217\001\217\001\217\001\217\001\217\001\
\217\001\217\001\217\001\217\001\217\001\217\001\000\000\000\000\
\000\000\000\000\000\000\010\000\011\000\000\000\000\000\000\000\
\181\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\217\001\000\000\217\001\000\000\217\001\217\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\217\001\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\036\000\037\000\000\000\000\000\000\000\
\000\000\000\000\010\000\011\000\000\000\000\000\000\000\004\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\169\000\
\039\000\000\000\041\000\000\000\042\000\043\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\056\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\000\000\000\000\000\000\000\000\
\000\000\000\000\011\000\000\000\000\000\098\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\169\000\039\000\
\000\000\041\000\000\000\042\000\043\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\056\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\000\
\000\000\000\000\098\000\000\000\000\000\000\000\039\000\000\000\
\041\000\000\000\042\000\043\000\044\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\045\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\053\000\000\000\054\000\000\000\055\000\056\000\013\000\
\014\000\015\000\016\000\017\000\000\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\000\000\000\000\000\000\000\000\000\000\000\000\011\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\039\000\000\000\041\000\000\000\042\000\
\043\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\056\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\000\000\
\000\000\000\000\000\000\000\000\000\000\011\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\039\000\000\000\041\000\000\000\042\000\043\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\056\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\000\000\000\000\000\000\000\000\111\000\
\032\000\033\000\034\000\035\000\036\000\037\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\039\000\000\000\041\000\000\000\000\000\043\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\111\000\111\000\111\000\111\000\000\000\111\000\111\000\111\000\
\111\000\111\000\111\000\111\000\111\000\000\000\000\000\000\000\
\000\000\056\000\111\000\111\000\111\000\111\000\111\000\111\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\111\000\000\000\111\000\000\000\000\000\
\111\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\010\000\000\000\000\000\000\000\010\000\
\000\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\000\000\000\000\111\000\012\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\011\000\000\000\000\000\000\000\011\000\000\000\
\011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
\000\000\000\000\000\000\014\000\011\000\011\000\011\000\011\000\
\011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
\011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
\011\000\185\000\185\000\185\000\185\000\000\000\000\000\000\000\
\000\000\000\000\185\000\000\000\000\000\185\000\185\000\185\000\
\185\000\185\000\000\000\010\000\000\000\185\000\000\000\185\000\
\185\000\185\000\185\000\185\000\000\000\185\000\000\000\185\000\
\185\000\185\000\185\000\185\000\185\000\185\000\185\000\185\000\
\185\000\185\000\185\000\185\000\185\000\185\000\185\000\185\000\
\185\000\185\000\185\000\185\000\185\000\000\000\000\000\000\000\
\000\000\000\000\011\000\181\000\181\000\181\000\181\000\000\000\
\000\000\000\000\000\000\000\000\181\000\000\000\000\000\181\000\
\181\000\181\000\181\000\181\000\000\000\000\000\000\000\181\000\
\185\000\181\000\181\000\181\000\181\000\181\000\185\000\181\000\
\000\000\181\000\181\000\181\000\181\000\181\000\181\000\181\000\
\181\000\181\000\181\000\181\000\181\000\181\000\181\000\181\000\
\181\000\181\000\181\000\181\000\181\000\181\000\181\000\000\000\
\000\000\000\000\000\000\000\000\000\000\168\001\169\001\170\001\
\171\001\000\000\000\000\000\000\000\000\000\000\172\001\000\000\
\000\000\173\001\174\001\175\001\176\001\177\001\000\000\000\000\
\000\000\178\001\181\000\179\001\180\001\181\001\182\001\183\001\
\181\000\184\001\000\000\185\001\000\000\186\001\187\001\188\001\
\189\001\190\001\191\001\192\001\193\001\194\001\195\001\196\001\
\197\001\198\001\199\001\200\001\201\001\202\001\203\001\204\001\
\205\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\010\000\000\000\000\000\010\000\010\000\000\000\010\000\010\000\
\010\000\010\000\010\000\000\000\206\001\010\000\000\000\000\000\
\000\000\005\000\207\001\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000"

let yycheck = "\003\000\
\036\000\003\000\002\000\002\000\071\000\149\000\002\000\071\000\
\193\000\002\000\004\000\208\000\008\000\002\000\136\001\140\001\
\071\000\002\000\000\000\008\000\076\001\002\000\168\000\008\000\
\075\001\157\000\005\000\034\000\035\000\018\001\209\001\105\002\
\000\000\081\000\000\000\014\001\120\000\085\001\010\000\148\001\
\008\001\050\002\078\000\008\001\188\000\000\000\136\001\145\000\
\244\000\097\000\019\001\164\000\165\000\166\000\096\001\041\001\
\025\001\098\002\125\000\021\001\020\001\193\000\139\001\009\001\
\141\001\019\001\052\001\113\000\223\002\019\001\035\001\025\001\
\014\001\157\000\130\001\025\001\212\002\062\001\030\001\167\001\
\019\001\081\000\130\001\018\001\018\001\081\000\025\001\019\001\
\064\001\103\001\076\001\077\001\081\000\025\001\192\000\018\001\
\081\000\025\001\025\001\062\001\102\001\185\000\021\001\097\000\
\253\002\036\001\018\001\035\001\036\001\222\000\018\001\110\000\
\116\000\018\001\116\000\101\001\120\000\103\001\025\001\133\001\
\062\001\009\001\021\001\040\003\041\003\119\000\021\001\253\002\
\036\001\036\001\113\000\110\001\134\001\109\001\222\001\202\000\
\035\003\114\001\202\000\237\000\186\000\208\000\077\001\077\001\
\123\000\114\001\026\003\133\001\013\001\018\001\015\001\031\003\
\207\000\157\000\077\001\157\000\030\001\255\000\137\001\226\000\
\077\003\157\000\139\001\000\000\157\000\053\001\145\000\176\002\
\157\000\210\002\138\001\226\000\157\000\138\001\134\001\144\001\
\217\002\139\001\043\001\227\000\228\000\185\000\134\001\114\001\
\050\002\164\000\165\000\166\000\064\001\193\000\144\001\193\000\
\168\000\086\003\144\001\114\001\007\001\193\000\088\001\193\000\
\193\000\124\002\020\003\186\000\193\000\144\001\134\001\134\001\
\193\000\097\001\030\001\029\003\144\001\192\000\014\001\114\001\
\086\003\045\001\046\001\114\001\139\001\111\001\222\000\212\001\
\018\001\099\001\021\001\134\001\228\000\222\000\083\002\227\000\
\084\002\109\001\210\000\005\000\064\001\209\000\227\000\039\002\
\139\001\222\000\227\000\222\000\139\001\037\002\240\000\039\002\
\244\000\253\000\045\002\253\000\246\000\247\000\040\002\244\000\
\250\000\253\000\237\000\244\000\113\002\018\001\090\001\097\002\
\034\000\035\000\056\001\101\002\253\000\113\001\018\001\025\001\
\018\001\213\001\214\001\025\001\255\000\088\001\018\001\099\001\
\088\001\109\001\036\001\021\001\074\001\142\001\036\001\108\002\
\109\002\018\001\236\001\143\002\010\001\019\001\012\001\028\002\
\153\001\045\001\046\001\049\002\111\001\093\002\023\001\111\001\
\018\001\192\000\044\001\019\001\022\001\019\001\197\000\234\002\
\111\001\034\001\073\002\025\001\064\001\030\001\064\001\114\001\
\019\001\023\001\072\002\025\001\064\001\136\001\025\001\064\001\
\014\001\056\001\014\001\064\001\018\001\117\001\018\001\064\001\
\005\000\148\001\022\001\129\001\148\001\113\001\090\001\212\002\
\139\001\019\001\105\002\074\001\236\001\148\001\019\001\025\001\
\014\001\073\001\102\001\154\001\102\001\223\002\223\001\224\001\
\045\002\109\001\078\001\109\001\217\002\139\001\035\001\014\001\
\088\001\109\001\017\001\002\001\109\001\063\002\185\001\145\000\
\109\001\169\002\105\001\014\001\109\001\140\001\013\001\018\001\
\015\001\016\001\099\001\034\001\019\001\020\001\211\002\111\001\
\136\001\110\001\164\000\165\000\166\000\087\002\142\001\158\002\
\014\001\018\001\129\001\017\001\114\001\142\001\020\001\018\001\
\178\000\153\001\018\001\127\001\043\001\026\003\134\001\114\001\
\153\001\142\001\031\003\142\001\014\001\211\001\192\000\017\001\
\110\001\072\001\110\001\018\001\153\001\162\002\153\001\063\002\
\025\001\014\001\144\001\034\001\035\001\018\001\019\001\025\001\
\210\000\022\001\000\000\036\001\025\001\144\001\099\000\100\000\
\062\001\199\002\036\001\137\001\222\000\137\001\014\001\087\002\
\035\001\008\001\018\001\025\001\025\003\108\001\022\001\014\001\
\212\001\215\002\212\001\237\000\062\001\122\000\036\001\022\001\
\212\001\019\001\014\001\110\001\145\000\014\001\050\002\025\001\
\017\001\041\001\018\001\212\001\211\001\255\000\022\001\019\001\
\043\002\035\001\045\002\043\002\052\001\025\001\232\001\164\000\
\165\000\166\000\246\001\237\001\090\001\191\002\137\001\236\002\
\038\002\041\001\019\001\001\003\139\001\140\001\141\001\062\001\
\025\001\029\001\030\001\052\001\052\001\207\002\052\002\192\002\
\054\002\020\001\035\001\192\000\022\001\062\001\024\001\018\001\
\023\001\110\001\025\001\022\001\030\001\114\001\068\002\027\002\
\028\002\027\002\028\002\018\001\083\002\210\000\097\002\027\002\
\028\002\069\002\101\002\083\002\018\001\044\002\110\001\195\002\
\196\002\222\000\027\002\028\002\137\001\201\002\050\002\191\002\
\014\001\018\001\050\002\144\001\018\001\022\001\018\001\038\002\
\237\000\056\002\113\002\055\002\192\002\110\001\134\001\207\002\
\036\002\137\001\055\002\043\002\014\001\052\002\055\002\054\002\
\018\001\019\001\255\000\041\001\022\001\019\001\019\001\035\001\
\223\001\224\001\036\001\025\001\025\001\068\002\052\001\019\001\
\137\001\036\001\073\002\000\000\176\002\025\001\021\001\041\001\
\107\001\014\001\025\001\134\001\017\001\101\002\025\001\020\001\
\111\002\116\001\052\001\014\001\134\001\025\001\136\001\099\000\
\100\000\042\000\030\001\020\001\142\001\128\001\020\001\130\001\
\036\001\132\001\105\002\019\001\128\002\019\001\128\002\153\001\
\114\001\025\001\134\002\135\002\061\000\116\002\122\000\034\001\
\035\001\131\002\132\002\133\002\069\000\070\000\014\001\019\001\
\110\001\062\001\018\001\076\000\131\001\025\001\022\001\155\002\
\156\002\036\001\014\001\019\001\223\002\017\001\162\002\223\002\
\162\002\025\001\217\002\142\002\110\001\018\001\162\002\014\001\
\134\001\041\001\017\001\137\001\176\002\020\001\170\002\158\002\
\176\002\162\002\126\001\127\001\052\001\170\002\020\001\099\001\
\183\002\170\002\011\001\019\001\192\002\019\001\192\002\137\001\
\000\000\025\001\009\001\025\001\192\002\084\002\192\002\192\002\
\014\001\014\001\062\001\192\002\018\001\019\001\091\001\192\002\
\022\001\134\001\019\001\025\001\195\002\196\002\018\001\062\001\
\014\001\142\001\201\002\000\000\018\001\108\002\109\002\223\002\
\035\003\019\001\016\003\035\003\153\001\022\001\019\001\025\001\
\236\002\237\002\236\002\239\002\025\001\231\002\110\001\019\001\
\236\002\113\000\225\002\041\001\000\000\025\001\023\001\251\002\
\025\001\251\002\110\001\236\002\124\000\019\001\052\001\018\001\
\143\002\019\001\019\001\025\001\134\002\135\002\019\001\014\001\
\025\001\137\001\017\001\010\003\025\001\020\001\157\002\023\001\
\019\001\011\003\044\002\147\000\018\001\137\001\025\001\018\001\
\019\001\155\002\156\002\022\001\018\001\119\001\120\001\018\001\
\022\001\016\003\024\001\035\003\026\001\027\001\028\001\035\001\
\110\001\045\003\019\001\047\003\114\001\049\003\041\001\019\001\
\025\001\053\003\054\003\035\001\021\001\025\001\020\001\062\001\
\110\001\052\001\186\000\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\019\001\137\001\211\002\212\002\019\001\019\001\
\025\001\019\001\144\001\101\002\025\001\025\001\019\001\025\001\
\019\001\019\001\019\001\137\001\025\001\111\002\025\001\025\001\
\025\001\019\001\025\001\095\003\096\003\095\003\096\003\019\001\
\022\001\025\001\024\001\103\003\026\001\103\003\001\000\002\000\
\003\000\004\000\005\000\237\002\030\001\239\002\019\001\019\001\
\021\001\019\001\023\001\114\001\025\001\000\000\145\001\019\001\
\114\001\008\003\031\001\018\001\018\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\021\001\
\110\001\024\001\025\003\026\003\036\001\018\001\035\001\145\001\
\031\003\052\001\053\001\054\001\055\001\056\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\019\001\045\003\019\001\047\003\000\000\049\003\
\019\001\023\001\035\001\053\003\054\003\021\001\036\001\018\001\
\056\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\074\001\091\001\035\001\114\001\025\001\018\001\
\023\001\036\001\035\001\019\001\099\003\021\001\014\001\023\001\
\020\001\025\001\014\001\035\001\019\001\023\001\036\001\031\001\
\019\001\134\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\105\001\018\001\144\001\025\001\019\001\019\001\018\001\
\021\001\021\001\023\001\036\001\025\001\019\001\036\001\014\001\
\014\001\005\001\006\001\007\001\008\001\034\001\035\001\036\001\
\084\001\129\001\014\001\036\001\023\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\019\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\114\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\134\001\014\001\
\084\001\114\001\025\001\018\001\021\001\114\001\090\001\019\001\
\144\001\036\001\000\000\211\001\036\001\021\001\036\001\099\001\
\036\001\101\001\102\001\103\001\035\001\105\001\106\001\107\001\
\084\001\134\001\041\001\019\001\008\001\023\001\114\001\036\001\
\116\001\233\001\121\001\144\001\018\001\052\001\127\001\139\001\
\019\001\036\001\009\001\036\001\128\001\000\000\130\001\021\001\
\132\001\133\001\134\001\036\001\036\001\019\001\035\001\139\001\
\021\001\019\001\114\001\114\001\144\001\021\001\021\001\036\001\
\019\001\035\001\021\001\019\001\023\001\114\001\025\001\114\001\
\114\001\114\001\014\001\019\002\031\001\002\000\018\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\104\001\038\002\110\001\
\232\000\142\002\149\000\225\001\116\001\041\001\057\002\010\003\
\229\002\099\003\090\002\221\000\052\002\101\002\054\002\075\002\
\052\001\142\001\107\002\225\002\115\002\014\001\153\001\134\001\
\017\001\019\001\137\001\021\001\068\002\023\001\184\000\025\001\
\192\002\073\002\152\002\029\001\030\001\031\001\000\000\174\002\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\114\001\
\090\001\105\002\086\003\103\001\114\001\062\001\255\255\107\001\
\085\003\255\255\110\001\255\255\116\002\255\255\255\255\255\255\
\116\001\255\255\255\255\134\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\128\001\144\001\130\001\255\255\
\132\001\133\001\255\255\255\255\255\255\137\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\107\001\255\255\255\255\110\001\158\002\255\255\
\114\001\255\255\255\255\116\001\255\255\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\255\255\255\255\128\001\
\255\255\130\001\255\255\132\001\134\001\255\255\255\255\255\255\
\137\001\255\255\255\255\255\255\255\255\255\255\144\001\255\255\
\255\255\255\255\255\255\195\002\196\002\255\255\255\255\255\255\
\255\255\201\002\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\255\255\255\255\255\255\255\255\255\255\
\014\001\225\002\255\255\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\255\255\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\016\003\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\084\001\255\255\
\255\255\255\255\255\255\255\255\090\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\099\001\255\255\101\001\
\102\001\103\001\255\255\105\001\106\001\107\001\255\255\255\255\
\255\255\255\255\255\255\014\001\114\001\255\255\116\001\018\001\
\019\001\255\255\000\000\022\001\255\255\255\255\025\001\255\255\
\255\255\255\255\128\001\255\255\130\001\255\255\132\001\133\001\
\134\001\036\001\255\255\255\255\014\001\139\001\041\001\017\001\
\018\001\019\001\144\001\021\001\022\001\023\001\255\255\025\001\
\255\255\052\001\255\255\029\001\030\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\110\001\255\255\255\255\000\000\114\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\101\001\255\255\103\001\255\255\105\001\
\106\001\255\255\255\255\134\001\110\001\019\001\137\001\021\001\
\114\001\023\001\255\255\025\001\255\255\144\001\000\000\255\255\
\255\255\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\255\255\133\001\134\001\255\255\255\255\137\001\
\014\001\255\255\255\255\017\001\018\001\019\001\144\001\021\001\
\022\001\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\114\001\255\255\000\000\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\101\001\
\134\001\103\001\255\255\105\001\106\001\255\255\255\255\255\255\
\110\001\255\255\144\001\255\255\114\001\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\133\001\
\134\001\255\255\255\255\137\001\255\255\255\255\255\255\255\255\
\014\001\255\255\144\001\017\001\018\001\019\001\255\255\021\001\
\022\001\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\101\001\
\255\255\103\001\255\255\105\001\106\001\255\255\255\255\255\255\
\110\001\019\001\255\255\021\001\114\001\023\001\000\000\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\255\255\255\255\133\001\
\134\001\255\255\255\255\137\001\014\001\255\255\255\255\017\001\
\018\001\019\001\144\001\021\001\022\001\023\001\255\255\025\001\
\255\255\255\255\255\255\029\001\030\001\031\001\000\000\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\114\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\101\001\134\001\103\001\255\255\105\001\
\106\001\019\001\255\255\021\001\110\001\023\001\144\001\025\001\
\114\001\255\255\255\255\255\255\255\255\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\008\001\133\001\134\001\255\255\255\255\137\001\
\255\255\255\255\255\255\255\255\018\001\019\001\144\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\000\000\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\000\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\114\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\255\255\134\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\144\001\255\255\
\255\255\255\255\255\255\255\255\114\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\008\001\255\255\
\134\001\255\255\255\255\255\255\138\001\255\255\255\255\255\255\
\018\001\019\001\144\001\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\018\001\019\001\255\255\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\000\000\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\114\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\134\001\255\255\255\255\255\255\
\138\001\255\255\255\255\255\255\255\255\255\255\144\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\114\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\134\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\018\001\019\001\144\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\019\001\000\000\021\001\022\001\023\001\
\255\255\025\001\255\255\255\255\255\255\029\001\030\001\031\001\
\255\255\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\014\001\255\255\255\255\017\001\018\001\255\255\
\255\255\255\255\255\255\255\255\114\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\134\001\255\255\255\255\255\255\255\255\000\000\255\255\255\255\
\255\255\255\255\144\001\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\114\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\078\001\079\001\080\001\081\001\134\001\255\255\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\144\001\019\001\255\255\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\029\001\030\001\031\001\106\001\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\255\255\029\001\030\001\031\001\255\255\000\000\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\000\000\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\114\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\134\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\144\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\114\001\255\255\
\255\255\255\255\255\255\000\000\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\019\001\
\255\255\021\001\134\001\023\001\255\255\025\001\255\255\255\255\
\255\255\029\001\030\001\031\001\144\001\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\019\001\255\255\021\001\
\255\255\023\001\000\000\025\001\255\255\255\255\255\255\255\255\
\255\255\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\255\255\
\019\001\255\255\021\001\173\000\023\001\255\255\025\001\255\255\
\000\000\255\255\255\255\255\255\031\001\255\255\114\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\255\255\134\001\255\255\255\255\255\255\255\255\019\001\
\255\255\021\001\255\255\023\001\144\001\025\001\000\000\255\255\
\255\255\255\255\255\255\031\001\114\001\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\134\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\144\001\255\255\255\255\255\255\255\255\255\255\
\002\001\255\255\255\255\255\255\255\255\255\255\255\255\114\001\
\019\001\255\255\021\001\013\001\023\001\015\001\025\001\255\255\
\255\255\255\255\255\255\255\255\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\134\001\255\255\255\255\255\255\255\255\
\019\001\255\255\021\001\255\255\023\001\144\001\025\001\255\255\
\255\255\043\001\255\255\255\255\031\001\255\255\114\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\019\001\
\255\255\021\001\134\001\023\001\000\000\025\001\255\255\255\255\
\255\255\255\255\076\001\031\001\144\001\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\255\255\255\255\114\001\
\255\255\255\255\031\001\255\255\255\255\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\134\001\255\255\255\255\255\255\114\001\
\130\001\255\255\255\255\255\255\255\255\144\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\134\001\255\255\019\001\255\255\021\001\
\255\255\023\001\255\255\025\001\255\255\144\001\114\001\255\255\
\255\255\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\134\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\144\001\114\001\255\255\255\255\
\255\255\255\255\000\000\019\001\000\000\021\001\255\255\023\001\
\255\255\025\001\255\255\000\000\255\255\255\255\255\255\031\001\
\255\255\134\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\255\255\144\001\255\255\223\001\224\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\019\001\255\255\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\114\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\255\255\255\255\
\134\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\144\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\255\255\255\255\114\001\255\255\255\255\039\002\255\255\255\255\
\042\002\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\134\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\144\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\114\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\021\001\255\255\255\255\134\001\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\144\001\255\255\
\036\001\000\000\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\082\001\083\001\
\255\255\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\097\001\098\001\255\255\
\255\255\101\001\102\001\103\001\255\255\105\001\106\001\107\001\
\255\255\255\255\110\001\255\255\255\255\255\255\114\001\255\255\
\116\001\255\255\118\001\119\001\120\001\121\001\122\001\123\001\
\124\001\125\001\255\255\127\001\128\001\255\255\130\001\255\255\
\132\001\133\001\134\001\135\001\136\001\137\001\138\001\139\001\
\014\001\141\001\014\001\255\255\018\001\019\001\018\001\019\001\
\022\001\014\001\022\001\255\255\014\001\018\001\019\001\017\001\
\255\255\022\001\255\255\255\255\255\255\035\001\036\001\035\001\
\036\001\255\255\255\255\041\001\255\255\041\001\035\001\036\001\
\255\255\255\255\255\255\255\255\041\001\255\255\052\001\255\255\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\052\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\255\255\014\001\255\255\
\255\255\255\255\018\001\255\255\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\014\001\035\001\016\001\017\001\255\255\255\255\
\110\001\041\001\110\001\255\255\255\255\255\255\255\255\255\255\
\106\001\110\001\255\255\255\255\052\001\255\255\255\255\255\255\
\036\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\134\001\255\255\134\001\137\001\255\255\137\001\255\255\255\255\
\255\255\134\001\255\255\255\255\137\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\107\001\255\255\255\255\110\001\255\255\
\255\255\016\001\017\001\255\255\116\001\255\255\255\255\255\255\
\100\001\101\001\102\001\103\001\255\255\105\001\106\001\107\001\
\128\001\255\255\130\001\255\255\132\001\255\255\255\255\255\255\
\116\001\137\001\118\001\119\001\120\001\121\001\122\001\123\001\
\124\001\255\255\255\255\255\255\128\001\255\255\130\001\255\255\
\132\001\133\001\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\100\001\101\001\255\255\
\103\001\255\255\105\001\106\001\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\133\001\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\095\001\096\001\097\001\098\001\255\255\255\255\101\001\255\255\
\103\001\255\255\105\001\106\001\255\255\255\255\255\255\110\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\019\001\255\255\255\255\255\255\255\255\255\255\133\001\255\255\
\027\001\028\001\137\001\138\001\255\255\032\001\033\001\255\255\
\255\255\255\255\145\001\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\098\001\
\255\255\255\255\101\001\255\255\103\001\255\255\105\001\106\001\
\255\255\255\255\255\255\110\001\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\255\255\255\255\255\255\
\255\255\255\255\133\001\255\255\027\001\028\001\137\001\138\001\
\255\255\032\001\033\001\255\255\255\255\255\255\145\001\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\095\001\096\001\097\001\098\001\255\255\255\255\101\001\255\255\
\103\001\255\255\105\001\106\001\255\255\255\255\255\255\110\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\019\001\255\255\255\255\255\255\255\255\255\255\133\001\255\255\
\027\001\028\001\137\001\138\001\255\255\032\001\033\001\255\255\
\255\255\255\255\145\001\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\098\001\
\255\255\255\255\101\001\255\255\103\001\255\255\105\001\106\001\
\255\255\255\255\255\255\110\001\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\133\001\255\255\027\001\028\001\137\001\138\001\
\255\255\032\001\033\001\255\255\255\255\255\255\145\001\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\095\001\096\001\097\001\098\001\255\255\255\255\101\001\255\255\
\103\001\255\255\105\001\106\001\255\255\255\255\255\255\110\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\255\255\255\255\255\255\255\255\255\255\255\255\133\001\255\255\
\027\001\028\001\137\001\138\001\255\255\032\001\033\001\255\255\
\255\255\255\255\145\001\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\098\001\
\255\255\255\255\101\001\255\255\103\001\255\255\105\001\106\001\
\255\255\255\255\255\255\110\001\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\016\001\017\001\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\133\001\255\255\027\001\028\001\137\001\138\001\
\255\255\032\001\033\001\255\255\255\255\036\001\145\001\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\082\001\083\001\255\255\085\001\086\001\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\095\001\096\001\097\001\098\001\255\255\255\255\101\001\102\001\
\103\001\255\255\105\001\106\001\107\001\255\255\255\255\110\001\
\111\001\112\001\255\255\255\255\255\255\116\001\255\255\118\001\
\119\001\120\001\121\001\122\001\123\001\124\001\125\001\255\255\
\255\255\128\001\255\255\130\001\255\255\132\001\133\001\134\001\
\135\001\136\001\137\001\138\001\255\255\255\255\141\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\016\001\017\001\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\082\001\083\001\255\255\085\001\
\086\001\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\095\001\096\001\097\001\098\001\255\255\255\255\101\001\
\102\001\103\001\255\255\105\001\106\001\107\001\255\255\255\255\
\110\001\255\255\255\255\255\255\114\001\255\255\116\001\255\255\
\118\001\119\001\120\001\121\001\122\001\123\001\124\001\125\001\
\255\255\255\255\128\001\255\255\130\001\255\255\132\001\133\001\
\134\001\135\001\136\001\137\001\138\001\139\001\255\255\141\001\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\016\001\017\001\018\001\255\255\020\001\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\036\001\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\082\001\083\001\255\255\
\085\001\086\001\087\001\088\001\089\001\090\001\091\001\092\001\
\093\001\094\001\095\001\096\001\097\001\098\001\255\255\255\255\
\101\001\102\001\103\001\255\255\105\001\106\001\107\001\255\255\
\255\255\110\001\255\255\255\255\255\255\114\001\255\255\116\001\
\255\255\118\001\119\001\120\001\121\001\122\001\123\001\124\001\
\125\001\255\255\255\255\128\001\255\255\130\001\255\255\132\001\
\133\001\134\001\135\001\136\001\137\001\138\001\139\001\255\255\
\141\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\082\001\083\001\
\255\255\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\097\001\098\001\255\255\
\255\255\101\001\102\001\103\001\255\255\105\001\106\001\107\001\
\255\255\255\255\110\001\255\255\255\255\255\255\114\001\255\255\
\116\001\255\255\118\001\119\001\120\001\121\001\122\001\123\001\
\124\001\125\001\255\255\255\255\128\001\255\255\130\001\255\255\
\132\001\133\001\134\001\135\001\136\001\137\001\138\001\139\001\
\255\255\141\001\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\016\001\017\001\018\001\
\255\255\020\001\255\255\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\036\001\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\082\001\
\083\001\255\255\085\001\086\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\095\001\096\001\097\001\098\001\
\255\255\255\255\101\001\102\001\103\001\255\255\105\001\106\001\
\107\001\255\255\255\255\110\001\255\255\112\001\255\255\255\255\
\255\255\116\001\255\255\118\001\119\001\120\001\121\001\122\001\
\123\001\124\001\125\001\255\255\255\255\128\001\255\255\130\001\
\255\255\132\001\133\001\134\001\135\001\136\001\137\001\138\001\
\255\255\255\255\141\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\016\001\017\001\
\018\001\255\255\020\001\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\036\001\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\082\001\083\001\255\255\085\001\086\001\087\001\088\001\089\001\
\090\001\091\001\092\001\093\001\094\001\095\001\096\001\097\001\
\098\001\255\255\255\255\101\001\102\001\103\001\255\255\105\001\
\106\001\107\001\255\255\255\255\110\001\255\255\255\255\255\255\
\255\255\255\255\116\001\255\255\118\001\119\001\120\001\121\001\
\122\001\123\001\124\001\125\001\255\255\255\255\128\001\255\255\
\130\001\255\255\132\001\133\001\134\001\135\001\136\001\137\001\
\138\001\255\255\255\255\141\001\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\255\255\013\001\014\001\255\255\255\255\
\017\001\018\001\255\255\020\001\255\255\255\255\255\255\255\255\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\036\001\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\082\001\083\001\255\255\085\001\086\001\087\001\088\001\
\089\001\090\001\091\001\092\001\093\001\094\001\095\001\096\001\
\097\001\098\001\255\255\255\255\101\001\102\001\103\001\255\255\
\105\001\106\001\255\255\255\255\255\255\110\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\125\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\133\001\134\001\135\001\136\001\
\137\001\138\001\255\255\255\255\141\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\255\255\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\062\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\082\001\083\001\255\255\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\098\001\255\255\255\255\255\255\102\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\110\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\118\001\255\255\
\255\255\255\255\255\255\255\255\255\255\125\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\134\001\135\001\
\136\001\137\001\138\001\255\255\255\255\141\001\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\255\255\017\001\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\062\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\082\001\083\001\255\255\085\001\086\001\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\095\001\096\001\097\001\098\001\255\255\255\255\255\255\102\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\110\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\125\001\255\255\
\255\255\013\001\014\001\255\255\255\255\017\001\018\001\134\001\
\135\001\136\001\137\001\138\001\255\255\255\255\141\001\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\095\001\096\001\097\001\098\001\255\255\
\255\255\101\001\255\255\103\001\255\255\105\001\106\001\255\255\
\255\255\255\255\110\001\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\255\255\017\001\018\001\255\255\255\255\255\255\255\255\255\255\
\255\255\133\001\134\001\027\001\028\001\137\001\138\001\255\255\
\032\001\033\001\255\255\255\255\255\255\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\255\255\
\255\255\255\255\255\255\255\255\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\095\001\
\096\001\097\001\098\001\255\255\255\255\101\001\255\255\103\001\
\255\255\255\255\106\001\255\255\255\255\255\255\110\001\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\255\255\017\001\018\001\255\255\020\001\
\021\001\022\001\255\255\024\001\255\255\133\001\027\001\028\001\
\255\255\137\001\138\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\062\001\013\001\014\001\255\255\255\255\017\001\018\001\
\255\255\020\001\021\001\022\001\255\255\024\001\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\095\001\096\001\097\001\098\001\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\031\001\255\255\
\255\255\110\001\255\255\062\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\255\255\137\001\138\001\255\255\255\255\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\098\001\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\110\001\017\001\018\001\255\255\020\001\
\255\255\022\001\255\255\024\001\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\137\001\138\001\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\062\001\013\001\014\001\255\255\255\255\255\255\018\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\036\001\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\095\001\096\001\097\001\098\001\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\110\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\137\001\138\001\255\255\255\255\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\098\001\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\110\001\255\255\018\001\255\255\020\001\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\134\001\041\001\255\255\137\001\138\001\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\255\255\255\255\022\001\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\095\001\096\001\097\001\098\001\050\001\051\001\
\052\001\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\110\001\013\001\014\001\255\255\255\255\255\255\018\001\
\255\255\255\255\255\255\255\255\023\001\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\137\001\138\001\041\001\255\255\
\255\255\255\255\255\255\095\001\096\001\097\001\098\001\050\001\
\051\001\052\001\255\255\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\110\001\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\137\001\138\001\041\001\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\098\001\
\050\001\051\001\052\001\255\255\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\110\001\013\001\014\001\255\255\255\255\
\255\255\018\001\255\255\020\001\255\255\255\255\255\255\255\255\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\255\255\255\255\038\001\137\001\138\001\
\041\001\255\255\255\255\255\255\255\255\095\001\096\001\097\001\
\098\001\050\001\051\001\052\001\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\110\001\013\001\014\001\255\255\
\255\255\255\255\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\255\255\255\255\038\001\137\001\
\138\001\041\001\255\255\255\255\255\255\255\255\095\001\096\001\
\097\001\098\001\050\001\051\001\052\001\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\110\001\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\023\001\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\137\001\138\001\041\001\255\255\255\255\255\255\255\255\095\001\
\096\001\097\001\098\001\050\001\051\001\052\001\255\255\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\110\001\013\001\
\014\001\255\255\255\255\255\255\018\001\019\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\255\255\255\255\
\038\001\137\001\138\001\041\001\255\255\255\255\255\255\255\255\
\095\001\096\001\097\001\098\001\050\001\051\001\052\001\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\110\001\
\013\001\014\001\255\255\255\255\255\255\018\001\019\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\137\001\138\001\041\001\255\255\255\255\255\255\
\255\255\095\001\096\001\097\001\098\001\050\001\051\001\052\001\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\110\001\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\137\001\138\001\041\001\255\255\255\255\
\255\255\255\255\095\001\096\001\097\001\098\001\050\001\051\001\
\052\001\014\001\255\255\255\255\017\001\018\001\019\001\020\001\
\255\255\110\001\255\255\255\255\025\001\014\001\255\255\255\255\
\255\255\018\001\019\001\255\255\255\255\022\001\035\001\036\001\
\025\001\255\255\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\036\001\137\001\138\001\255\255\052\001\
\041\001\255\255\255\255\095\001\096\001\097\001\098\001\255\255\
\255\255\062\001\255\255\052\001\014\001\255\255\255\255\255\255\
\018\001\019\001\110\001\255\255\022\001\014\001\255\255\025\001\
\255\255\018\001\019\001\255\255\255\255\022\001\255\255\255\255\
\025\001\014\001\036\001\255\255\255\255\018\001\019\001\041\001\
\255\255\022\001\255\255\036\001\025\001\137\001\138\001\255\255\
\041\001\255\255\052\001\255\255\255\255\255\255\255\255\036\001\
\255\255\110\001\255\255\052\001\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\110\001\255\255\052\001\
\255\255\114\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\134\001\255\255\255\255\137\001\255\255\255\255\255\255\
\255\255\255\255\255\255\144\001\255\255\134\001\255\255\255\255\
\137\001\255\255\255\255\255\255\255\255\255\255\255\255\144\001\
\255\255\255\255\255\255\255\255\110\001\255\255\255\255\255\255\
\114\001\255\255\255\255\255\255\255\255\110\001\255\255\255\255\
\255\255\114\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\110\001\255\255\255\255\134\001\114\001\255\255\137\001\
\255\255\255\255\255\255\255\255\255\255\134\001\144\001\255\255\
\137\001\255\255\017\001\255\255\019\001\020\001\255\255\144\001\
\255\255\134\001\025\001\255\255\137\001\255\255\255\255\030\001\
\255\255\255\255\255\255\144\001\035\001\036\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\099\001\255\255\101\001\102\001\
\103\001\255\255\105\001\106\001\107\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\116\001\255\255\017\001\
\255\255\019\001\020\001\255\255\255\255\255\255\255\255\025\001\
\255\255\128\001\255\255\130\001\030\001\132\001\133\001\134\001\
\255\255\035\001\036\001\255\255\139\001\255\255\255\255\255\255\
\255\255\144\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\255\255\101\001\102\001\103\001\255\255\105\001\
\106\001\107\001\255\255\014\001\255\255\255\255\017\001\018\001\
\255\255\255\255\116\001\022\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\128\001\255\255\
\130\001\036\001\132\001\133\001\134\001\255\255\041\001\255\255\
\255\255\139\001\255\255\255\255\255\255\255\255\144\001\255\255\
\255\255\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\014\001\255\255\
\255\255\017\001\101\001\255\255\103\001\255\255\105\001\106\001\
\255\255\255\255\255\255\110\001\255\255\255\255\255\255\114\001\
\255\255\255\255\255\255\255\255\036\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\133\001\134\001\255\255\255\255\137\001\255\255\
\139\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\255\255\
\255\255\255\255\255\255\255\255\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\101\001\255\255\103\001\
\255\255\255\255\106\001\107\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\116\001\255\255\118\001\119\001\
\120\001\121\001\122\001\123\001\124\001\255\255\255\255\255\255\
\128\001\255\255\130\001\255\255\132\001\133\001\014\001\255\255\
\255\255\017\001\018\001\139\001\255\255\255\255\022\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\035\001\036\001\255\255\255\255\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\017\001\255\255\101\001\020\001\103\001\
\255\255\105\001\106\001\025\001\255\255\255\255\110\001\255\255\
\030\001\255\255\114\001\255\255\255\255\255\255\036\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\133\001\134\001\255\255\
\255\255\137\001\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\099\001\255\255\101\001\
\255\255\103\001\255\255\105\001\106\001\107\001\255\255\255\255\
\017\001\255\255\255\255\020\001\255\255\255\255\116\001\255\255\
\025\001\255\255\255\255\255\255\255\255\030\001\255\255\255\255\
\255\255\255\255\128\001\036\001\130\001\255\255\132\001\133\001\
\255\255\255\255\255\255\255\255\255\255\139\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\099\001\255\255\101\001\255\255\103\001\255\255\
\105\001\106\001\107\001\255\255\255\255\017\001\255\255\255\255\
\020\001\255\255\255\255\116\001\255\255\025\001\255\255\255\255\
\255\255\255\255\030\001\255\255\255\255\255\255\255\255\128\001\
\036\001\130\001\255\255\132\001\133\001\255\255\255\255\255\255\
\255\255\255\255\139\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\015\001\255\255\017\001\255\255\019\001\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\255\255\105\001\106\001\107\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\116\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\128\001\255\255\130\001\255\255\
\132\001\133\001\057\001\058\001\059\001\060\001\061\001\139\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\015\001\255\255\017\001\
\255\255\255\255\255\255\255\255\255\255\255\255\101\001\255\255\
\103\001\255\255\105\001\106\001\255\255\255\255\255\255\255\255\
\034\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\133\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\015\001\255\255\017\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\101\001\255\255\103\001\255\255\105\001\
\106\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\133\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\015\001\255\255\017\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\101\001\255\255\103\001\255\255\105\001\106\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\133\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\016\001\017\001\255\255\255\255\255\255\
\021\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\101\001\255\255\103\001\255\255\105\001\106\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\133\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\255\255\255\255\255\255\
\255\255\255\255\016\001\017\001\255\255\255\255\255\255\021\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\100\001\
\101\001\255\255\103\001\255\255\105\001\106\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\133\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\255\255\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\100\001\101\001\
\255\255\103\001\255\255\105\001\106\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\133\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\017\001\
\255\255\255\255\020\001\255\255\255\255\255\255\101\001\255\255\
\103\001\255\255\105\001\106\001\107\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\116\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\128\001\255\255\130\001\255\255\132\001\133\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\255\255\255\255\017\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\101\001\255\255\103\001\255\255\105\001\
\106\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\133\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\101\001\255\255\103\001\255\255\105\001\106\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\133\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\255\255\255\255\255\255\255\255\017\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\101\001\255\255\103\001\255\255\255\255\106\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\255\255\255\255\255\255\
\255\255\133\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\101\001\255\255\103\001\255\255\255\255\
\106\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\022\001\
\255\255\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\255\255\255\255\133\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\018\001\255\255\255\255\255\255\022\001\255\255\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\255\255\255\255\255\255\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\005\001\006\001\007\001\008\001\255\255\255\255\255\255\
\255\255\255\255\014\001\255\255\255\255\017\001\018\001\019\001\
\020\001\021\001\255\255\114\001\255\255\025\001\255\255\027\001\
\028\001\029\001\030\001\031\001\255\255\033\001\255\255\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\255\255\255\255\114\001\005\001\006\001\007\001\008\001\255\255\
\255\255\255\255\255\255\255\255\014\001\255\255\255\255\017\001\
\018\001\019\001\020\001\021\001\255\255\255\255\255\255\025\001\
\084\001\027\001\028\001\029\001\030\001\031\001\090\001\033\001\
\255\255\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\255\255\255\255\255\255\255\255\255\255\014\001\255\255\
\255\255\017\001\018\001\019\001\020\001\021\001\255\255\255\255\
\255\255\025\001\084\001\027\001\028\001\029\001\030\001\031\001\
\090\001\033\001\255\255\035\001\255\255\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\018\001\255\255\255\255\021\001\022\001\255\255\024\001\025\001\
\026\001\027\001\028\001\255\255\084\001\031\001\255\255\255\255\
\255\255\035\001\090\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001"

let yynames_const = "\
  "

let yynames_block = "\
  TUnknown\000\
  TCommentSpace\000\
  TCommentNewline\000\
  TComment\000\
  TInt\000\
  TFloat\000\
  TChar\000\
  TString\000\
  TQuote\000\
  TPct\000\
  TFormat\000\
  TSubString\000\
  TDecimal\000\
  TIdent\000\
  TKRParam\000\
  Tconstructorname\000\
  TypedefIdent\000\
  TOPar\000\
  TCPar\000\
  TOBrace\000\
  TCBrace\000\
  TOCro\000\
  TCCro\000\
  TDot\000\
  TComma\000\
  TPtrOp\000\
  TInc\000\
  TDec\000\
  TAssign\000\
  TEq\000\
  TWhy\000\
  TTilde\000\
  TBang\000\
  TEllipsis\000\
  TDotDot\000\
  TPtVirg\000\
  TOrLog\000\
  TAndLog\000\
  TOr\000\
  TXor\000\
  TAnd\000\
  TEqEq\000\
  TNotEq\000\
  TInf\000\
  TSup\000\
  TInfEq\000\
  TSupEq\000\
  TShl\000\
  TShr\000\
  TPlus\000\
  TMinus\000\
  TMul\000\
  TDiv\000\
  TMod\000\
  TMax\000\
  TMin\000\
  Tchar\000\
  Tshort\000\
  Tint\000\
  Tdouble\000\
  Tfloat\000\
  Tcomplex\000\
  Tlong\000\
  Tunsigned\000\
  Tsigned\000\
  Tvoid\000\
  Tsize_t\000\
  Tssize_t\000\
  Tptrdiff_t\000\
  TautoType\000\
  Tauto\000\
  Tregister\000\
  Textern\000\
  Tstatic\000\
  Ttypedef\000\
  Tconst\000\
  Tvolatile\000\
  Tstruct\000\
  Tunion\000\
  Tenum\000\
  Tdecimal\000\
  Texec\000\
  Tbreak\000\
  Telse\000\
  Tswitch\000\
  Tcase\000\
  Tcontinue\000\
  Tfor\000\
  Tdo\000\
  Tif\000\
  Twhile\000\
  Treturn\000\
  Tgoto\000\
  Tdefault\000\
  Tsizeof\000\
  Tnew\000\
  Tdelete\000\
  Tdefined\000\
  TOParCplusplusInit\000\
  Tnamespace\000\
  Trestrict\000\
  Tasm\000\
  Tattribute\000\
  TattributeNoarg\000\
  Tinline\000\
  Ttypeof\000\
  TDefine\000\
  TDefParamVariadic\000\
  TCppEscapedNewline\000\
  TCppConcatOp\000\
  TOParDefine\000\
  TOBraceDefineInit\000\
  TIdentDefine\000\
  TDefEOL\000\
  TInclude\000\
  TIncludeStart\000\
  TIncludeFilename\000\
  TIfdef\000\
  TIfdefelif\000\
  TIfdefelse\000\
  TEndif\000\
  TIfdefBool\000\
  TIfdefMisc\000\
  TIfdefVersion\000\
  TUifdef\000\
  TUelseif\000\
  TUendif\000\
  TUndef\000\
  TPrePragma\000\
  TPragma\000\
  TPragmaString\000\
  TCppDirectiveOther\000\
  TMacroAttr\000\
  TMacroEndAttr\000\
  TMacroStmt\000\
  TMacroIdStmt\000\
  TMacroIdentBuilder\000\
  TMacroString\000\
  TMacroDecl\000\
  TMacroDeclConst\000\
  TMacroIterator\000\
  TCommentSkipTagStart\000\
  TCommentSkipTagEnd\000\
  TCParEOL\000\
  TAction\000\
  TCommentMisc\000\
  TCommentCpp\000\
  EOF\000\
  TTODO\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 701 "parsing_c/parser_c.mly"
                          ( _1 )
# 3521 "parsing_c/parser_c.ml"
               : Ast_c.program))
; (fun __caml_parser_env ->
    Obj.repr(
# 705 "parsing_c/parser_c.mly"
     ( [] )
# 3527 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 707 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; _1 @ [_2] )
# 3535 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 709 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       _1 @ [Namespace (_5, [_2; snd _3; _4; _6])] )
# 3548 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 722 "parsing_c/parser_c.mly"
                ( _1 )
# 3555 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 723 "parsing_c/parser_c.mly"
                ( _1 )
# 3562 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 724 "parsing_c/parser_c.mly"
                ( ("complex", _1) )
# 3569 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 728 "parsing_c/parser_c.mly"
                ( _1 )
# 3576 "parsing_c/parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 729 "parsing_c/parser_c.mly"
                ( ("complex", _1) )
# 3583 "parsing_c/parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 738 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3590 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 739 "parsing_c/parser_c.mly"
                   ( _1 )
# 3597 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 743 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3604 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 745 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3611 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 746 "parsing_c/parser_c.mly"
                   ( _1 )
# 3618 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 747 "parsing_c/parser_c.mly"
                ( RegularName (mk_string_wrap ("complex", _1)) )
# 3625 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp_list) in
    Obj.repr(
# 751 "parsing_c/parser_c.mly"
     (
       CppConcatenatedName (
         match _3 with
         | [] -> raise (Impossible 87)
         | (x,concatnull)::xs ->
             assert (concatnull = []);
             (mk_string_wrap _1, [])::(x,[_2])::xs
       )
   )
# 3642 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 761 "parsing_c/parser_c.mly"
     ( CppVariadicName (fst _2, [_1; snd _2]) )
# 3650 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'param_define_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 763 "parsing_c/parser_c.mly"
     ( CppIdentBuilder ((fst _1, [snd _1;_2;_4]), _3) )
# 3660 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 766 "parsing_c/parser_c.mly"
          ( [mk_string_wrap _1, []] )
# 3667 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 767 "parsing_c/parser_c.mly"
                                           ( _1 @ [mk_string_wrap _3, [_2]] )
# 3676 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 774 "parsing_c/parser_c.mly"
                           ( _1 )
# 3683 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 775 "parsing_c/parser_c.mly"
                           ( mk_e (Sequence (_1,_3)) [_2] )
# 3692 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 781 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3699 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.assignOp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 782 "parsing_c/parser_c.mly"
                                 ( mk_e(Assignment (_1, _2, _3)) [])
# 3708 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 783 "parsing_c/parser_c.mly"
                                 ( mk_e (Assignment (_1, (SimpleAssign, [_2]),_3)) [])
# 3717 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 791 "parsing_c/parser_c.mly"
     ( _1 )
# 3724 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_opt_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 793 "parsing_c/parser_c.mly"
     ( mk_e (CondExpr (_1,_3,_5)) [_2;_4] )
# 3735 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 797 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3742 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 798 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mul,[_2]), _3)) [] )
# 3751 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 799 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Div, [_2]), _3)) [] )
# 3760 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 800 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Min, [_2]), _3)) [] )
# 3769 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 801 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Max, [_2]), _3)) [] )
# 3778 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 802 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mod, [_2]), _3)) [] )
# 3787 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 803 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Plus, [_2]), _3)) [] )
# 3796 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 804 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Minus, [_2]), _3)) [] )
# 3805 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 805 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecLeft, [_2]), _3)) [] )
# 3814 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 806 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecRight, [_2]), _3)) [] )
# 3823 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 807 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Inf, [_2]), _3)) [] )
# 3832 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 808 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Sup, [_2]), _3)) [] )
# 3841 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 809 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical InfEq, [_2]), _3)) [] )
# 3850 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 810 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical SupEq, [_2]), _3)) [] )
# 3859 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 811 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Eq, [_2]), _3)) [] )
# 3868 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 812 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical NotEq, [_2]), _3)) [] )
# 3877 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 813 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith And, [_2]), _3)) [] )
# 3886 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 814 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Or, [_2]), _3)) [] )
# 3895 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 815 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Xor, [_2]), _3)) [] )
# 3904 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 816 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical AndLog, [_2]), _3)) [] )
# 3913 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 817 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical OrLog, [_2]), _3)) [] )
# 3922 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 820 "parsing_c/parser_c.mly"
                                     ( _1 )
# 3929 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.attribute list * Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 822 "parsing_c/parser_c.mly"
   ( mk_e(Cast (snd _2, fst _2, _4)) [_1;_3] )
# 3939 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expr) in
    Obj.repr(
# 830 "parsing_c/parser_c.mly"
                                   ( _1 )
# 3946 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 831 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Inc))    [_1] )
# 3954 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 832 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Dec))    [_1] )
# 3962 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_op) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 833 "parsing_c/parser_c.mly"
                                   ( mk_e(Unary (_2, fst _1)) [snd _1] )
# 3970 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 834 "parsing_c/parser_c.mly"
                                   ( mk_e(SizeOfExpr (_2))    [_1] )
# 3978 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar2) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.attribute list * Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar2) in
    Obj.repr(
# 836 "parsing_c/parser_c.mly"
     ( let ret = mk_e(SizeOfType (snd _3)) [_1;_2;_4] in
       match (fst _3) with (* warn about dropped attributes *)
         [] -> ret
       | _ -> warning "attributes found in sizeof(...), dropping" ret )
# 3991 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 840 "parsing_c/parser_c.mly"
                                   ( mk_e(New (None, _2))     [_1] )
# 3999 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 841 "parsing_c/parser_c.mly"
                                                  ( mk_e(New (Some _3, _5))             [_1; _2; _4] )
# 4010 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 842 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(false, _2))  [_1] )
# 4018 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 843 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(true, _4))   [_1;_2;_3] )
# 4028 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 844 "parsing_c/parser_c.mly"
                                   ( mk_e(Defined _2)         [_1] )
# 4036 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'identifier_cpp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 846 "parsing_c/parser_c.mly"
 ( mk_e(Defined _3) [_1;_2;_4] )
# 4046 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 850 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 4057 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 853 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left(mk_e(FunCall (fn, [])) [_2;_3]) )
# 4067 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 856 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 4078 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 859 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, [])) [_2;_3]) )
# 4088 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 862 "parsing_c/parser_c.mly"
     ( let ty = addTypeD (_1,nullDecl) in
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam ty in
       Right (ArgType { p_namei = None; p_type = returnType;
                        p_register = hasreg, iihasreg; p_attr = [];
		      } )
     )
# 4100 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'new_argument) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 869 "parsing_c/parser_c.mly"
     (
       match _1 with
	 Left(e) -> Left(mk_e(ArrayAccess (e, _3)) [_2;_4])
       | Right(ArgType(ty)) -> (* lots of hacks to make the right type *)
	   let fty = mk_ty (Array (Some _3, ty.Ast_c.p_type)) [_2;_4] in
	   let pty = { ty with p_type = fty } in
	   Right(ArgType pty)
       | _ -> raise (Impossible 88)
     )
# 4118 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 880 "parsing_c/parser_c.mly"
          ( GetRef,     _1 )
# 4125 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 881 "parsing_c/parser_c.mly"
          ( DeRef,      _1 )
# 4132 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 882 "parsing_c/parser_c.mly"
          ( UnPlus,     _1 )
# 4139 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 883 "parsing_c/parser_c.mly"
          ( UnMinus,    _1 )
# 4146 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 884 "parsing_c/parser_c.mly"
          ( Tilde,      _1 )
# 4153 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 885 "parsing_c/parser_c.mly"
          ( Not,        _1 )
# 4160 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 889 "parsing_c/parser_c.mly"
           ( GetRefLabel, _1 )
# 4167 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expr) in
    Obj.repr(
# 892 "parsing_c/parser_c.mly"
                              ( _1 )
# 4174 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 894 "parsing_c/parser_c.mly"
     ( mk_e(ArrayAccess (_1, _3)) [_2;_4] )
# 4184 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 896 "parsing_c/parser_c.mly"
     ( mk_e(FunCall (_1, _3)) [_2;_4] )
# 4194 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 897 "parsing_c/parser_c.mly"
                              ( mk_e(FunCall (_1, [])) [_2;_3] )
# 4203 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 898 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordAccess   (_1,_3)) [_2] )
# 4212 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 899 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordPtAccess (_1,_3)) [_2] )
# 4221 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 900 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Inc)) [_2] )
# 4229 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 901 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Dec)) [_2] )
# 4237 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.attribute list * Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 905 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (snd _2, (InitList [], [_4;_5]))) [_1;_3] )
# 4248 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.attribute list * Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 907 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (snd _2, (InitList (List.rev _5),[_4;_7] @ _6))) [_1;_3] )
# 4261 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 911 "parsing_c/parser_c.mly"
                   ( mk_e(Ident  (_1)) [] )
# 4268 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 913 "parsing_c/parser_c.mly"
    ( let (str,(sign,base)) = fst _1 in
      mk_e(Constant (Int (str,Si(sign,base)))) [snd _1] )
# 4276 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 915 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Float  (fst _1))) [snd _1] )
# 4283 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 916 "parsing_c/parser_c.mly"
           ( mk_e(Constant (String (fst _1))) [snd _1] )
# 4290 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragments) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 918 "parsing_c/parser_c.mly"
     ( let ((fullstring,isW),lqinfo) = _1 in
       let (_,rqinfo) = _3 in
       mk_e (Ast_c.StringConstant(_2, fullstring, isW)) [lqinfo;rqinfo] )
# 4301 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 921 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Char   (fst _1))) [snd _1] )
# 4308 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * string (*n*) * string (*p*)) * Ast_c.info) in
    Obj.repr(
# 922 "parsing_c/parser_c.mly"
            ( let (a,b,c) = fst _1 in
              mk_e(Constant (DecimalConst (a,b,c))) [snd _1] )
# 4316 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 924 "parsing_c/parser_c.mly"
                    ( mk_e(ParenExpr (_2)) [_1;_3] )
# 4325 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 927 "parsing_c/parser_c.mly"
                ( mk_e(Constant (MultiString [fst _1])) [snd _1] )
# 4332 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_elem) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 929 "parsing_c/parser_c.mly"
     ( mk_e(Constant (MultiString ["TODO: MultiString"])) (_1 @ _2) )
# 4340 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 932 "parsing_c/parser_c.mly"
                         ( mk_e(StatementExpr (_2)) [_1;_3] )
# 4349 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 935 "parsing_c/parser_c.mly"
               ( [] )
# 4355 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragment) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_fragments) in
    Obj.repr(
# 936 "parsing_c/parser_c.mly"
                                    ( _1 :: _2 )
# 4363 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_format) in
    Obj.repr(
# 939 "parsing_c/parser_c.mly"
                      ( Ast_c.FormatFragment(_2), [_1] )
# 4371 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 940 "parsing_c/parser_c.mly"
              ( Ast_c.ConstantFragment(fst _1), [snd _1] )
# 4378 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 943 "parsing_c/parser_c.mly"
           ( Ast_c.ConstantFormat(fst _1), [snd _1] )
# 4385 "parsing_c/parser_c.ml"
               : 'string_format))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 952 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4392 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 953 "parsing_c/parser_c.mly"
                  ( Right (ArgType _1)  )
# 4399 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro_ne) in
    Obj.repr(
# 954 "parsing_c/parser_c.mly"
                              ( Right (ArgAction _1) )
# 4406 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 958 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4413 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 959 "parsing_c/parser_c.mly"
                  ( Right (ArgType _1)  )
# 4420 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro) in
    Obj.repr(
# 961 "parsing_c/parser_c.mly"
                           ( Right (ArgAction _1) )
# 4427 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 965 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4437 "parsing_c/parser_c.ml"
               : 'action_higherordermacro_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 973 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4447 "parsing_c/parser_c.ml"
               : 'action_higherordermacro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 984 "parsing_c/parser_c.mly"
                      ( _1  )
# 4454 "parsing_c/parser_c.ml"
               : 'const_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 987 "parsing_c/parser_c.mly"
              ( et "topar2" (); _1  )
# 4461 "parsing_c/parser_c.ml"
               : 'topar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 988 "parsing_c/parser_c.mly"
              ( et "tcpar2" (); _1 (*TODO? et ? sure ? c pas dt plutot ? *) )
# 4468 "parsing_c/parser_c.ml"
               : 'tcpar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'statement2) in
    Obj.repr(
# 996 "parsing_c/parser_c.mly"
                      ( mk_st (fst _1) (snd _1) )
# 4475 "parsing_c/parser_c.ml"
               : Ast_c.statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'labeled) in
    Obj.repr(
# 999 "parsing_c/parser_c.mly"
                   ( Labeled      (fst _1), snd _1 )
# 4482 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1000 "parsing_c/parser_c.mly"
                   ( Compound     (fst _1), snd _1 )
# 4489 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expr_statement) in
    Obj.repr(
# 1001 "parsing_c/parser_c.mly"
                   ( ExprStatement(fst _1), snd _1 )
# 4496 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection) in
    Obj.repr(
# 1002 "parsing_c/parser_c.mly"
                   ( Selection    (fst _1), snd _1 @ [postfakeInfo(snd _1)] )
# 4503 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration) in
    Obj.repr(
# 1003 "parsing_c/parser_c.mly"
                   ( Iteration    (fst _1), snd _1 @ [postfakeInfo(snd _1)] )
# 4510 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'jump) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1004 "parsing_c/parser_c.mly"
                   ( Jump         (fst _1), snd _1 @ [_2] )
# 4518 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1007 "parsing_c/parser_c.mly"
                                                ( Asm _3, [_1;_2;_4;_5] )
# 4529 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1008 "parsing_c/parser_c.mly"
                                                ( Asm _4, [_1;_2;_3;_5;_6] )
# 4541 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1011 "parsing_c/parser_c.mly"
                                           (
   let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
   ExprStatement (Some(mk_e (FunCall (fn, _3)) [_2;_4])), [Ast_c.fakeInfo ()] )
# 4553 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1014 "parsing_c/parser_c.mly"
                ( MacroStmt, [snd _1] )
# 4560 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1016 "parsing_c/parser_c.mly"
                                      ( Exec(_3), [_1;snd _2;_4] )
# 4570 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1023 "parsing_c/parser_c.mly"
                                              ( Label (_1, _3),  [_2] )
# 4579 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1024 "parsing_c/parser_c.mly"
                                              ( Case (_2, _4),       [_1; _3] )
# 4589 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1026 "parsing_c/parser_c.mly"
     ( CaseRange (_2, _4, _6), [_1;_3;_5] )
# 4601 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1027 "parsing_c/parser_c.mly"
                                         ( Default _3,             [_1; _2] )
# 4610 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1030 "parsing_c/parser_c.mly"
             ( mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii )
# 4617 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1031 "parsing_c/parser_c.mly"
             ( _1 )
# 4624 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1042 "parsing_c/parser_c.mly"
     ( Label (_1, (mk_st (ExprStatement None) Ast_c.noii)), [_2] )
# 4632 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1044 "parsing_c/parser_c.mly"
     ( Case (_2, (mk_st (ExprStatement None) Ast_c.noii)), [_1;_3] )
# 4641 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1046 "parsing_c/parser_c.mly"
     ( Default (mk_st (ExprStatement None) Ast_c.noii),    [_1; _2] )
# 4649 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace) in
    Obj.repr(
# 1052 "parsing_c/parser_c.mly"
                                    ( _2, [_1; _3]  )
# 4658 "parsing_c/parser_c.ml"
               : 'compound))
; (fun __caml_parser_env ->
    Obj.repr(
# 1064 "parsing_c/parser_c.mly"
                     ( ([]) )
# 4664 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1065 "parsing_c/parser_c.mly"
                     ( _1 )
# 4671 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl) in
    Obj.repr(
# 1069 "parsing_c/parser_c.mly"
                                  ( [_1] )
# 4678 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_labeled) in
    Obj.repr(
# 1071 "parsing_c/parser_c.mly"
                ( [StmtElem (mk_st (Labeled  (fst _1)) (snd _1))] )
# 4685 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1073 "parsing_c/parser_c.mly"
                                  ( _1 :: _2 )
# 4693 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1076 "parsing_c/parser_c.mly"
             ( StmtElem (mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii) )
# 4700 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1077 "parsing_c/parser_c.mly"
             ( StmtElem _1 )
# 4707 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1080 "parsing_c/parser_c.mly"
                       ( StmtElem (mk_st (NestedFunc _1) Ast_c.noii) )
# 4714 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1084 "parsing_c/parser_c.mly"
     ( CppDirectiveStmt _1 )
# 4721 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1086 "parsing_c/parser_c.mly"
     ( IfdefStmt _1 )
# 4728 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1090 "parsing_c/parser_c.mly"
                               ( None,    [_1] )
# 4735 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1091 "parsing_c/parser_c.mly"
                               ( None,    [_2] )
# 4743 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1092 "parsing_c/parser_c.mly"
                               ( Some _1, [_2] )
# 4751 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1096 "parsing_c/parser_c.mly"
     ( If (_3, _5, (mk_st (ExprStatement None) Ast_c.noii)),   [_1;_2;_4] )
# 4762 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'cpp_ifdef_statement) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1098 "parsing_c/parser_c.mly"
     ( If (_3, _5, _7),  [_1;_2;_4;_6] )
# 4775 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1100 "parsing_c/parser_c.mly"
     ( Switch (_3,_5),   [_1;_2;_4]  )
# 4786 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1103 "parsing_c/parser_c.mly"
     ( Ifdef_Ite (_4,_6,_9), [_1;_2;_3;_5;_7;_8] )
# 4801 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 10 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 9 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _10 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _11 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1106 "parsing_c/parser_c.mly"
     ( Ifdef_Ite2 (_4,_6,_9,_11), [_1;_2;_3;_5;_7;_8;_10] )
# 4818 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1110 "parsing_c/parser_c.mly"
     ( While (_3,_5),                [_1;_2;_4] )
# 4829 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1112 "parsing_c/parser_c.mly"
     ( DoWhile (_2,_5),              [_1;_3;_4;_6;_7] )
# 4842 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1114 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(None, []),_6),    [_1;_2;_5])
# 4854 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1116 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(Some _5, []),_7), [_1;_2;_6] )
# 4867 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1119 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(None, []),_6),    [_1;_2;_5])
# 4879 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1121 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(Some _5, []),_7), [_1;_2;_6] )
# 4892 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1124 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, _3, _5), [snd _1;_2;_4] )
# 4903 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1126 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, [], _4), [snd _1;_2;_3] )
# 4913 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1130 "parsing_c/parser_c.mly"
                    ( Goto (_2),  [_1] )
# 4921 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1131 "parsing_c/parser_c.mly"
                ( Continue,       [_1] )
# 4928 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1132 "parsing_c/parser_c.mly"
                ( Break,          [_1] )
# 4935 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1133 "parsing_c/parser_c.mly"
                ( Return,         [_1] )
# 4942 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1134 "parsing_c/parser_c.mly"
                ( ReturnExpr _2,  [_1] )
# 4950 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1135 "parsing_c/parser_c.mly"
                   ( GotoComputed _3, [_1;_2] )
# 4959 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1143 "parsing_c/parser_c.mly"
           ( [snd _1] )
# 4966 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1145 "parsing_c/parser_c.mly"
                ( [snd _1] )
# 4973 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm_list) in
    Obj.repr(
# 1149 "parsing_c/parser_c.mly"
                               ( _1, _2 )
# 4981 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 1150 "parsing_c/parser_c.mly"
               ( _1, [] )
# 4988 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option_list) in
    Obj.repr(
# 1153 "parsing_c/parser_c.mly"
                                     ( Colon _2, [_1]   )
# 4996 "parsing_c/parser_c.ml"
               : 'colon_asm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1156 "parsing_c/parser_c.mly"
                                ( ColonMisc, [snd _1] )
# 5003 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1157 "parsing_c/parser_c.mly"
                                ( ColonExpr _3, [snd _1; _2;_4] )
# 5013 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1160 "parsing_c/parser_c.mly"
     ( ColonExpr _6, [_1;snd _2;_3;snd _4; _5; _7 ] )
# 5026 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 1161 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [snd _1] )
# 5033 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1162 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [] )
# 5039 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1166 "parsing_c/parser_c.mly"
                ( [] )
# 5045 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1168 "parsing_c/parser_c.mly"
      ( (ExecEval (_3 (mk_e (Ident _2) [])), [_1]) :: _4 )
# 5055 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1170 "parsing_c/parser_c.mly"
      ( (ExecToken, [snd _1]) :: _2 @ _3 )
# 5064 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'token) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1171 "parsing_c/parser_c.mly"
                    ( (ExecToken, [_1]) :: _2 )
# 5072 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 1174 "parsing_c/parser_c.mly"
    ( function prev -> prev )
# 5078 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1176 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordAccess   (prev,fld)) [_1]) )
# 5089 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1180 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordPtAccess   (prev,fld)) [_1]) )
# 5100 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1184 "parsing_c/parser_c.mly"
     ( function prev ->
       _4 (mk_e(ArrayAccess   (prev,_2)) [_1;_3]) )
# 5111 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    Obj.repr(
# 1188 "parsing_c/parser_c.mly"
    ( [] )
# 5117 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident2) in
    Obj.repr(
# 1190 "parsing_c/parser_c.mly"
    ( (ExecToken, [_1]) :: (ExecToken, [snd _2]) :: _3 )
# 5126 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1192 "parsing_c/parser_c.mly"
                      ( _1 )
# 5133 "parsing_c/parser_c.ml"
               : 'asm_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1195 "parsing_c/parser_c.mly"
            ( _1 )
# 5140 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1196 "parsing_c/parser_c.mly"
            ( _1 )
# 5147 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1197 "parsing_c/parser_c.mly"
            ( _1 )
# 5154 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1198 "parsing_c/parser_c.mly"
            ( _1 )
# 5161 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1199 "parsing_c/parser_c.mly"
            ( _1 )
# 5168 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1200 "parsing_c/parser_c.mly"
            ( _1 )
# 5175 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1201 "parsing_c/parser_c.mly"
            ( _1 )
# 5182 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1202 "parsing_c/parser_c.mly"
            ( _1 )
# 5189 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1203 "parsing_c/parser_c.mly"
            ( _1 )
# 5196 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1204 "parsing_c/parser_c.mly"
            ( _1 )
# 5203 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.assignOp) in
    Obj.repr(
# 1205 "parsing_c/parser_c.mly"
            ( List.hd (snd _1) )
# 5210 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1207 "parsing_c/parser_c.mly"
            ( _1 )
# 5217 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1208 "parsing_c/parser_c.mly"
            ( _1 )
# 5224 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1209 "parsing_c/parser_c.mly"
            ( _1 )
# 5231 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1210 "parsing_c/parser_c.mly"
            ( _1 )
# 5238 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1211 "parsing_c/parser_c.mly"
            ( _1 )
# 5245 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1212 "parsing_c/parser_c.mly"
            ( _1 )
# 5252 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1214 "parsing_c/parser_c.mly"
            ( _1 )
# 5259 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1215 "parsing_c/parser_c.mly"
            ( _1 )
# 5266 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1216 "parsing_c/parser_c.mly"
            ( _1 )
# 5273 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1217 "parsing_c/parser_c.mly"
            ( _1 )
# 5280 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1218 "parsing_c/parser_c.mly"
            ( _1 )
# 5287 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1219 "parsing_c/parser_c.mly"
            ( _1 )
# 5294 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1220 "parsing_c/parser_c.mly"
            ( _1 )
# 5301 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1222 "parsing_c/parser_c.mly"
            ( _1 )
# 5308 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1223 "parsing_c/parser_c.mly"
            ( _1 )
# 5315 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1226 "parsing_c/parser_c.mly"
            ( _1 )
# 5322 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1227 "parsing_c/parser_c.mly"
            ( _1 )
# 5329 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1231 "parsing_c/parser_c.mly"
            ( _1 )
# 5336 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1232 "parsing_c/parser_c.mly"
            ( _1 )
# 5343 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1233 "parsing_c/parser_c.mly"
            ( _1 )
# 5350 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1235 "parsing_c/parser_c.mly"
                 ( snd _1 )
# 5357 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1237 "parsing_c/parser_c.mly"
            ( _1 )
# 5364 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1238 "parsing_c/parser_c.mly"
            ( _1 )
# 5371 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 1239 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5378 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 1240 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5385 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1241 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5392 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1242 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5399 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1253 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType Void),            [_1] )
# 5406 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1254 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType CChar)), [_1])
# 5413 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1255 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType (Si (Signed,CInt)))), [_1])
# 5420 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1256 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloat)),  [_1])
# 5427 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1257 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CDouble)), [_1] )
# 5434 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1258 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloatComplex)),  [_1;_2])
# 5442 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1259 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CDoubleComplex)), [_1;_2] )
# 5450 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1260 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SizeType),            [_1] )
# 5457 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1261 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SSizeType),           [_1] )
# 5464 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1262 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType PtrDiffType),         [_1] )
# 5471 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1263 "parsing_c/parser_c.mly"
                        ( Middle3 Short,  [_1])
# 5478 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1264 "parsing_c/parser_c.mly"
                        ( Middle3 Long,   [_1])
# 5485 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1265 "parsing_c/parser_c.mly"
                        ( Left3 Signed,   [_1])
# 5492 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1266 "parsing_c/parser_c.mly"
                        ( Left3 UnSigned, [_1])
# 5499 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union_spec) in
    Obj.repr(
# 1267 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5506 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enum_spec) in
    Obj.repr(
# 1268 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5513 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1270 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,Some _5)), [_1;_2;_4;_6] )
# 5525 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1272 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,None)), [_1;_2;_4] )
# 5535 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1273 "parsing_c/parser_c.mly"
             (
     let can_auto_type =
      let open Flag in
       match !c_plus_plus with
         Off -> false
       | On None -> true
       | On (Some i) -> i >= 2011
     in
     if can_auto_type
     then (Right3 AutoType, [_1])
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("auto is not a valid C type, try using the --c++ option",
                       i)) )
# 5555 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1302 "parsing_c/parser_c.mly"
     ( let name = RegularName (mk_string_wrap _1) in
       Right3 (TypeName (name, Ast_c.noTypedefDef())),[] )
# 5563 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'assign_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1305 "parsing_c/parser_c.mly"
                                   ( Right3 (TypeOfExpr (_3)), [_1;_2;_4] )
# 5573 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.attribute list * Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1307 "parsing_c/parser_c.mly"
     ( let ret = Right3 (TypeOfType (snd _3)), [_1;_2;_4] in
       match (fst _3) with (* warn about dropped attributes *)
         [] -> ret
       | _ -> warning "attributes found in typeof(...), dropping" ret )
# 5586 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec2) in
    Obj.repr(
# 1316 "parsing_c/parser_c.mly"
                         ( dt "type" (); _1   )
# 5593 "parsing_c/parser_c.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1323 "parsing_c/parser_c.mly"
             ( {const=true  ; volatile=false}, _1 )
# 5600 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1324 "parsing_c/parser_c.mly"
             ( {const=false ; volatile=true},  _1 )
# 5607 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1326 "parsing_c/parser_c.mly"
             ( (* TODO *) {const=false ; volatile=false},  _1 )
# 5614 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1334 "parsing_c/parser_c.mly"
                                    ( raise Todo )
# 5623 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1336 "parsing_c/parser_c.mly"
              ( Attribute (fst _1), [snd _1] )
# 5630 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1351 "parsing_c/parser_c.mly"
                    ( let (attr,ptr) = _1 in
                      (attr, (fst _2, fun x -> x +> ptr +> (snd _2))) )
# 5639 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1353 "parsing_c/parser_c.mly"
                    ( (Ast_c.noattr, _1)  )
# 5646 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tmul) in
    Obj.repr(
# 1357 "parsing_c/parser_c.mly"
                          ( (Ast_c.noattr,fun x -> mk_ty (Pointer x) [_1]) )
# 5653 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1359 "parsing_c/parser_c.mly"
     ( let (attr,ptr) = _2 in
       (attr,fun x -> ptr (mk_ty (Pointer x) [_1])) )
# 5662 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_list) in
    Obj.repr(
# 1362 "parsing_c/parser_c.mly"
     ( let (attr,tq) = _2 in
       (attr,fun x -> (tq.qualifD, mk_tybis (Pointer x) [_1])))
# 5671 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1365 "parsing_c/parser_c.mly"
     ( let (attr1,tq) = _2 in
       let (attr2,ptr) = _3 in
       (attr1@attr2,fun x -> ptr (tq.qualifD, mk_tybis (Pointer x) [_1])) )
# 5682 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1370 "parsing_c/parser_c.mly"
        ( _1 )
# 5689 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1372 "parsing_c/parser_c.mly"
     ( if !Flag.c_plus_plus <> Flag.Off
     then _1
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("& not allowed in C types, try -c++ option", i)) )
# 5700 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 1381 "parsing_c/parser_c.mly"
     ( (_1, fun x -> x) )
# 5707 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1383 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _2 in  (* attr gets ignored... *)
       (fst dec, fun x -> mk_ty (ParenType ((snd dec) x)) [_1;_3]) )
# 5717 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1386 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (None,x)) [_2;_3])) )
# 5726 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1388 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (Some _3,x)) [_2;_4])) )
# 5736 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1390 "parsing_c/parser_c.mly"
     ( (fst _1,
       fun x->(snd _1)
         (mk_ty (FunctionType (x,(([],(false, []))))) [_2;_3]))
     )
# 5748 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1395 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1)
       (mk_ty (FunctionType (x, _3)) [_2;_4]))
     )
# 5760 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1404 "parsing_c/parser_c.mly"
             ( et "tocro" ();_1 )
# 5767 "parsing_c/parser_c.ml"
               : 'tocro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1405 "parsing_c/parser_c.mly"
             ( dt "tccro" ();_1 )
# 5774 "parsing_c/parser_c.ml"
               : 'tccro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1409 "parsing_c/parser_c.mly"
                                      ( _1 )
# 5781 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1410 "parsing_c/parser_c.mly"
                                      ( ([], _1) )
# 5788 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1412 "parsing_c/parser_c.mly"
     ( (fst _1, fun x -> x +> _2 +> (snd _1)) )
# 5796 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abstract_declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1416 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (ParenType ((snd _2) x)) [_1;_3] )
# 5805 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1419 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (None, x)) [_1;_2] )
# 5813 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1421 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (Some _2, x)) [_1;_3] )
# 5822 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1423 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (None, x))  [_2;_3]) )
# 5831 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1425 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (Some _3,x))  [_2;_4]) )
# 5841 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1427 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, ([], (false,  [])))) [_1;_2] )
# 5849 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1429 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, _2))  [_1;_3] )
# 5858 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1440 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, (([], (false, []))))) [_2;_3]) )
# 5867 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1442 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, _3)) [_2;_4]) )
# 5877 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_list) in
    Obj.repr(
# 1448 "parsing_c/parser_c.mly"
                                   ( (_1, (false, [])))
# 5884 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1449 "parsing_c/parser_c.mly"
                                   ( (_1, (true,  [_2;_3])) )
# 5893 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1453 "parsing_c/parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
       p_attr = [];
     }
   )
# 5908 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1463 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg),iihasreg) = fixDeclSpecForParam (snd _1) in
       let attrs = (fst _1) @ (fst _2) in
       let (name, ftyp) = snd _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
         p_attr = attrs;
       }
     )
# 5925 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1474 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       let attrs = (fst _1) @ (fst _2) in
       { p_namei = None;
         p_type = (snd _2) returnType;
         p_register = hasreg, iihasreg;
         p_attr = attrs;
       }
     )
# 5941 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1484 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
         p_attr = fst _1;
       }
     )
# 5955 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1498 "parsing_c/parser_c.mly"
                                ( et "param" ();  _1 )
# 5962 "parsing_c/parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1501 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in
                 LP.add_ident (str_of_name (fst dec)); attr, dec )
# 5970 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1505 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in
                 let attr = attr @ _2 in
                 LP.add_ident (str_of_name (fst dec)); attr, dec )
# 5980 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1510 "parsing_c/parser_c.mly"
                       ( _1 )
# 5987 "parsing_c/parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1520 "parsing_c/parser_c.mly"
                                ( ([], addTypeD (_1, nullDecl)) )
# 5994 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1521 "parsing_c/parser_c.mly"
                                ( ([], {nullDecl with qualifD = (fst _1,[snd _1])}))
# 6001 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1522 "parsing_c/parser_c.mly"
                                ( ([_1], nullDecl) )
# 6008 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1523 "parsing_c/parser_c.mly"
                                ( (fst _2, addTypeD (_1,snd _2)) )
# 6016 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1524 "parsing_c/parser_c.mly"
                                ( (fst _2, addQualifD (_1,snd _2)) )
# 6024 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1525 "parsing_c/parser_c.mly"
                                ( ([_1]@(fst _2), snd _2) )
# 6032 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list2) in
    Obj.repr(
# 1527 "parsing_c/parser_c.mly"
                                               (  dt "spec_qualif" (); _1 )
# 6039 "parsing_c/parser_c.ml"
               : 'spec_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1532 "parsing_c/parser_c.mly"
               ( (Ast_c.noattr,{nullDecl with qualifD = (fst _1,[snd _1])}) )
# 6046 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1533 "parsing_c/parser_c.mly"
                                ( ([_1],nullDecl) )
# 6053 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1534 "parsing_c/parser_c.mly"
                                ( (fst _1,addQualifD (_2,snd _1)) )
# 6061 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1535 "parsing_c/parser_c.mly"
                                ( ((fst _1)@[_2],snd _1) )
# 6069 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1543 "parsing_c/parser_c.mly"
     ( let (attrs, ds) = _1 in
       let (returnType, _) = fixDeclSpecForDecl ds in (attrs, returnType) )
# 6077 "parsing_c/parser_c.ml"
               : Ast_c.attribute list * Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratort) in
    Obj.repr(
# 1546 "parsing_c/parser_c.mly"
     ( let (attrs1, ds) = _1 in
       let (attrs2, fn) = _2 in
       let (returnType, _) = fixDeclSpecForDecl ds in
       (attrs1@attrs2, fn returnType) )
# 6088 "parsing_c/parser_c.ml"
               : Ast_c.attribute list * Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1554 "parsing_c/parser_c.mly"
                       ( _1 )
# 6095 "parsing_c/parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1564 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList ([{v_namei = None; v_type = returnType;
                   v_storage = unwrap storage; v_local = local;
                   v_attr = fst _1; v_endattr = _2;
                   v_type_bis = ref None;
                },[]],
                (_3::iistart::snd storage))
     )
# 6113 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'init_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1575 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList (
         (_2 +> List.map (fun ((((name,f),attrs,endattrs), ini), iivirg) ->
           let s = str_of_name name in
	   if fst (unwrap storage) = StoTypedef
	   then LP.add_typedef s;
           {v_namei = Some (name, ini);
            v_type = f returnType;
            v_storage = unwrap storage;
            v_local = local;
            v_attr = (fst _1)@attrs;
            v_endattr = endattrs;
            v_type_bis = ref None;
           },
           iivirg
         )
         ),  (_3::iistart::snd storage))
     )
# 6141 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1599 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDecl
	     ((sto, fst _2, _4, _6, true),
              (snd _2::_3::_5::_7::fakeInfo()::stoii))
       | None ->
	   MacroDecl
	     ((NoSto, fst _2, _4, _6, true),
              [snd _2;_3;_5;_7;fakeInfo()]) )
# 6163 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 7 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _8 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1612 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDeclInit
	     ((sto, fst _2, _4, _7),
	      (snd _2::_3::_5::_6::_8::fakeInfo()::stoii))
       | None ->
	   MacroDeclInit
	     ((NoSto, fst _2, _4, _7), [snd _2;_3;_5;_6;_8;fakeInfo()]) )
# 6185 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec_nt) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1623 "parsing_c/parser_c.mly"
                                         ( Some (fst _1,[snd _1; _2]) )
# 6193 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1624 "parsing_c/parser_c.mly"
                         ( Some (fst _1,[snd _1]) )
# 6200 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 1625 "parsing_c/parser_c.mly"
                         ( None )
# 6206 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1629 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with storageD = (fst _1, [snd _1]) }) )
# 6213 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1630 "parsing_c/parser_c.mly"
                      ( ([], addTypeD (_1,nullDecl)) )
# 6220 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1631 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with qualifD  = (fst _1, [snd _1]) }) )
# 6227 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1632 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with inlineD = (true, [_1]) }) )
# 6234 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1633 "parsing_c/parser_c.mly"
                      ( ([_1], nullDecl) )
# 6241 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1634 "parsing_c/parser_c.mly"
                                 ( (fst _2, addStorageD (_1, snd _2)) )
# 6249 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1635 "parsing_c/parser_c.mly"
                                 ( (fst _2, addTypeD    (_1, snd _2)) )
# 6257 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1636 "parsing_c/parser_c.mly"
                                 ( (fst _2, addQualifD  (_1, snd _2)) )
# 6265 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1637 "parsing_c/parser_c.mly"
                                 ( (fst _2, addInlineD ((true, _1), snd _2)) )
# 6273 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1638 "parsing_c/parser_c.mly"
                                 ( (_1::(fst _2), snd _2) )
# 6281 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1646 "parsing_c/parser_c.mly"
                ( Sto Static,  _1 )
# 6288 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1647 "parsing_c/parser_c.mly"
                ( Sto Extern,  _1 )
# 6295 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1649 "parsing_c/parser_c.mly"
     (
      let can_auto_storage =
        let open Flag in
        match !c_plus_plus with
          Off | On None -> true
        | On (Some i) -> i < 2011
      in
      if can_auto_storage
      then (Sto Auto, _1)
      else
        let i = Ast_c.parse_info_of_info _1 in
        raise
          (Semantic
            ("auto is not a valid storage since C++11, \
              try removing the version specification on the --c++ option \
              or removing the whole option",
             i))
     )
# 6319 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1667 "parsing_c/parser_c.mly"
                ( Sto Register,_1 )
# 6326 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1670 "parsing_c/parser_c.mly"
                         ( _1 )
# 6333 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1671 "parsing_c/parser_c.mly"
                ( StoTypedef,  _1 )
# 6340 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl2) in
    Obj.repr(
# 1678 "parsing_c/parser_c.mly"
                         ( et "decl" (); _1 )
# 6347 "parsing_c/parser_c.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1679 "parsing_c/parser_c.mly"
                         ( dt "declspec" (); _1  )
# 6354 "parsing_c/parser_c.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1685 "parsing_c/parser_c.mly"
                                ( (_1, NoInit) )
# 6361 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1686 "parsing_c/parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 6370 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1689 "parsing_c/parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 6380 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1699 "parsing_c/parser_c.mly"
                                ( (_1, NoInit) )
# 6387 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1700 "parsing_c/parser_c.mly"
                                ( (_2, NoInit) )
# 6395 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1701 "parsing_c/parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 6404 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1702 "parsing_c/parser_c.mly"
                                           ( (_2, ValInit(_3, _4)) )
# 6414 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1705 "parsing_c/parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 6424 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1707 "parsing_c/parser_c.mly"
     ( (_2, ConstrInit(_4,[_3;_5])) )
# 6435 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1712 "parsing_c/parser_c.mly"
          ( et "teq" (); _1 )
# 6442 "parsing_c/parser_c.ml"
               : 'teq))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator2) in
    Obj.repr(
# 1714 "parsing_c/parser_c.mly"
                                   ( dt "init" (); _1 )
# 6449 "parsing_c/parser_c.ml"
               : 'init_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator_attrs2) in
    Obj.repr(
# 1716 "parsing_c/parser_c.mly"
                                              ( dt "init_attrs" (); _1 )
# 6456 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1725 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 6464 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'gcc_asm_decl) in
    Obj.repr(
# 1729 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 6473 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1733 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, _2 (* TODO *) )
# 6482 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1738 "parsing_c/parser_c.mly"
                                         (  )
# 6492 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1739 "parsing_c/parser_c.mly"
                                        (  )
# 6503 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1745 "parsing_c/parser_c.mly"
     ( InitExpr _1,                [] )
# 6510 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1747 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),     [_1;_4] @ _3 )
# 6520 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1749 "parsing_c/parser_c.mly"
     ( InitList [],       [_1;_2] )
# 6528 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1760 "parsing_c/parser_c.mly"
                                      ( [_1,   []] )
# 6535 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1761 "parsing_c/parser_c.mly"
                                      ( (_3,  [_2])::_1 )
# 6544 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 1767 "parsing_c/parser_c.mly"
     ( InitExpr _1,   [] )
# 6551 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1769 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),   [_1;_4] @ _3 )
# 6561 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1771 "parsing_c/parser_c.mly"
     ( InitList [],  [_1;_2]  )
# 6569 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1775 "parsing_c/parser_c.mly"
     ( InitDesignators (_1, _3), [_2] )
# 6578 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1779 "parsing_c/parser_c.mly"
     ( InitFieldOld (fst _1, _3),     [snd _1; _2] )
# 6587 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1790 "parsing_c/parser_c.mly"
     ( DesignatorField (fst _2), [_1;snd _2] )
# 6595 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1792 "parsing_c/parser_c.mly"
     ( DesignatorIndex (_2),  [_1;_3] )
# 6604 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1794 "parsing_c/parser_c.mly"
     ( DesignatorRange (_2, _4),  [_1;_3;_5] )
# 6615 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1802 "parsing_c/parser_c.mly"
          (  [_1] )
# 6622 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    Obj.repr(
# 1803 "parsing_c/parser_c.mly"
                    (  [Ast_c.fakeInfo() +> Ast_c.rewrap_str ","]  )
# 6628 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1818 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, Some (fst _2), _4),  [snd _1;snd _2;_3;_5]  )
# 6639 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1820 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, None, _3), [snd _1;_2;_4] )
# 6649 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1822 "parsing_c/parser_c.mly"
     ( StructUnionName (fst _1, fst _2), [snd _1;snd _2] )
# 6657 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1825 "parsing_c/parser_c.mly"
             ( Struct, _1 )
# 6664 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1826 "parsing_c/parser_c.mly"
             ( Union, _1 )
# 6671 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1828 "parsing_c/parser_c.mly"
                        ( Struct, _1 (* TODO *) )
# 6679 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1829 "parsing_c/parser_c.mly"
                        ( Union, _1  (* TODO *) )
# 6687 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration) in
    Obj.repr(
# 1834 "parsing_c/parser_c.mly"
                     ( DeclarationField _1 )
# 6694 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1835 "parsing_c/parser_c.mly"
           ( EmptyField _1  )
# 6701 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1841 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6712 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1844 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6723 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1848 "parsing_c/parser_c.mly"
     ( CppDirectiveStruct _1 )
# 6730 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1850 "parsing_c/parser_c.mly"
     ( IfdefStruct _1 )
# 6737 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1855 "parsing_c/parser_c.mly"
     (
       let (attrs, ds) = _1 in
       let (returnType,storage) = fixDeclSpecForDecl ds in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing don't allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList (_2 +> (List.map (fun (f, iivirg) ->
         f returnType, iivirg))
                         ,[_4;iistart])
         (* don't need to check if typedef or func initialised cos
          * grammar don't allow typedef nor initialiser in struct
          *)
     )
# 6760 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1871 "parsing_c/parser_c.mly"
     (
       let (attrs, ds) = _1 in
       (* gccext: allow empty elements if it is a structdef or enumdef *)
       let (returnType,storage) = fixDeclSpecForDecl ds in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing don't allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList ([(Simple (None, returnType)) , []], [_3;iistart])
     )
# 6778 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorsd) in
    Obj.repr(
# 1888 "parsing_c/parser_c.mly"
     ( (fun x -> Simple   (Some (fst _1), (snd _1) x)) )
# 6785 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1890 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (None, x, _1, _2)) )
# 6793 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratorsd) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1892 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (Some (fst _1), ((snd _1) x), _2, _3)) )
# 6802 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1900 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in (* attr ignored *)
       (*also ? LP.add_ident (fst (fst dec)); *) dec )
# 6810 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1903 "parsing_c/parser_c.mly"
                           ( let (attr,dec) = _1 in dec )
# 6818 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 's_or_u_spec2) in
    Obj.repr(
# 1908 "parsing_c/parser_c.mly"
                                   ( dt "su" (); _1 )
# 6825 "parsing_c/parser_c.ml"
               : 'struct_or_union_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union2) in
    Obj.repr(
# 1909 "parsing_c/parser_c.mly"
                                  ( et "su" (); _1 )
# 6832 "parsing_c/parser_c.ml"
               : 'struct_or_union))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl2) in
    Obj.repr(
# 1910 "parsing_c/parser_c.mly"
                           ( et "struct" (); _1 )
# 6839 "parsing_c/parser_c.ml"
               : 'struct_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1912 "parsing_c/parser_c.mly"
                 ( et "dotdot" (); _1 )
# 6846 "parsing_c/parser_c.ml"
               : 'dotdot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1913 "parsing_c/parser_c.mly"
                        ( dt "const_expr2" (); _1 )
# 6853 "parsing_c/parser_c.ml"
               : 'const_expr2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl_list) in
    Obj.repr(
# 1916 "parsing_c/parser_c.mly"
                     ( _1 )
# 6860 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    Obj.repr(
# 1917 "parsing_c/parser_c.mly"
                         ( [] )
# 6866 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1925 "parsing_c/parser_c.mly"
     ( Enum (None,    _3),           [_1;_2;_5] @ _4 )
# 6877 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1927 "parsing_c/parser_c.mly"
     ( Enum (Some (fst _2), _4),     [_1; snd _2; _3;_6] @ _5 )
# 6889 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1929 "parsing_c/parser_c.mly"
     ( EnumName (fst _2),       [_1; snd _2] )
# 6897 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'idente) in
    Obj.repr(
# 1932 "parsing_c/parser_c.mly"
                          ( _1, None     )
# 6904 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'idente) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1933 "parsing_c/parser_c.mly"
                          ( _1, Some (_2, _3) )
# 6913 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1940 "parsing_c/parser_c.mly"
                  ( LP.add_ident (str_of_name _1); _1 )
# 6920 "parsing_c/parser_c.ml"
               : 'idente))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_def) in
    Obj.repr(
# 1947 "parsing_c/parser_c.mly"
                                     ( fixFunc _1 )
# 6927 "parsing_c/parser_c.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1950 "parsing_c/parser_c.mly"
                  ( [_1 Ast_c.LocalDecl]   )
# 6934 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1951 "parsing_c/parser_c.mly"
                  ( _1 @ [_2 Ast_c.LocalDecl] )
# 6942 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1955 "parsing_c/parser_c.mly"
                                    ( )
# 6949 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1956 "parsing_c/parser_c.mly"
                                    ( )
# 6957 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1959 "parsing_c/parser_c.mly"
                           ( LP.del_scope(); (_1, _2, None) )
# 6965 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1960 "parsing_c/parser_c.mly"
                                         ( LP.del_scope(); (_1, _3, None) )
# 6974 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1961 "parsing_c/parser_c.mly"
                                     (
     (* TODO: undo the typedef added ? *)
     LP.del_scope();
     (_1, _3, Some _2)
   )
# 6987 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'start_fun2) in
    Obj.repr(
# 1968 "parsing_c/parser_c.mly"
  ( LP.new_scope();
    fix_add_params_ident _1;
    (* toreput? !LP._lexer_hint.toplevel <- false;  *)
    _1
  )
# 6998 "parsing_c/parser_c.ml"
               : 'start_fun))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorfd) in
    Obj.repr(
# 1975 "parsing_c/parser_c.mly"
     ( let (returnType,storage) = fixDeclSpecForFuncDef (snd _1) in
       let (id, attrs) = _2 in
       (fst id, fixOldCDecl ((snd id) returnType) , storage, (fst _1)@attrs)
     )
# 7009 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_dtor) in
    Obj.repr(
# 1979 "parsing_c/parser_c.mly"
               ( _1 )
# 7016 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1982 "parsing_c/parser_c.mly"
                                (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, (([], (false, []))))) [_2;_3] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 7031 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1989 "parsing_c/parser_c.mly"
                                                    (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, _3)) [_2;_4] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 7047 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 2011 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 7054 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 2014 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 7062 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : (Ast_c.info * bool ref)) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2023 "parsing_c/parser_c.mly"
     (
       let (i1, in_ifdef) = _1 in
       let (s, i2) = _2 in

       (* redo some lexing work :( *)
       let inc_file =
         match () with
         | _ when s =~ "^\"\\(.*\\)\"$" ->
             Local (Common.split "/" (matched1 s))
         | _ when s =~ "^\\<\\(.*\\)\\>$" ->
             NonLocal (Common.split "/" (matched1 s))
         | _ ->
             Weird s
       in
       Include { i_include = (inc_file, [i1;i2]);
                 i_rel_pos = Ast_c.noRelPos();
                 i_overall_rel_pos = Ast_c.noRelPos();
                 i_is_in_ifdef = !in_ifdef;
                 i_content = Ast_c.noi_content;
       }
     )
# 7090 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2046 "parsing_c/parser_c.mly"
     ( Define ((fst _2, [_1; snd _2;_4]), (DefineVar, _3)) )
# 7100 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'param_define_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2053 "parsing_c/parser_c.mly"
     ( Define
         ((fst _2, [_1; snd _2; _7]),
           (DefineFunc (_4, [_3;_5]), _6))
     )
# 7116 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2059 "parsing_c/parser_c.mly"
     ( Define((fst _2, [_1; snd _2; _3]), (Undef,DefineEmpty)) )
# 7125 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pragma_strings) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2062 "parsing_c/parser_c.mly"
     ( Pragma((RegularName (mk_string_wrap _2),_3),[_1;_4]) )
# 7135 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2064 "parsing_c/parser_c.mly"
                      ( OtherDirective ([_1]) )
# 7142 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2067 "parsing_c/parser_c.mly"
                 ( [(fst _1, [snd _1])] )
# 7149 "parsing_c/parser_c.ml"
               : 'pragma_strings))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pragma_strings) in
    Obj.repr(
# 2068 "parsing_c/parser_c.mly"
                                ( (fst _1, [snd _1])::_2 )
# 7157 "parsing_c/parser_c.ml"
               : 'pragma_strings))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2074 "parsing_c/parser_c.mly"
             ( DefineExpr _1 )
# 7164 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 2075 "parsing_c/parser_c.mly"
             ( DefineStmt _1 )
# 7171 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2076 "parsing_c/parser_c.mly"
             ( DefineStmt (mk_st (Decl (_1 Ast_c.NotLocalDecl)) Ast_c.noii) )
# 7178 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 2086 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       DefineType returnType
     )
# 7187 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 2090 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       let typ = (snd _2) returnType in
       DefineType typ
     )
# 7198 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 2102 "parsing_c/parser_c.mly"
     ( DefineMulti
	 (List.map
	    (function
		StmtElem e -> e
	      | _ -> failwith "unexpected statement for DefineMulti")
	    (_1 :: _2)) )
# 7211 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2116 "parsing_c/parser_c.mly"
                       ( DefineFunction _1 )
# 7218 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'comma_opt) in
    Obj.repr(
# 2119 "parsing_c/parser_c.mly"
    ( DefineInit (InitList (List.rev _2), [_1;_4] @ _3 @ _5)  )
# 7229 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2123 "parsing_c/parser_c.mly"
     (
       (* TOREPUT
       if fst $5 <> "0"
       then pr2 "WEIRD: in macro and have not a while(0)";
       *)
       DefineDoWhileZero ((_2,_5),   [_1;_3;_4;_6])
     )
# 7247 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2131 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 7257 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2132 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 7268 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    Obj.repr(
# 2136 "parsing_c/parser_c.mly"
                   ( DefineEmpty )
# 7274 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2142 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 7281 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2143 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 7288 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2144 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 7295 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2145 "parsing_c/parser_c.mly"
                        ( "...", [_1] )
# 7302 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2147 "parsing_c/parser_c.mly"
                        ( "register", [_1] )
# 7309 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdef) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement_tail) in
    Obj.repr(
# 2154 "parsing_c/parser_c.mly"
     ( IfdefStmt1 ((_1::fst _3), (_2::snd _3)), [] )
# 7318 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 2155 "parsing_c/parser_c.mly"
             (_1)
# 7325 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdefelse) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'endif) in
    Obj.repr(
# 2158 "parsing_c/parser_c.mly"
                                       ( [_1;_3], [_2] )
# 7334 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement_tail))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdefelif) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement_tail) in
    Obj.repr(
# 2160 "parsing_c/parser_c.mly"
   ( (_1::fst _3), (_2::snd _3) )
# 7343 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement_tail))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2164 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((Ifdef cond, IfdefTag (Common.some !tag)),  [ii]) )
# 7351 "parsing_c/parser_c.ml"
               : 'ifdef))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2169 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElse, IfdefTag (Common.some !tag)), [ii]) )
# 7359 "parsing_c/parser_c.ml"
               : 'ifdefelse))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2174 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((IfdefElseif cond, IfdefTag (Common.some !tag)), [ii]) )
# 7367 "parsing_c/parser_c.ml"
               : 'ifdefelif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2179 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefEndif, IfdefTag (Common.some !tag)), [ii]) )
# 7375 "parsing_c/parser_c.ml"
               : 'endif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdef) in
    Obj.repr(
# 2183 "parsing_c/parser_c.mly"
         ( _1 )
# 7382 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdefelse) in
    Obj.repr(
# 2184 "parsing_c/parser_c.mly"
             ( _1 )
# 7389 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdefelif) in
    Obj.repr(
# 2185 "parsing_c/parser_c.mly"
             ( _1 )
# 7396 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'endif) in
    Obj.repr(
# 2186 "parsing_c/parser_c.mly"
         ( _1 )
# 7403 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2189 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7411 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2192 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7419 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2195 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7427 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2206 "parsing_c/parser_c.mly"
     (
       if args_are_params _3
       then
	 (* if all args are params, assume it is a prototype of a function
	    with no return type *)
	 let parameters = args_to_params _3 None in
	 let paramlist = (parameters, (false, [])) in (* no varargs *)
	 let id = RegularName (mk_string_wrap _1) in
	 let ret =
	   warning "type defaults to 'int'"
	     (mk_ty defaultInt [fakeInfo fake_pi]) in
	 let ty =
	   fixOldCDecl (mk_ty (FunctionType (ret, paramlist)) [_2;_4]) in
	 let attrs = Ast_c.noattr in
	 let sto = (NoSto, false), [] in
	 let iistart = Ast_c.fakeInfo () in
	 Declaration(
	 DeclList ([{v_namei = Some (id,NoInit); v_type = ty;
                      v_storage = unwrap sto; v_local = NotLocalDecl;
                      v_attr = attrs; v_endattr = _5;
		      v_type_bis = ref None;
                    },[]],
                   (_6::iistart::snd sto)))
       else
	 Declaration
	   (MacroDecl
             ((NoSto, fst _1, _3, _5, true),
              [snd _1;_2;_4;_6;fakeInfo()]))
           (* old: MacroTop (fst $1, $3,    [snd $1;$2;$4;$5])  *)
     )
# 7468 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2240 "parsing_c/parser_c.mly"
                                                 (
   let parameters = args_to_params _3 (Some (snd _1)) in
   let paramlist = (parameters, (false, [])) in (* no varargs *)
   let fninfo =
     let id = RegularName (mk_string_wrap _1) in
     let ret =
       warning "type defaults to 'int'"
	 (mk_ty defaultInt [fakeInfo fake_pi]) in
     let ty = mk_ty (FunctionType (ret, paramlist)) [_2;_4] in
     let attrs = Ast_c.noattr in
     let sto = (NoSto, false), [] in
     (id, fixOldCDecl ty, sto, attrs) in
   let fundef = fixFunc (fninfo, _5, None) in
   Definition fundef
 )
# 7493 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2258 "parsing_c/parser_c.mly"
     ( Declaration
	 (MacroDecl
           ((NoSto, fst _1, _3, Ast_c.noattr, false),
            [snd _1;_2;_4;fakeInfo()])) )
# 7506 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2264 "parsing_c/parser_c.mly"
                      ( EmptyDef [snd _1;_2] )
# 7514 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2273 "parsing_c/parser_c.mly"
                                     ( Definition _1 )
# 7521 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2274 "parsing_c/parser_c.mly"
                                     ( Declaration (_1 Ast_c.NotLocalDecl) )
# 7528 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2279 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       Namespace (_4, [_1; snd _2; _3; _5]) )
# 7540 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 2282 "parsing_c/parser_c.mly"
                                                ( _1 )
# 7547 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 2286 "parsing_c/parser_c.mly"
     ( CppTop _1 )
# 7554 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_other) in
    Obj.repr(
# 2288 "parsing_c/parser_c.mly"
     ( _1 )
# 7561 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 2290 "parsing_c/parser_c.mly"
     ( IfdefTop _1 )
# 7568 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2293 "parsing_c/parser_c.mly"
                                                ( EmptyDef [_1;_2;_4;_5] )
# 7579 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2300 "parsing_c/parser_c.mly"
              ( EmptyDef [_1] )
# 7586 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2303 "parsing_c/parser_c.mly"
              ( FinalDef _1 )
# 7593 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2312 "parsing_c/parser_c.mly"
                  ( LP.push_context LP.InFunction; LP.new_scope (); _1 )
# 7600 "parsing_c/parser_c.ml"
               : 'tobrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2313 "parsing_c/parser_c.mly"
                  ( LP.pop_context();              LP.del_scope (); _1 )
# 7607 "parsing_c/parser_c.ml"
               : 'tcbrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2315 "parsing_c/parser_c.mly"
                      ( LP.push_context LP.InEnum; _1 )
# 7614 "parsing_c/parser_c.ml"
               : 'tobrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2316 "parsing_c/parser_c.mly"
                      ( LP.pop_context (); _1 )
# 7621 "parsing_c/parser_c.ml"
               : 'tcbrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2318 "parsing_c/parser_c.mly"
                     ( LP.push_context LP.InInitializer; _1 )
# 7628 "parsing_c/parser_c.ml"
               : 'tobrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2319 "parsing_c/parser_c.mly"
                     ( LP.pop_context (); _1 )
# 7635 "parsing_c/parser_c.ml"
               : 'tcbrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2321 "parsing_c/parser_c.mly"
                        ( LP.push_context LP.InStruct; _1)
# 7642 "parsing_c/parser_c.ml"
               : 'tobrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2322 "parsing_c/parser_c.mly"
                        ( LP.pop_context (); _1 )
# 7649 "parsing_c/parser_c.ml"
               : 'tcbrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2328 "parsing_c/parser_c.mly"
     ( LP.new_scope ();et "topar" ();
       LP.push_context LP.InParameter;
       _1
     )
# 7659 "parsing_c/parser_c.ml"
               : 'topar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2333 "parsing_c/parser_c.mly"
     ( LP.del_scope ();dt "tcpar" ();
       LP.pop_context ();
       _1
     )
# 7669 "parsing_c/parser_c.ml"
               : 'tcpar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2372 "parsing_c/parser_c.mly"
               ( _1 )
# 7676 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2373 "parsing_c/parser_c.mly"
                           ( _1 @ _2 )
# 7684 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2376 "parsing_c/parser_c.mly"
             ( [_1] )
# 7691 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'colon_asm_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2377 "parsing_c/parser_c.mly"
                             ( _1 @ [_2] )
# 7699 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2380 "parsing_c/parser_c.mly"
                ( [_1, []] )
# 7706 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'colon_option_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2381 "parsing_c/parser_c.mly"
                                         ( _1 @ [_3, [_2]] )
# 7715 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument_ne) in
    Obj.repr(
# 2385 "parsing_c/parser_c.mly"
                                         ( [_1, []] )
# 7722 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2386 "parsing_c/parser_c.mly"
                                    ( _1 @ [_3,    [_2]] )
# 7731 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2389 "parsing_c/parser_c.mly"
                                      ( [_1, []] )
# 7738 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2390 "parsing_c/parser_c.mly"
                                 ( _1 @ [_3,    [_2]] )
# 7747 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2400 "parsing_c/parser_c.mly"
                                 ( [_1] )
# 7754 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2401 "parsing_c/parser_c.mly"
                                 ( _1 @ [_2] )
# 7762 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2405 "parsing_c/parser_c.mly"
                                                   ( [_1,           []] )
# 7769 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2407 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7779 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2408 "parsing_c/parser_c.mly"
                                                   ( _1 @ [_3,     [_2]] )
# 7788 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2412 "parsing_c/parser_c.mly"
                                     ( [_1,          []]   )
# 7795 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2414 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7805 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2415 "parsing_c/parser_c.mly"
                                     ( _1 @ [_3,    [_2]] )
# 7814 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2419 "parsing_c/parser_c.mly"
                                               ( [_1,   []] )
# 7821 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator_attrs) in
    Obj.repr(
# 2421 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7831 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator_attrs) in
    Obj.repr(
# 2422 "parsing_c/parser_c.mly"
                                                     ( _1 @ [_3, [_2]] )
# 7840 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2426 "parsing_c/parser_c.mly"
                                        ( [_1, []] )
# 7847 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2427 "parsing_c/parser_c.mly"
                                        ( _1 @ [_3,  [_2]] )
# 7856 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2430 "parsing_c/parser_c.mly"
                           ( [_1] )
# 7863 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 2431 "parsing_c/parser_c.mly"
                           ( _1 :: _2 )
# 7871 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    Obj.repr(
# 2439 "parsing_c/parser_c.mly"
                        ( [] )
# 7877 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 2440 "parsing_c/parser_c.mly"
                        ( _1 :: _2 )
# 7885 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 2443 "parsing_c/parser_c.mly"
                   ( [] )
# 7891 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2444 "parsing_c/parser_c.mly"
                                          ( [_1, []] )
# 7898 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'param_define_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2445 "parsing_c/parser_c.mly"
                                          ( _1 @ [_3, [_2]] )
# 7907 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2448 "parsing_c/parser_c.mly"
              ( [_1] )
# 7914 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2449 "parsing_c/parser_c.mly"
                              ( _1 @ [_2] )
# 7922 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2452 "parsing_c/parser_c.mly"
             ( [_1] )
# 7929 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2453 "parsing_c/parser_c.mly"
                            ( _1 @ [_2] )
# 7937 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_list) in
    Obj.repr(
# 2455 "parsing_c/parser_c.mly"
                           ( _1 )
# 7944 "parsing_c/parser_c.ml"
               : 'attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2458 "parsing_c/parser_c.mly"
                 ( [Attribute (fst _1), [snd _1]] )
# 7951 "parsing_c/parser_c.ml"
               : 'end_attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'end_attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2459 "parsing_c/parser_c.mly"
                                    ( _1 @ [Attribute(fst _2), [snd _2]] )
# 7959 "parsing_c/parser_c.ml"
               : 'end_attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_attribute_list) in
    Obj.repr(
# 2461 "parsing_c/parser_c.mly"
                                   ( _1 )
# 7966 "parsing_c/parser_c.ml"
               : 'end_attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 2464 "parsing_c/parser_c.mly"
                  ( _1 )
# 7973 "parsing_c/parser_c.ml"
               : 'end_attributes_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2465 "parsing_c/parser_c.mly"
                   ( [] )
# 7979 "parsing_c/parser_c.ml"
               : 'end_attributes_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2468 "parsing_c/parser_c.mly"
          (  [_1] )
# 7986 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2469 "parsing_c/parser_c.mly"
                    (  []  )
# 7992 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2478 "parsing_c/parser_c.mly"
               ( Some _1 )
# 7999 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 2479 "parsing_c/parser_c.mly"
                   ( None  )
# 8005 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry celem *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry statement *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry expr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry type_name *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast_c.program)
let celem (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Ast_c.toplevel)
let statement (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Ast_c.statement)
let expr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 4 lexfun lexbuf : Ast_c.expression)
let type_name (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 5 lexfun lexbuf : Ast_c.attribute list * Ast_c.fullType)
